/* builder.c generated by valac, the Vala compiler
 * generated from builder.vala, do not modify */

/* builder.vala
 *
 * Copyright (C) 2008-2009  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <nicolas.joseph@valaide.org>
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>


#define VALIDE_TYPE_BUILDING_STEP (valide_building_step_get_type ())

#define VALIDE_TYPE_BUILDER (valide_builder_get_type ())
#define VALIDE_BUILDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_BUILDER, ValideBuilder))
#define VALIDE_IS_BUILDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_BUILDER))
#define VALIDE_BUILDER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), VALIDE_TYPE_BUILDER, ValideBuilderIface))

typedef struct _ValideBuilder ValideBuilder;
typedef struct _ValideBuilderIface ValideBuilderIface;

#define VALIDE_TYPE_PROJECT (valide_project_get_type ())
#define VALIDE_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PROJECT, ValideProject))
#define VALIDE_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_PROJECT, ValideProjectClass))
#define VALIDE_IS_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PROJECT))
#define VALIDE_IS_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_PROJECT))
#define VALIDE_PROJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_PROJECT, ValideProjectClass))

typedef struct _ValideProject ValideProject;
typedef struct _ValideProjectClass ValideProjectClass;

#define VALIDE_TYPE_EXECUTABLE_MANAGER (valide_executable_manager_get_type ())
#define VALIDE_EXECUTABLE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_EXECUTABLE_MANAGER, ValideExecutableManager))
#define VALIDE_EXECUTABLE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_EXECUTABLE_MANAGER, ValideExecutableManagerClass))
#define VALIDE_IS_EXECUTABLE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_EXECUTABLE_MANAGER))
#define VALIDE_IS_EXECUTABLE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_EXECUTABLE_MANAGER))
#define VALIDE_EXECUTABLE_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_EXECUTABLE_MANAGER, ValideExecutableManagerClass))

typedef struct _ValideExecutableManager ValideExecutableManager;
typedef struct _ValideExecutableManagerClass ValideExecutableManagerClass;

#define VALIDE_TYPE_BUILDER_OPTIONS (valide_builder_options_get_type ())
#define VALIDE_BUILDER_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_BUILDER_OPTIONS, ValideBuilderOptions))
#define VALIDE_IS_BUILDER_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_BUILDER_OPTIONS))
#define VALIDE_BUILDER_OPTIONS_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), VALIDE_TYPE_BUILDER_OPTIONS, ValideBuilderOptionsIface))

typedef struct _ValideBuilderOptions ValideBuilderOptions;
typedef struct _ValideBuilderOptionsIface ValideBuilderOptionsIface;

typedef enum  {
	VALIDE_BUILDING_STEP_CONFIGURE,
	VALIDE_BUILDING_STEP_BUILD,
	VALIDE_BUILDING_STEP_INSTALL,
	VALIDE_BUILDING_STEP_DIST,
	VALIDE_BUILDING_STEP_CLEAN,
	VALIDE_BUILDING_STEP_DISTCLEAN,
	VALIDE_BUILDING_STEP_UNINSTALL
} ValideBuildingStep;

struct _ValideBuilderIface {
	GTypeInterface parent_iface;
	void (*configure) (ValideBuilder* self);
	void (*build) (ValideBuilder* self);
	void (*install) (ValideBuilder* self);
	void (*dist) (ValideBuilder* self);
	void (*clean) (ValideBuilder* self);
	void (*distclean) (ValideBuilder* self);
	void (*uninstall) (ValideBuilder* self);
	GtkWidget* (*preferences) (ValideBuilder* self);
	ValideProject* (*get_project) (ValideBuilder* self);
	void (*set_project) (ValideBuilder* self, ValideProject* value);
	ValideExecutableManager* (*get_executables) (ValideBuilder* self);
	void (*set_executables) (ValideBuilder* self, ValideExecutableManager* value);
};

struct _ValideBuilderOptionsIface {
	GTypeInterface parent_iface;
};



GType valide_building_step_get_type (void);
GType valide_project_get_type (void);
GType valide_executable_manager_get_type (void);
GType valide_builder_get_type (void);
void valide_builder_configure (ValideBuilder* self);
void valide_builder_build (ValideBuilder* self);
void valide_builder_install (ValideBuilder* self);
void valide_builder_dist (ValideBuilder* self);
void valide_builder_clean (ValideBuilder* self);
void valide_builder_distclean (ValideBuilder* self);
void valide_builder_uninstall (ValideBuilder* self);
GtkWidget* valide_builder_preferences (ValideBuilder* self);
ValideProject* valide_builder_get_project (ValideBuilder* self);
void valide_builder_set_project (ValideBuilder* self, ValideProject* value);
ValideExecutableManager* valide_builder_get_executables (ValideBuilder* self);
void valide_builder_set_executables (ValideBuilder* self, ValideExecutableManager* value);
GType valide_builder_options_get_type (void);




GType valide_building_step_get_type (void) {
	static GType valide_building_step_type_id = 0;
	if (G_UNLIKELY (valide_building_step_type_id == 0)) {
		static const GEnumValue values[] = {{VALIDE_BUILDING_STEP_CONFIGURE, "VALIDE_BUILDING_STEP_CONFIGURE", "configure"}, {VALIDE_BUILDING_STEP_BUILD, "VALIDE_BUILDING_STEP_BUILD", "build"}, {VALIDE_BUILDING_STEP_INSTALL, "VALIDE_BUILDING_STEP_INSTALL", "install"}, {VALIDE_BUILDING_STEP_DIST, "VALIDE_BUILDING_STEP_DIST", "dist"}, {VALIDE_BUILDING_STEP_CLEAN, "VALIDE_BUILDING_STEP_CLEAN", "clean"}, {VALIDE_BUILDING_STEP_DISTCLEAN, "VALIDE_BUILDING_STEP_DISTCLEAN", "distclean"}, {VALIDE_BUILDING_STEP_UNINSTALL, "VALIDE_BUILDING_STEP_UNINSTALL", "uninstall"}, {0, NULL, NULL}};
		valide_building_step_type_id = g_enum_register_static ("ValideBuildingStep", values);
	}
	return valide_building_step_type_id;
}


#line 48 "builder.vala"
void valide_builder_configure (ValideBuilder* self) {
#line 48 "builder.vala"
	VALIDE_BUILDER_GET_INTERFACE (self)->configure (self);
#line 136 "builder.c"
}


#line 49 "builder.vala"
void valide_builder_build (ValideBuilder* self) {
#line 49 "builder.vala"
	VALIDE_BUILDER_GET_INTERFACE (self)->build (self);
#line 144 "builder.c"
}


#line 50 "builder.vala"
void valide_builder_install (ValideBuilder* self) {
#line 50 "builder.vala"
	VALIDE_BUILDER_GET_INTERFACE (self)->install (self);
#line 152 "builder.c"
}


#line 51 "builder.vala"
void valide_builder_dist (ValideBuilder* self) {
#line 51 "builder.vala"
	VALIDE_BUILDER_GET_INTERFACE (self)->dist (self);
#line 160 "builder.c"
}


#line 52 "builder.vala"
void valide_builder_clean (ValideBuilder* self) {
#line 52 "builder.vala"
	VALIDE_BUILDER_GET_INTERFACE (self)->clean (self);
#line 168 "builder.c"
}


#line 53 "builder.vala"
void valide_builder_distclean (ValideBuilder* self) {
#line 53 "builder.vala"
	VALIDE_BUILDER_GET_INTERFACE (self)->distclean (self);
#line 176 "builder.c"
}


#line 54 "builder.vala"
void valide_builder_uninstall (ValideBuilder* self) {
#line 54 "builder.vala"
	VALIDE_BUILDER_GET_INTERFACE (self)->uninstall (self);
#line 184 "builder.c"
}


#line 55 "builder.vala"
GtkWidget* valide_builder_preferences (ValideBuilder* self) {
#line 55 "builder.vala"
	return VALIDE_BUILDER_GET_INTERFACE (self)->preferences (self);
#line 192 "builder.c"
}


ValideProject* valide_builder_get_project (ValideBuilder* self) {
	return VALIDE_BUILDER_GET_INTERFACE (self)->get_project (self);
}


void valide_builder_set_project (ValideBuilder* self, ValideProject* value) {
	VALIDE_BUILDER_GET_INTERFACE (self)->set_project (self, value);
}


ValideExecutableManager* valide_builder_get_executables (ValideBuilder* self) {
	return VALIDE_BUILDER_GET_INTERFACE (self)->get_executables (self);
}


void valide_builder_set_executables (ValideBuilder* self, ValideExecutableManager* value) {
	VALIDE_BUILDER_GET_INTERFACE (self)->set_executables (self, value);
}


static void valide_builder_base_init (ValideBuilderIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
		g_object_interface_install_property (iface, g_param_spec_object ("project", "project", "project", VALIDE_TYPE_PROJECT, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
		g_object_interface_install_property (iface, g_param_spec_object ("executables", "executables", "executables", VALIDE_TYPE_EXECUTABLE_MANAGER, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	}
}


GType valide_builder_get_type (void) {
	static GType valide_builder_type_id = 0;
	if (valide_builder_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValideBuilderIface), (GBaseInitFunc) valide_builder_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		valide_builder_type_id = g_type_register_static (G_TYPE_INTERFACE, "ValideBuilder", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (valide_builder_type_id, G_TYPE_OBJECT);
	}
	return valide_builder_type_id;
}


static void valide_builder_options_base_init (ValideBuilderOptionsIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


GType valide_builder_options_get_type (void) {
	static GType valide_builder_options_type_id = 0;
	if (valide_builder_options_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValideBuilderOptionsIface), (GBaseInitFunc) valide_builder_options_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		valide_builder_options_type_id = g_type_register_static (G_TYPE_INTERFACE, "ValideBuilderOptions", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (valide_builder_options_type_id, G_TYPE_OBJECT);
	}
	return valide_builder_options_type_id;
}




