/* document-message.c generated by valac, the Vala compiler
 * generated from document-message.vala, do not modify */

/* document-message.vala
 *
 * Copyright (C) 2008-2009  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <nicolas.joseph@valaide.org>
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <glib/gi18n-lib.h>


#define VALIDE_TYPE_DOCUMENT_MESSAGE (valide_document_message_get_type ())
#define VALIDE_DOCUMENT_MESSAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_DOCUMENT_MESSAGE, ValideDocumentMessage))
#define VALIDE_DOCUMENT_MESSAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_DOCUMENT_MESSAGE, ValideDocumentMessageClass))
#define VALIDE_IS_DOCUMENT_MESSAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_DOCUMENT_MESSAGE))
#define VALIDE_IS_DOCUMENT_MESSAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_DOCUMENT_MESSAGE))
#define VALIDE_DOCUMENT_MESSAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_DOCUMENT_MESSAGE, ValideDocumentMessageClass))

typedef struct _ValideDocumentMessage ValideDocumentMessage;
typedef struct _ValideDocumentMessageClass ValideDocumentMessageClass;
typedef struct _ValideDocumentMessagePrivate ValideDocumentMessagePrivate;

#define VALIDE_TYPE_ABSTRACT_TEXT_DOCUMENT (valide_abstract_text_document_get_type ())
#define VALIDE_ABSTRACT_TEXT_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_ABSTRACT_TEXT_DOCUMENT, ValideAbstractTextDocument))
#define VALIDE_ABSTRACT_TEXT_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_ABSTRACT_TEXT_DOCUMENT, ValideAbstractTextDocumentClass))
#define VALIDE_IS_ABSTRACT_TEXT_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_ABSTRACT_TEXT_DOCUMENT))
#define VALIDE_IS_ABSTRACT_TEXT_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_ABSTRACT_TEXT_DOCUMENT))
#define VALIDE_ABSTRACT_TEXT_DOCUMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_ABSTRACT_TEXT_DOCUMENT, ValideAbstractTextDocumentClass))

typedef struct _ValideAbstractTextDocument ValideAbstractTextDocument;
typedef struct _ValideAbstractTextDocumentClass ValideAbstractTextDocumentClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define VALIDE_TYPE_DOCUMENT_STATE (valide_document_state_get_type ())

#define VALIDE_TYPE_IDOCUMENT (valide_idocument_get_type ())
#define VALIDE_IDOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_IDOCUMENT, ValideiDocument))
#define VALIDE_IS_IDOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_IDOCUMENT))
#define VALIDE_IDOCUMENT_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), VALIDE_TYPE_IDOCUMENT, ValideiDocumentIface))

typedef struct _ValideiDocument ValideiDocument;
typedef struct _ValideiDocumentIface ValideiDocumentIface;

#define VALIDE_TYPE_UI_MANAGER (valide_ui_manager_get_type ())
#define VALIDE_UI_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_UI_MANAGER, ValideUIManager))
#define VALIDE_UI_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_UI_MANAGER, ValideUIManagerClass))
#define VALIDE_IS_UI_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_UI_MANAGER))
#define VALIDE_IS_UI_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_UI_MANAGER))
#define VALIDE_UI_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_UI_MANAGER, ValideUIManagerClass))

typedef struct _ValideUIManager ValideUIManager;
typedef struct _ValideUIManagerClass ValideUIManagerClass;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _ValideDocumentMessage {
	GtkHBox parent_instance;
	ValideDocumentMessagePrivate * priv;
};

struct _ValideDocumentMessageClass {
	GtkHBoxClass parent_class;
};

struct _ValideDocumentMessagePrivate {
	GtkLabel* primary_label;
	GtkLabel* secondary_label;
	ValideAbstractTextDocument* _document;
};

typedef enum  {
	VALIDE_DOCUMENT_STATE_NORMAL,
	VALIDE_DOCUMENT_STATE_EXTERNALLY_MODIFIED,
	VALIDE_DOCUMENT_STATE_BAD_ENCODING,
	VALIDE_DOCUMENT_STATE_INFO
} ValideDocumentState;

struct _ValideiDocumentIface {
	GTypeInterface parent_iface;
	void (*open) (ValideiDocument* self, const char* path, GError** error);
	void (*save) (ValideiDocument* self, const char* current_folder);
	void (*save_as) (ValideiDocument* self, const char* current_folder);
	void (*rename) (ValideiDocument* self);
	gboolean (*close) (ValideiDocument* self);
	GdkPixbuf* (*get_icon) (ValideiDocument* self);
	char* (*get_tooltips) (ValideiDocument* self);
	void (*setup_ui) (ValideiDocument* self, ValideUIManager* ui_manager);
	ValideDocumentState (*get_state) (ValideiDocument* self);
	void (*set_state) (ValideiDocument* self, ValideDocumentState value);
	gboolean (*get_is_save) (ValideiDocument* self);
	void (*set_is_save) (ValideiDocument* self, gboolean value);
	const char* (*get_path) (ValideiDocument* self);
	void (*set_path) (ValideiDocument* self, const char* value);
	const char* (*get_title) (ValideiDocument* self);
	const char* (*get_filename) (ValideiDocument* self);
};


static gpointer valide_document_message_parent_class = NULL;

GType valide_document_message_get_type (void);
GType valide_abstract_text_document_get_type (void);
#define VALIDE_DOCUMENT_MESSAGE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALIDE_TYPE_DOCUMENT_MESSAGE, ValideDocumentMessagePrivate))
enum  {
	VALIDE_DOCUMENT_MESSAGE_DUMMY_PROPERTY,
	VALIDE_DOCUMENT_MESSAGE_DOCUMENT
};
ValideDocumentMessage* valide_document_message_new (ValideAbstractTextDocument* document);
ValideDocumentMessage* valide_document_message_construct (GType object_type, ValideAbstractTextDocument* document);
ValideAbstractTextDocument* valide_document_message_get_document (ValideDocumentMessage* self);
static void valide_document_message_set_document (ValideDocumentMessage* self, ValideAbstractTextDocument* value);
void valide_abstract_text_document_reload (ValideAbstractTextDocument* self);
GType valide_document_state_get_type (void);
GType valide_ui_manager_get_type (void);
GType valide_idocument_get_type (void);
void valide_idocument_set_state (ValideiDocument* self, ValideDocumentState value);
static void _lambda29_ (ValideDocumentMessage* self);
static void __lambda29__gtk_button_clicked (GtkButton* _sender, gpointer self);
void valide_idocument_set_is_save (ValideiDocument* self, gboolean value);
static void _lambda30_ (ValideDocumentMessage* self);
static void __lambda30__gtk_button_clicked (GtkButton* _sender, gpointer self);
ValideDocumentState valide_idocument_get_state (ValideiDocument* self);
const char* valide_idocument_get_path (ValideiDocument* self);
gboolean valide_idocument_get_is_save (ValideiDocument* self);
static GObject * valide_document_message_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void valide_document_message_finalize (GObject* obj);
static void valide_document_message_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void valide_document_message_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);



#line 44 "document-message.vala"
ValideDocumentMessage* valide_document_message_construct (GType object_type, ValideAbstractTextDocument* document) {
#line 158 "document-message.c"
	ValideDocumentMessage * self;
#line 44 "document-message.vala"
	g_return_val_if_fail (document != NULL, NULL);
#line 46 "document-message.vala"
	self = (ValideDocumentMessage*) g_object_new (object_type, "document", document, NULL);
#line 164 "document-message.c"
	return self;
}


#line 44 "document-message.vala"
ValideDocumentMessage* valide_document_message_new (ValideAbstractTextDocument* document) {
#line 44 "document-message.vala"
	return valide_document_message_construct (VALIDE_TYPE_DOCUMENT_MESSAGE, document);
#line 173 "document-message.c"
}


ValideAbstractTextDocument* valide_document_message_get_document (ValideDocumentMessage* self) {
	ValideAbstractTextDocument* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_document;
#line 36 "document-message.vala"
	return result;
#line 183 "document-message.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void valide_document_message_set_document (ValideDocumentMessage* self, ValideAbstractTextDocument* value) {
	ValideAbstractTextDocument* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_document = (_tmp0_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_document), _tmp0_);
	g_object_notify ((GObject *) self, "document");
}


static void _lambda29_ (ValideDocumentMessage* self) {
#line 84 "document-message.vala"
	valide_abstract_text_document_reload (self->priv->_document);
#line 85 "document-message.vala"
	valide_idocument_set_state ((ValideiDocument*) self->priv->_document, VALIDE_DOCUMENT_STATE_NORMAL);
#line 86 "document-message.vala"
	gtk_widget_grab_focus ((GtkWidget*) self->priv->_document);
#line 87 "document-message.vala"
	gtk_object_destroy ((GtkObject*) self);
#line 209 "document-message.c"
}


static void __lambda29__gtk_button_clicked (GtkButton* _sender, gpointer self) {
	_lambda29_ (self);
}


static void _lambda30_ (ValideDocumentMessage* self) {
#line 93 "document-message.vala"
	valide_idocument_set_is_save ((ValideiDocument*) self->priv->_document, FALSE);
#line 94 "document-message.vala"
	valide_idocument_set_state ((ValideiDocument*) self->priv->_document, VALIDE_DOCUMENT_STATE_NORMAL);
#line 95 "document-message.vala"
	gtk_widget_grab_focus ((GtkWidget*) self->priv->_document);
#line 96 "document-message.vala"
	gtk_object_destroy ((GtkObject*) self);
#line 227 "document-message.c"
}


static void __lambda30__gtk_button_clicked (GtkButton* _sender, gpointer self) {
	_lambda30_ (self);
}


static GObject * valide_document_message_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	ValideDocumentMessage * self;
	parent_class = G_OBJECT_CLASS (valide_document_message_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = VALIDE_DOCUMENT_MESSAGE (obj);
	{
		GtkImage* image;
		GtkVBox* vbox;
		GtkVButtonBox* box;
		GtkButton* button;
		char* text;
		GtkImage* _tmp0_;
		GtkVBox* _tmp1_;
		GtkLabel* _tmp2_;
		GtkLabel* _tmp3_;
		GtkVButtonBox* _tmp4_;
		GtkButton* _tmp5_;
		GtkButton* _tmp6_;
		image = NULL;
		vbox = NULL;
		box = NULL;
		button = NULL;
		text = NULL;
#line 57 "document-message.vala"
		gtk_box_set_spacing ((GtkBox*) self, 16);
#line 58 "document-message.vala"
		gtk_container_set_border_width ((GtkContainer*) self, (guint) 8);
#line 60 "document-message.vala"
		image = (_tmp0_ = g_object_ref_sink ((GtkImage*) gtk_image_new_from_stock (GTK_STOCK_DIALOG_WARNING, GTK_ICON_SIZE_DIALOG)), _g_object_unref0 (image), _tmp0_);
#line 62 "document-message.vala"
		gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) image, FALSE, TRUE, (guint) 0);
#line 65 "document-message.vala"
		vbox = (_tmp1_ = g_object_ref_sink ((GtkVBox*) gtk_vbox_new (FALSE, 0)), _g_object_unref0 (vbox), _tmp1_);
#line 66 "document-message.vala"
		gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) vbox, TRUE, TRUE, (guint) 0);
#line 68 "document-message.vala"
		self->priv->primary_label = (_tmp2_ = g_object_ref_sink ((GtkLabel*) gtk_label_new ("")), _g_object_unref0 (self->priv->primary_label), _tmp2_);
#line 69 "document-message.vala"
		gtk_misc_set_alignment ((GtkMisc*) self->priv->primary_label, (float) 0, 0.5f);
#line 70 "document-message.vala"
		gtk_label_set_justify (self->priv->primary_label, GTK_JUSTIFY_LEFT);
#line 71 "document-message.vala"
		gtk_box_pack_start ((GtkBox*) vbox, (GtkWidget*) self->priv->primary_label, TRUE, TRUE, (guint) 0);
#line 73 "document-message.vala"
		self->priv->secondary_label = (_tmp3_ = g_object_ref_sink ((GtkLabel*) gtk_label_new ("")), _g_object_unref0 (self->priv->secondary_label), _tmp3_);
#line 74 "document-message.vala"
		gtk_misc_set_alignment ((GtkMisc*) self->priv->secondary_label, (float) 0, 0.5f);
#line 75 "document-message.vala"
		gtk_label_set_justify (self->priv->secondary_label, GTK_JUSTIFY_LEFT);
#line 76 "document-message.vala"
		gtk_box_pack_start ((GtkBox*) vbox, (GtkWidget*) self->priv->secondary_label, FALSE, TRUE, (guint) 0);
#line 78 "document-message.vala"
		box = (_tmp4_ = g_object_ref_sink ((GtkVButtonBox*) gtk_vbutton_box_new ()), _g_object_unref0 (box), _tmp4_);
#line 79 "document-message.vala"
		gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) box, FALSE, TRUE, (guint) 0);
#line 81 "document-message.vala"
		button = (_tmp5_ = g_object_ref_sink ((GtkButton*) gtk_button_new_from_stock (GTK_STOCK_REFRESH)), _g_object_unref0 (button), _tmp5_);
#line 82 "document-message.vala"
		gtk_box_pack_start ((GtkBox*) box, (GtkWidget*) button, TRUE, TRUE, (guint) 0);
#line 83 "document-message.vala"
		g_signal_connect_object (button, "clicked", (GCallback) __lambda29__gtk_button_clicked, self, 0);
#line 90 "document-message.vala"
		button = (_tmp6_ = g_object_ref_sink ((GtkButton*) gtk_button_new_from_stock (GTK_STOCK_CANCEL)), _g_object_unref0 (button), _tmp6_);
#line 91 "document-message.vala"
		gtk_box_pack_start ((GtkBox*) box, (GtkWidget*) button, TRUE, TRUE, (guint) 0);
#line 92 "document-message.vala"
		g_signal_connect_object (button, "clicked", (GCallback) __lambda30__gtk_button_clicked, self, 0);
#line 99 "document-message.vala"
		switch (valide_idocument_get_state ((ValideiDocument*) self->priv->_document)) {
#line 307 "document-message.c"
			case VALIDE_DOCUMENT_STATE_EXTERNALLY_MODIFIED:
			{
				char* _tmp7_;
#line 102 "document-message.vala"
				text = (_tmp7_ = g_strdup_printf (_ ("The file %s changed on disk."), valide_idocument_get_path ((ValideiDocument*) self->priv->_document)), _g_free0 (text), _tmp7_);
#line 103 "document-message.vala"
				gtk_label_set_text (self->priv->primary_label, text);
#line 105 "document-message.vala"
				if (!valide_idocument_get_is_save ((ValideiDocument*) self->priv->_document)) {
#line 317 "document-message.c"
					char* _tmp8_;
#line 107 "document-message.vala"
					text = (_tmp8_ = g_strdup (_ ("Do you want to drop your changes and reload the file?")), _g_free0 (text), _tmp8_);
#line 321 "document-message.c"
				} else {
					char* _tmp9_;
#line 111 "document-message.vala"
					text = (_tmp9_ = g_strdup (_ ("Do you want to reload the file?")), _g_free0 (text), _tmp9_);
#line 326 "document-message.c"
				}
#line 113 "document-message.vala"
				gtk_label_set_text (self->priv->secondary_label, text);
#line 114 "document-message.vala"
				break;
#line 332 "document-message.c"
			}
			case VALIDE_DOCUMENT_STATE_BAD_ENCODING:
			{
				char* _tmp10_;
				char* _tmp11_;
#line 116 "document-message.vala"
				text = (_tmp10_ = g_strdup_printf (_ ("Couldn't open the file %s."), valide_idocument_get_path ((ValideiDocument*) self->priv->_document)), _g_free0 (text), _tmp10_);
#line 117 "document-message.vala"
				gtk_label_set_text (self->priv->primary_label, text);
#line 119 "document-message.vala"
				text = (_tmp11_ = g_strdup ("Val(a)IDE has not been able to detect the character coding.\nPlease check that you are not trying to open a binary file."), _g_free0 (text), _tmp11_);
#line 121 "document-message.vala"
				gtk_label_set_text (self->priv->secondary_label, text);
#line 122 "document-message.vala"
				break;
#line 348 "document-message.c"
			}
		}
		_g_object_unref0 (image);
		_g_object_unref0 (vbox);
		_g_object_unref0 (box);
		_g_object_unref0 (button);
		_g_free0 (text);
	}
	return obj;
}


static void valide_document_message_class_init (ValideDocumentMessageClass * klass) {
	valide_document_message_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValideDocumentMessagePrivate));
	G_OBJECT_CLASS (klass)->get_property = valide_document_message_get_property;
	G_OBJECT_CLASS (klass)->set_property = valide_document_message_set_property;
	G_OBJECT_CLASS (klass)->constructor = valide_document_message_constructor;
	G_OBJECT_CLASS (klass)->finalize = valide_document_message_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_DOCUMENT_MESSAGE_DOCUMENT, g_param_spec_object ("document", "document", "document", VALIDE_TYPE_ABSTRACT_TEXT_DOCUMENT, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}


static void valide_document_message_instance_init (ValideDocumentMessage * self) {
	self->priv = VALIDE_DOCUMENT_MESSAGE_GET_PRIVATE (self);
}


static void valide_document_message_finalize (GObject* obj) {
	ValideDocumentMessage * self;
	self = VALIDE_DOCUMENT_MESSAGE (obj);
	_g_object_unref0 (self->priv->primary_label);
	_g_object_unref0 (self->priv->secondary_label);
	_g_object_unref0 (self->priv->_document);
	G_OBJECT_CLASS (valide_document_message_parent_class)->finalize (obj);
}


GType valide_document_message_get_type (void) {
	static GType valide_document_message_type_id = 0;
	if (valide_document_message_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValideDocumentMessageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valide_document_message_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValideDocumentMessage), 0, (GInstanceInitFunc) valide_document_message_instance_init, NULL };
		valide_document_message_type_id = g_type_register_static (GTK_TYPE_HBOX, "ValideDocumentMessage", &g_define_type_info, 0);
	}
	return valide_document_message_type_id;
}


static void valide_document_message_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	ValideDocumentMessage * self;
	self = VALIDE_DOCUMENT_MESSAGE (object);
	switch (property_id) {
		case VALIDE_DOCUMENT_MESSAGE_DOCUMENT:
		g_value_set_object (value, valide_document_message_get_document (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void valide_document_message_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	ValideDocumentMessage * self;
	self = VALIDE_DOCUMENT_MESSAGE (object);
	switch (property_id) {
		case VALIDE_DOCUMENT_MESSAGE_DOCUMENT:
		valide_document_message_set_document (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}




