/* encoding.c generated by valac, the Vala compiler
 * generated from encoding.vala, do not modify */

/* encoding.vala
 *
 * Copyright (C) 2009  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <nicolas.joseph@valaide.org>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gstdio.h>
#include <gtk/gtk.h>


#define VALIDE_TYPE_ENCODING (valide_encoding_get_type ())
#define VALIDE_ENCODING(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_ENCODING, ValideEncoding))
#define VALIDE_ENCODING_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_ENCODING, ValideEncodingClass))
#define VALIDE_IS_ENCODING(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_ENCODING))
#define VALIDE_IS_ENCODING_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_ENCODING))
#define VALIDE_ENCODING_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_ENCODING, ValideEncodingClass))

typedef struct _ValideEncoding ValideEncoding;
typedef struct _ValideEncodingClass ValideEncodingClass;
typedef struct _ValideEncodingPrivate ValideEncodingPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

typedef enum  {
	VALIDE_ENCODING_ERROR_UNKNOW_ENCODING
} ValideEncodingError;
#define VALIDE_ENCODING_ERROR valide_encoding_error_quark ()
struct _ValideEncoding {
	GObject parent_instance;
	ValideEncodingPrivate * priv;
};

struct _ValideEncodingClass {
	GObjectClass parent_class;
};


static gpointer valide_encoding_parent_class = NULL;

GQuark valide_encoding_error_quark (void);
GType valide_encoding_get_type (void);
enum  {
	VALIDE_ENCODING_DUMMY_PROPERTY
};
static char* valide_encoding_convert (const char* text, const char* to_codeset, const char* from_codeset, GError** error);
static gboolean valide_encoding_test (const char* text, const char* charset);
static char* valide_encoding_get_charset (const char* text);
char* valide_encoding_to_utf8 (const char* path, char** encoding, GError** error);
char* valide_encoding_from_utf8 (GtkTextBuffer* text_buffer, char** encoding, GError** error);
ValideEncoding* valide_encoding_new (void);
ValideEncoding* valide_encoding_construct (GType object_type);

static const char* VALIDE_ENCODING_charsets[] = {"UTF-8", "ISO-8859-15"};


GQuark valide_encoding_error_quark (void) {
	return g_quark_from_static_string ("valide_encoding_error-quark");
}


#line 34 "encoding.vala"
static char* valide_encoding_convert (const char* text, const char* to_codeset, const char* from_codeset, GError** error) {
#line 86 "encoding.c"
	char* result;
	GError * _inner_error_;
	char* _tmp0_;
#line 34 "encoding.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 34 "encoding.vala"
	g_return_val_if_fail (to_codeset != NULL, NULL);
#line 34 "encoding.vala"
	g_return_val_if_fail (from_codeset != NULL, NULL);
#line 96 "encoding.c"
	_inner_error_ = NULL;
#line 38 "encoding.vala"
	_tmp0_ = g_convert (text, (gssize) (-1), to_codeset, from_codeset, NULL, NULL, &_inner_error_);
#line 100 "encoding.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
	result = _tmp0_;
#line 38 "encoding.vala"
	return result;
#line 108 "encoding.c"
}


#line 41 "encoding.vala"
static gboolean valide_encoding_test (const char* text, const char* charset) {
#line 114 "encoding.c"
	gboolean result;
	GError * _inner_error_;
	gboolean valid;
#line 41 "encoding.vala"
	g_return_val_if_fail (text != NULL, FALSE);
#line 41 "encoding.vala"
	g_return_val_if_fail (charset != NULL, FALSE);
#line 122 "encoding.c"
	_inner_error_ = NULL;
#line 43 "encoding.vala"
	valid = FALSE;
#line 126 "encoding.c"
	{
		char* convert;
		char* _tmp0_;
		char* _tmp1_;
		convert = NULL;
#line 49 "encoding.vala"
		_tmp0_ = g_convert (text, (gssize) (-1), "UTF-8", charset, NULL, NULL, &_inner_error_);
#line 134 "encoding.c"
		if (_inner_error_ != NULL) {
			_g_free0 (convert);
			goto __catch0_g_error;
			goto __finally0;
		}
#line 49 "encoding.vala"
		convert = (_tmp1_ = _tmp0_, _g_free0 (convert), _tmp1_);
#line 50 "encoding.vala"
		valid = TRUE;
#line 144 "encoding.c"
		_g_free0 (convert);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
#line 54 "encoding.vala"
			g_debug ("encoding.vala:54: %s", e->message);
#line 156 "encoding.c"
			_g_error_free0 (e);
		}
	}
	__finally0:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	result = valid;
#line 56 "encoding.vala"
	return result;
#line 169 "encoding.c"
}


#line 59 "encoding.vala"
static char* valide_encoding_get_charset (const char* text) {
#line 175 "encoding.c"
	char* result;
	char* charset;
#line 59 "encoding.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 61 "encoding.vala"
	charset = NULL;
#line 182 "encoding.c"
	{
		const char** c_collection;
		int c_collection_length1;
		int c_it;
#line 63 "encoding.vala"
		c_collection = VALIDE_ENCODING_charsets;
#line 189 "encoding.c"
		c_collection_length1 = G_N_ELEMENTS (VALIDE_ENCODING_charsets);
		for (c_it = 0; c_it < G_N_ELEMENTS (VALIDE_ENCODING_charsets); c_it = c_it + 1) {
			char* c;
			c = g_strdup (c_collection[c_it]);
			{
#line 65 "encoding.vala"
				if (valide_encoding_test (text, c)) {
#line 197 "encoding.c"
					char* _tmp0_;
#line 67 "encoding.vala"
					charset = (_tmp0_ = g_strdup (c), _g_free0 (charset), _tmp0_);
#line 201 "encoding.c"
					_g_free0 (c);
#line 68 "encoding.vala"
					break;
#line 205 "encoding.c"
				}
				_g_free0 (c);
			}
		}
	}
	result = charset;
#line 71 "encoding.vala"
	return result;
#line 214 "encoding.c"
}


#line 82 "encoding.vala"
char* valide_encoding_to_utf8 (const char* path, char** encoding, GError** error) {
#line 220 "encoding.c"
	char* result;
	GError * _inner_error_;
	char* text;
	char* contents;
	char* _tmp2_;
	gboolean _tmp1_;
	char* _tmp0_ = NULL;
	char* _tmp3_;
#line 82 "encoding.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 231 "encoding.c"
	if (encoding != NULL) {
		*encoding = NULL;
	}
	_inner_error_ = NULL;
#line 84 "encoding.vala"
	text = NULL;
#line 85 "encoding.vala"
	contents = g_strdup ("");
#line 87 "encoding.vala"
	_tmp1_ = g_file_get_contents (path, &_tmp0_, NULL, &_inner_error_);
#line 87 "encoding.vala"
	text = (_tmp2_ = _tmp0_, _g_free0 (text), _tmp2_);
#line 87 "encoding.vala"
	_tmp1_;
#line 246 "encoding.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_free0 (text);
		_g_free0 (contents);
		return NULL;
	}
#line 88 "encoding.vala"
	*encoding = (_tmp3_ = valide_encoding_get_charset (text), _g_free0 (*encoding), _tmp3_);
#line 89 "encoding.vala"
	if ((*encoding) != NULL) {
#line 257 "encoding.c"
		char* _tmp4_;
		char* _tmp5_;
#line 91 "encoding.vala"
		_tmp4_ = valide_encoding_convert (text, "UTF-8", *encoding, &_inner_error_);
#line 262 "encoding.c"
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (text);
			_g_free0 (contents);
			return NULL;
		}
#line 91 "encoding.vala"
		contents = (_tmp5_ = _tmp4_, _g_free0 (contents), _tmp5_);
#line 271 "encoding.c"
	} else {
		_inner_error_ = g_error_new_literal (VALIDE_ENCODING_ERROR, VALIDE_ENCODING_ERROR_UNKNOW_ENCODING, "unknow encoding");
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (text);
			_g_free0 (contents);
			return NULL;
		}
	}
	result = contents;
	_g_free0 (text);
#line 97 "encoding.vala"
	return result;
#line 285 "encoding.c"
}


#line 109 "encoding.vala"
char* valide_encoding_from_utf8 (GtkTextBuffer* text_buffer, char** encoding, GError** error) {
#line 291 "encoding.c"
	char* result;
	GError * _inner_error_;
	char* text;
	GtkTextIter end = {0};
	GtkTextIter start = {0};
	char* convert;
	char* _tmp0_;
#line 109 "encoding.vala"
	g_return_val_if_fail (text_buffer != NULL, NULL);
#line 301 "encoding.c"
	if (encoding != NULL) {
		*encoding = NULL;
	}
	_inner_error_ = NULL;
	text = NULL;
#line 114 "encoding.vala"
	convert = NULL;
#line 116 "encoding.vala"
	gtk_text_buffer_get_bounds (text_buffer, &start, &end);
#line 117 "encoding.vala"
	text = (_tmp0_ = g_strdup (gtk_text_iter_get_text (&start, &end)), _g_free0 (text), _tmp0_);
#line 118 "encoding.vala"
	if (text != NULL) {
#line 315 "encoding.c"
		char* _tmp1_;
#line 120 "encoding.vala"
		*encoding = (_tmp1_ = valide_encoding_get_charset (text), _g_free0 (*encoding), _tmp1_);
#line 121 "encoding.vala"
		if ((*encoding) != NULL) {
#line 321 "encoding.c"
			char* _tmp2_;
			char* _tmp3_;
#line 123 "encoding.vala"
			_tmp2_ = valide_encoding_convert (text, *encoding, "UTF-8", &_inner_error_);
#line 326 "encoding.c"
			if (_inner_error_ != NULL) {
				g_propagate_error (error, _inner_error_);
				_g_free0 (text);
				_g_free0 (convert);
				return NULL;
			}
#line 123 "encoding.vala"
			convert = (_tmp3_ = _tmp2_, _g_free0 (convert), _tmp3_);
#line 335 "encoding.c"
		}
	}
	result = convert;
	_g_free0 (text);
#line 126 "encoding.vala"
	return result;
#line 342 "encoding.c"
}


#line 30 "encoding.vala"
ValideEncoding* valide_encoding_construct (GType object_type) {
#line 348 "encoding.c"
	ValideEncoding * self;
#line 30 "encoding.vala"
	self = (ValideEncoding*) g_object_new (object_type, NULL);
#line 352 "encoding.c"
	return self;
}


#line 30 "encoding.vala"
ValideEncoding* valide_encoding_new (void) {
#line 30 "encoding.vala"
	return valide_encoding_construct (VALIDE_TYPE_ENCODING);
#line 361 "encoding.c"
}


static void valide_encoding_class_init (ValideEncodingClass * klass) {
	valide_encoding_parent_class = g_type_class_peek_parent (klass);
}


static void valide_encoding_instance_init (ValideEncoding * self) {
}


GType valide_encoding_get_type (void) {
	static GType valide_encoding_type_id = 0;
	if (valide_encoding_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValideEncodingClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valide_encoding_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValideEncoding), 0, (GInstanceInitFunc) valide_encoding_instance_init, NULL };
		valide_encoding_type_id = g_type_register_static (G_TYPE_OBJECT, "ValideEncoding", &g_define_type_info, 0);
	}
	return valide_encoding_type_id;
}




