/* goto-dialog.c generated by valac, the Vala compiler
 * generated from goto-dialog.vala, do not modify */

/* goto-dialog.vala
 *
 * Copyright (C) 2008-2009  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <nicolas.joseph@valaide.org>
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gtksourceview/gtksourceview.h>
#include <gdk/gdk.h>
#include <gdk/gdkkeysyms.h>
#include <stdlib.h>
#include <string.h>


#define VALIDE_TYPE_GOTO_DIALOG (valide_goto_dialog_get_type ())
#define VALIDE_GOTO_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_GOTO_DIALOG, ValideGotoDialog))
#define VALIDE_GOTO_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_GOTO_DIALOG, ValideGotoDialogClass))
#define VALIDE_IS_GOTO_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_GOTO_DIALOG))
#define VALIDE_IS_GOTO_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_GOTO_DIALOG))
#define VALIDE_GOTO_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_GOTO_DIALOG, ValideGotoDialogClass))

typedef struct _ValideGotoDialog ValideGotoDialog;
typedef struct _ValideGotoDialogClass ValideGotoDialogClass;
typedef struct _ValideGotoDialogPrivate ValideGotoDialogPrivate;

#define VALIDE_TYPE_SOURCE_VIEW (valide_source_view_get_type ())
#define VALIDE_SOURCE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_SOURCE_VIEW, ValideSourceView))
#define VALIDE_SOURCE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_SOURCE_VIEW, ValideSourceViewClass))
#define VALIDE_IS_SOURCE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_SOURCE_VIEW))
#define VALIDE_IS_SOURCE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_SOURCE_VIEW))
#define VALIDE_SOURCE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_SOURCE_VIEW, ValideSourceViewClass))

typedef struct _ValideSourceView ValideSourceView;
typedef struct _ValideSourceViewClass ValideSourceViewClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _ValideGotoDialog {
	GtkWindow parent_instance;
	ValideGotoDialogPrivate * priv;
};

struct _ValideGotoDialogClass {
	GtkWindowClass parent_class;
};

struct _ValideGotoDialogPrivate {
	GtkEntry* entry;
	ValideSourceView* _source_view;
};


static gpointer valide_goto_dialog_parent_class = NULL;

GType valide_goto_dialog_get_type (void);
GType valide_source_view_get_type (void);
#define VALIDE_GOTO_DIALOG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALIDE_TYPE_GOTO_DIALOG, ValideGotoDialogPrivate))
enum  {
	VALIDE_GOTO_DIALOG_DUMMY_PROPERTY,
	VALIDE_GOTO_DIALOG_SOURCE_VIEW
};
ValideSourceView* valide_goto_dialog_get_source_view (ValideGotoDialog* self);
static void valide_goto_dialog_hide_search (ValideGotoDialog* self, gboolean cancel);
static void valide_goto_dialog_update_position (ValideGotoDialog* self);
static gboolean valide_goto_dialog_key_press_event_cb (ValideGotoDialog* self, GtkWidget* sender, GdkEventKey* event);
gboolean valide_source_view_goto_line (ValideSourceView* self, gint line);
static void valide_goto_dialog_changed_cb (ValideGotoDialog* self);
static void valide_goto_dialog_insert_text_cb (ValideGotoDialog* self, GtkEditable* sender, const char* new_text, gint new_text_length, void* position);
ValideGotoDialog* valide_goto_dialog_new (ValideSourceView* source_view);
ValideGotoDialog* valide_goto_dialog_construct (GType object_type, ValideSourceView* source_view);
static void valide_goto_dialog_real_show (GtkWidget* base);
static void valide_goto_dialog_real_grab_focus (GtkWidget* base);
static void valide_goto_dialog_set_source_view (ValideGotoDialog* self, ValideSourceView* value);
static void _lambda2_ (ValideGotoDialog* self);
static void __lambda2__gtk_entry_activate (GtkEntry* _sender, gpointer self);
static gboolean _lambda3_ (ValideGotoDialog* self);
static gboolean __lambda3__gtk_widget_delete_event (GtkWidget* _sender, GdkEvent* event, gpointer self);
static gboolean _lambda4_ (ValideGotoDialog* self);
static gboolean __lambda4__gtk_widget_focus_out_event (GtkWidget* _sender, GdkEventFocus* event, gpointer self);
static void _valide_goto_dialog_changed_cb_gtk_editable_changed (GtkEditable* _sender, gpointer self);
static void _valide_goto_dialog_insert_text_cb_gtk_editable_insert_text (GtkEditable* _sender, const char* text, gint length, void* position, gpointer self);
static gboolean _valide_goto_dialog_key_press_event_cb_gtk_widget_key_press_event (GtkWidget* _sender, GdkEventKey* event, gpointer self);
static GObject * valide_goto_dialog_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void valide_goto_dialog_finalize (GObject* obj);
static void valide_goto_dialog_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void valide_goto_dialog_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static int _vala_strcmp0 (const char * str1, const char * str2);



#line 38 "goto-dialog.vala"
static void valide_goto_dialog_hide_search (ValideGotoDialog* self, gboolean cancel) {
#line 38 "goto-dialog.vala"
	g_return_if_fail (self != NULL);
#line 40 "goto-dialog.vala"
	gtk_widget_hide ((GtkWidget*) self);
#line 42 "goto-dialog.vala"
	if (cancel) {
#line 119 "goto-dialog.c"
	}
#line 45 "goto-dialog.vala"
	gtk_widget_grab_focus ((GtkWidget*) self->priv->_source_view);
#line 123 "goto-dialog.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 48 "goto-dialog.vala"
static void valide_goto_dialog_update_position (ValideGotoDialog* self) {
#line 134 "goto-dialog.c"
	gint view_x = 0;
	gint view_y = 0;
	GdkWindow* view_window;
	GdkWindow* _tmp0_;
#line 48 "goto-dialog.vala"
	g_return_if_fail (self != NULL);
#line 141 "goto-dialog.c"
	view_window = NULL;
#line 53 "goto-dialog.vala"
	view_window = (_tmp0_ = _g_object_ref0 (((GtkWidget*) self->priv->_source_view)->window), _g_object_unref0 (view_window), _tmp0_);
#line 54 "goto-dialog.vala"
	gtk_widget_realize ((GtkWidget*) self);
#line 56 "goto-dialog.vala"
	gdk_window_get_origin (view_window, &view_x, &view_y);
#line 58 "goto-dialog.vala"
	gtk_window_move ((GtkWindow*) self, view_x, view_y);
#line 151 "goto-dialog.c"
	_g_object_unref0 (view_window);
}


#line 61 "goto-dialog.vala"
static gboolean valide_goto_dialog_key_press_event_cb (ValideGotoDialog* self, GtkWidget* sender, GdkEventKey* event) {
#line 158 "goto-dialog.c"
	gboolean result;
	gboolean catched;
#line 61 "goto-dialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 61 "goto-dialog.vala"
	g_return_val_if_fail (sender != NULL, FALSE);
#line 63 "goto-dialog.vala"
	catched = FALSE;
#line 65 "goto-dialog.vala"
	switch ((*event).keyval) {
#line 169 "goto-dialog.c"
		case GDK_Return:
		case GDK_Tab:
		{
#line 69 "goto-dialog.vala"
			valide_goto_dialog_hide_search (self, FALSE);
#line 70 "goto-dialog.vala"
			catched = TRUE;
#line 71 "goto-dialog.vala"
			break;
#line 179 "goto-dialog.c"
		}
		case GDK_Escape:
		{
#line 74 "goto-dialog.vala"
			valide_goto_dialog_hide_search (self, TRUE);
#line 75 "goto-dialog.vala"
			catched = TRUE;
#line 76 "goto-dialog.vala"
			break;
#line 189 "goto-dialog.c"
		}
	}
	result = catched;
#line 78 "goto-dialog.vala"
	return result;
#line 195 "goto-dialog.c"
}


#line 81 "goto-dialog.vala"
static void valide_goto_dialog_changed_cb (ValideGotoDialog* self) {
#line 81 "goto-dialog.vala"
	g_return_if_fail (self != NULL);
#line 83 "goto-dialog.vala"
	if (_vala_strcmp0 (gtk_entry_get_text (self->priv->entry), "") != 0) {
#line 205 "goto-dialog.c"
		gint line = 0;
		gboolean moved = FALSE;
		GdkColor color = {0};
#line 89 "goto-dialog.vala"
		line = atoi (gtk_entry_get_text (self->priv->entry));
#line 90 "goto-dialog.vala"
		if (line > 0) {
#line 92 "goto-dialog.vala"
			line--;
#line 215 "goto-dialog.c"
		}
#line 94 "goto-dialog.vala"
		moved = valide_source_view_goto_line (self->priv->_source_view, line);
#line 96 "goto-dialog.vala"
		if (!moved) {
#line 98 "goto-dialog.vala"
			gdk_color_parse ("#FFBFBF", &color);
#line 223 "goto-dialog.c"
		} else {
#line 102 "goto-dialog.vala"
			gdk_color_parse ("white", &color);
#line 227 "goto-dialog.c"
		}
#line 104 "goto-dialog.vala"
		gtk_widget_modify_base ((GtkWidget*) self->priv->entry, GTK_STATE_NORMAL, &color);
#line 231 "goto-dialog.c"
	}
}


#line 108 "goto-dialog.vala"
static void valide_goto_dialog_insert_text_cb (ValideGotoDialog* self, GtkEditable* sender, const char* new_text, gint new_text_length, void* position) {
#line 238 "goto-dialog.c"
	gint i;
	gunichar c = 0U;
#line 108 "goto-dialog.vala"
	g_return_if_fail (self != NULL);
#line 108 "goto-dialog.vala"
	g_return_if_fail (sender != NULL);
#line 108 "goto-dialog.vala"
	g_return_if_fail (new_text != NULL);
#line 111 "goto-dialog.vala"
	i = 0;
#line 114 "goto-dialog.vala"
	while (TRUE) {
#line 114 "goto-dialog.vala"
		if (!(i < new_text_length)) {
#line 114 "goto-dialog.vala"
			break;
#line 255 "goto-dialog.c"
		}
#line 116 "goto-dialog.vala"
		c = g_utf8_get_char (g_utf8_offset_to_pointer (new_text, i));
#line 118 "goto-dialog.vala"
		if (!g_unichar_isdigit (c)) {
#line 120 "goto-dialog.vala"
			g_signal_stop_emission_by_name (sender, "insert_text");
#line 121 "goto-dialog.vala"
			break;
#line 265 "goto-dialog.c"
		}
#line 123 "goto-dialog.vala"
		i++;
#line 269 "goto-dialog.c"
	}
}


#line 132 "goto-dialog.vala"
ValideGotoDialog* valide_goto_dialog_construct (GType object_type, ValideSourceView* source_view) {
#line 276 "goto-dialog.c"
	ValideGotoDialog * self;
#line 132 "goto-dialog.vala"
	g_return_val_if_fail (source_view != NULL, NULL);
#line 134 "goto-dialog.vala"
	self = (ValideGotoDialog*) g_object_new (object_type, "source-view", source_view, NULL);
#line 282 "goto-dialog.c"
	return self;
}


#line 132 "goto-dialog.vala"
ValideGotoDialog* valide_goto_dialog_new (ValideSourceView* source_view) {
#line 132 "goto-dialog.vala"
	return valide_goto_dialog_construct (VALIDE_TYPE_GOTO_DIALOG, source_view);
#line 291 "goto-dialog.c"
}


#line 187 "goto-dialog.vala"
static void valide_goto_dialog_real_show (GtkWidget* base) {
#line 297 "goto-dialog.c"
	ValideGotoDialog * self;
	self = (ValideGotoDialog*) base;
#line 189 "goto-dialog.vala"
	GTK_WIDGET_CLASS (valide_goto_dialog_parent_class)->show ((GtkWidget*) GTK_WINDOW (self));
#line 190 "goto-dialog.vala"
	valide_goto_dialog_update_position (self);
#line 191 "goto-dialog.vala"
	gtk_widget_grab_focus ((GtkWidget*) self);
#line 306 "goto-dialog.c"
}


#line 197 "goto-dialog.vala"
static void valide_goto_dialog_real_grab_focus (GtkWidget* base) {
#line 312 "goto-dialog.c"
	ValideGotoDialog * self;
	self = (ValideGotoDialog*) base;
#line 199 "goto-dialog.vala"
	gtk_widget_grab_focus ((GtkWidget*) self->priv->entry);
#line 317 "goto-dialog.c"
}


ValideSourceView* valide_goto_dialog_get_source_view (ValideGotoDialog* self) {
	ValideSourceView* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_source_view;
#line 34 "goto-dialog.vala"
	return result;
#line 327 "goto-dialog.c"
}


static void valide_goto_dialog_set_source_view (ValideGotoDialog* self, ValideSourceView* value) {
	ValideSourceView* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_source_view = (_tmp0_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_source_view), _tmp0_);
	g_object_notify ((GObject *) self, "source-view");
}


static void _lambda2_ (ValideGotoDialog* self) {
#line 166 "goto-dialog.vala"
	valide_goto_dialog_hide_search (self, FALSE);
#line 342 "goto-dialog.c"
}


static void __lambda2__gtk_entry_activate (GtkEntry* _sender, gpointer self) {
	_lambda2_ (self);
}


static gboolean _lambda3_ (ValideGotoDialog* self) {
	gboolean result;
#line 170 "goto-dialog.vala"
	valide_goto_dialog_hide_search (self, FALSE);
#line 355 "goto-dialog.c"
	result = FALSE;
#line 171 "goto-dialog.vala"
	return result;
#line 359 "goto-dialog.c"
}


static gboolean __lambda3__gtk_widget_delete_event (GtkWidget* _sender, GdkEvent* event, gpointer self) {
	return _lambda3_ (self);
}


static gboolean _lambda4_ (ValideGotoDialog* self) {
	gboolean result;
#line 175 "goto-dialog.vala"
	valide_goto_dialog_hide_search (self, TRUE);
#line 372 "goto-dialog.c"
	result = FALSE;
#line 176 "goto-dialog.vala"
	return result;
#line 376 "goto-dialog.c"
}


static gboolean __lambda4__gtk_widget_focus_out_event (GtkWidget* _sender, GdkEventFocus* event, gpointer self) {
	return _lambda4_ (self);
}


#line 81 "goto-dialog.vala"
static void _valide_goto_dialog_changed_cb_gtk_editable_changed (GtkEditable* _sender, gpointer self) {
#line 387 "goto-dialog.c"
	valide_goto_dialog_changed_cb (self);
}


#line 108 "goto-dialog.vala"
static void _valide_goto_dialog_insert_text_cb_gtk_editable_insert_text (GtkEditable* _sender, const char* text, gint length, void* position, gpointer self) {
#line 394 "goto-dialog.c"
	valide_goto_dialog_insert_text_cb (self, _sender, text, length, position);
}


#line 61 "goto-dialog.vala"
static gboolean _valide_goto_dialog_key_press_event_cb_gtk_widget_key_press_event (GtkWidget* _sender, GdkEventKey* event, gpointer self) {
#line 401 "goto-dialog.c"
	return valide_goto_dialog_key_press_event_cb (self, _sender, event);
}


static GObject * valide_goto_dialog_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	ValideGotoDialog * self;
	parent_class = G_OBJECT_CLASS (valide_goto_dialog_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = VALIDE_GOTO_DIALOG (obj);
	{
		GtkFrame* frame;
		GtkVBox* vbox;
		GtkWindow* toplevel;
		GtkWindow* _tmp1_;
		GtkWidget* _tmp0_;
		GtkFrame* _tmp2_;
		GtkVBox* _tmp3_;
		GtkEntry* _tmp4_;
		frame = NULL;
		vbox = NULL;
		toplevel = NULL;
#line 143 "goto-dialog.vala"
		gtk_window_set_decorated ((GtkWindow*) self, FALSE);
#line 144 "goto-dialog.vala"
		gtk_window_set_skip_taskbar_hint ((GtkWindow*) self, TRUE);
#line 145 "goto-dialog.vala"
		gtk_window_set_skip_pager_hint ((GtkWindow*) self, TRUE);
#line 146 "goto-dialog.vala"
		toplevel = (_tmp1_ = _g_object_ref0 ((_tmp0_ = gtk_widget_get_toplevel ((GtkWidget*) self->priv->_source_view), GTK_IS_WINDOW (_tmp0_) ? ((GtkWindow*) _tmp0_) : NULL)), _g_object_unref0 (toplevel), _tmp1_);
#line 147 "goto-dialog.vala"
		gtk_window_group_add_window (toplevel->group, (GtkWindow*) self);
#line 148 "goto-dialog.vala"
		gtk_window_set_modal ((GtkWindow*) self, TRUE);
#line 150 "goto-dialog.vala"
		frame = (_tmp2_ = g_object_ref_sink ((GtkFrame*) gtk_frame_new (NULL)), _g_object_unref0 (frame), _tmp2_);
#line 151 "goto-dialog.vala"
		gtk_frame_set_shadow_type (frame, GTK_SHADOW_ETCHED_IN);
#line 152 "goto-dialog.vala"
		gtk_container_add ((GtkContainer*) self, (GtkWidget*) frame);
#line 153 "goto-dialog.vala"
		gtk_widget_show ((GtkWidget*) frame);
#line 155 "goto-dialog.vala"
		vbox = (_tmp3_ = g_object_ref_sink ((GtkVBox*) gtk_vbox_new (FALSE, 0)), _g_object_unref0 (vbox), _tmp3_);
#line 156 "goto-dialog.vala"
		gtk_container_set_border_width ((GtkContainer*) vbox, (guint) 3);
#line 157 "goto-dialog.vala"
		gtk_container_add ((GtkContainer*) frame, (GtkWidget*) vbox);
#line 158 "goto-dialog.vala"
		gtk_widget_show ((GtkWidget*) vbox);
#line 160 "goto-dialog.vala"
		self->priv->entry = (_tmp4_ = g_object_ref_sink ((GtkEntry*) gtk_entry_new ()), _g_object_unref0 (self->priv->entry), _tmp4_);
#line 161 "goto-dialog.vala"
		gtk_container_add ((GtkContainer*) vbox, (GtkWidget*) self->priv->entry);
#line 162 "goto-dialog.vala"
		gtk_widget_show ((GtkWidget*) self->priv->entry);
#line 163 "goto-dialog.vala"
		gtk_widget_realize ((GtkWidget*) self->priv->entry);
#line 165 "goto-dialog.vala"
		g_signal_connect_object (self->priv->entry, "activate", (GCallback) __lambda2__gtk_entry_activate, self, 0);
#line 169 "goto-dialog.vala"
		g_signal_connect_object ((GtkWidget*) self, "delete-event", (GCallback) __lambda3__gtk_widget_delete_event, self, 0);
#line 174 "goto-dialog.vala"
		g_signal_connect_object ((GtkWidget*) self, "focus-out-event", (GCallback) __lambda4__gtk_widget_focus_out_event, self, 0);
#line 179 "goto-dialog.vala"
		g_signal_connect_object ((GtkEditable*) self->priv->entry, "changed", (GCallback) _valide_goto_dialog_changed_cb_gtk_editable_changed, self, 0);
#line 180 "goto-dialog.vala"
		g_signal_connect_object ((GtkEditable*) self->priv->entry, "insert-text", (GCallback) _valide_goto_dialog_insert_text_cb_gtk_editable_insert_text, self, 0);
#line 181 "goto-dialog.vala"
		g_signal_connect_object ((GtkWidget*) self->priv->entry, "key-press-event", (GCallback) _valide_goto_dialog_key_press_event_cb_gtk_widget_key_press_event, self, 0);
#line 473 "goto-dialog.c"
		_g_object_unref0 (frame);
		_g_object_unref0 (vbox);
		_g_object_unref0 (toplevel);
	}
	return obj;
}


static void valide_goto_dialog_class_init (ValideGotoDialogClass * klass) {
	valide_goto_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValideGotoDialogPrivate));
	GTK_WIDGET_CLASS (klass)->show = valide_goto_dialog_real_show;
	GTK_WIDGET_CLASS (klass)->grab_focus = valide_goto_dialog_real_grab_focus;
	G_OBJECT_CLASS (klass)->get_property = valide_goto_dialog_get_property;
	G_OBJECT_CLASS (klass)->set_property = valide_goto_dialog_set_property;
	G_OBJECT_CLASS (klass)->constructor = valide_goto_dialog_constructor;
	G_OBJECT_CLASS (klass)->finalize = valide_goto_dialog_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_GOTO_DIALOG_SOURCE_VIEW, g_param_spec_object ("source-view", "source-view", "source-view", VALIDE_TYPE_SOURCE_VIEW, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}


static void valide_goto_dialog_instance_init (ValideGotoDialog * self) {
	self->priv = VALIDE_GOTO_DIALOG_GET_PRIVATE (self);
}


static void valide_goto_dialog_finalize (GObject* obj) {
	ValideGotoDialog * self;
	self = VALIDE_GOTO_DIALOG (obj);
	_g_object_unref0 (self->priv->entry);
	_g_object_unref0 (self->priv->_source_view);
	G_OBJECT_CLASS (valide_goto_dialog_parent_class)->finalize (obj);
}


GType valide_goto_dialog_get_type (void) {
	static GType valide_goto_dialog_type_id = 0;
	if (valide_goto_dialog_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValideGotoDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valide_goto_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValideGotoDialog), 0, (GInstanceInitFunc) valide_goto_dialog_instance_init, NULL };
		valide_goto_dialog_type_id = g_type_register_static (GTK_TYPE_WINDOW, "ValideGotoDialog", &g_define_type_info, 0);
	}
	return valide_goto_dialog_type_id;
}


static void valide_goto_dialog_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	ValideGotoDialog * self;
	self = VALIDE_GOTO_DIALOG (object);
	switch (property_id) {
		case VALIDE_GOTO_DIALOG_SOURCE_VIEW:
		g_value_set_object (value, valide_goto_dialog_get_source_view (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void valide_goto_dialog_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	ValideGotoDialog * self;
	self = VALIDE_GOTO_DIALOG (object);
	switch (property_id) {
		case VALIDE_GOTO_DIALOG_SOURCE_VIEW:
		valide_goto_dialog_set_source_view (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




