/* idocument.c generated by valac, the Vala compiler
 * generated from idocument.vala, do not modify */

/* idocument.vala
 *
 * Copyright (C) 2008-2009  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <nicolas.joseph@valaide.org>
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixdata.h>


#define VALIDE_TYPE_DOCUMENT_STATE (valide_document_state_get_type ())

#define VALIDE_TYPE_IDOCUMENT (valide_idocument_get_type ())
#define VALIDE_IDOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_IDOCUMENT, ValideiDocument))
#define VALIDE_IS_IDOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_IDOCUMENT))
#define VALIDE_IDOCUMENT_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), VALIDE_TYPE_IDOCUMENT, ValideiDocumentIface))

typedef struct _ValideiDocument ValideiDocument;
typedef struct _ValideiDocumentIface ValideiDocumentIface;

#define VALIDE_TYPE_UI_MANAGER (valide_ui_manager_get_type ())
#define VALIDE_UI_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_UI_MANAGER, ValideUIManager))
#define VALIDE_UI_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_UI_MANAGER, ValideUIManagerClass))
#define VALIDE_IS_UI_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_UI_MANAGER))
#define VALIDE_IS_UI_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_UI_MANAGER))
#define VALIDE_UI_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_UI_MANAGER, ValideUIManagerClass))

typedef struct _ValideUIManager ValideUIManager;
typedef struct _ValideUIManagerClass ValideUIManagerClass;

typedef enum  {
	VALIDE_DOCUMENT_STATE_NORMAL,
	VALIDE_DOCUMENT_STATE_EXTERNALLY_MODIFIED,
	VALIDE_DOCUMENT_STATE_BAD_ENCODING,
	VALIDE_DOCUMENT_STATE_INFO
} ValideDocumentState;

struct _ValideiDocumentIface {
	GTypeInterface parent_iface;
	void (*open) (ValideiDocument* self, const char* path, GError** error);
	void (*save) (ValideiDocument* self, const char* current_folder);
	void (*save_as) (ValideiDocument* self, const char* current_folder);
	void (*rename) (ValideiDocument* self);
	gboolean (*close) (ValideiDocument* self);
	GdkPixbuf* (*get_icon) (ValideiDocument* self);
	char* (*get_tooltips) (ValideiDocument* self);
	void (*setup_ui) (ValideiDocument* self, ValideUIManager* ui_manager);
	ValideDocumentState (*get_state) (ValideiDocument* self);
	void (*set_state) (ValideiDocument* self, ValideDocumentState value);
	gboolean (*get_is_save) (ValideiDocument* self);
	void (*set_is_save) (ValideiDocument* self, gboolean value);
	const char* (*get_path) (ValideiDocument* self);
	void (*set_path) (ValideiDocument* self, const char* value);
	const char* (*get_title) (ValideiDocument* self);
	const char* (*get_filename) (ValideiDocument* self);
};



GType valide_document_state_get_type (void);
GType valide_ui_manager_get_type (void);
GType valide_idocument_get_type (void);
void valide_idocument_open (ValideiDocument* self, const char* path, GError** error);
static void valide_idocument_real_open (ValideiDocument* self, const char* path, GError** error);
void valide_idocument_save (ValideiDocument* self, const char* current_folder);
static void valide_idocument_real_save (ValideiDocument* self, const char* current_folder);
void valide_idocument_save_as (ValideiDocument* self, const char* current_folder);
static void valide_idocument_real_save_as (ValideiDocument* self, const char* current_folder);
void valide_idocument_rename (ValideiDocument* self);
static void valide_idocument_real_rename (ValideiDocument* self);
gboolean valide_idocument_close (ValideiDocument* self);
static gboolean valide_idocument_real_close (ValideiDocument* self);
GdkPixbuf* valide_utils_get_pixbuf_for_stock (const char* stock_id, GtkIconSize size);
GdkPixbuf* valide_idocument_get_icon (ValideiDocument* self);
static GdkPixbuf* valide_idocument_real_get_icon (ValideiDocument* self);
char* valide_idocument_get_tooltips (ValideiDocument* self);
static char* valide_idocument_real_get_tooltips (ValideiDocument* self);
void valide_idocument_setup_ui (ValideiDocument* self, ValideUIManager* ui_manager);
static void valide_idocument_real_setup_ui (ValideiDocument* self, ValideUIManager* ui_manager);
ValideDocumentState valide_idocument_get_state (ValideiDocument* self);
void valide_idocument_set_state (ValideiDocument* self, ValideDocumentState value);
gboolean valide_idocument_get_is_save (ValideiDocument* self);
void valide_idocument_set_is_save (ValideiDocument* self, gboolean value);
const char* valide_idocument_get_path (ValideiDocument* self);
void valide_idocument_set_path (ValideiDocument* self, const char* value);
const char* valide_idocument_get_title (ValideiDocument* self);
const char* valide_idocument_get_filename (ValideiDocument* self);




GType valide_document_state_get_type (void) {
	static GType valide_document_state_type_id = 0;
	if (G_UNLIKELY (valide_document_state_type_id == 0)) {
		static const GEnumValue values[] = {{VALIDE_DOCUMENT_STATE_NORMAL, "VALIDE_DOCUMENT_STATE_NORMAL", "normal"}, {VALIDE_DOCUMENT_STATE_EXTERNALLY_MODIFIED, "VALIDE_DOCUMENT_STATE_EXTERNALLY_MODIFIED", "externally-modified"}, {VALIDE_DOCUMENT_STATE_BAD_ENCODING, "VALIDE_DOCUMENT_STATE_BAD_ENCODING", "bad-encoding"}, {VALIDE_DOCUMENT_STATE_INFO, "VALIDE_DOCUMENT_STATE_INFO", "info"}, {0, NULL, NULL}};
		valide_document_state_type_id = g_enum_register_static ("ValideDocumentState", values);
	}
	return valide_document_state_type_id;
}


#line 103 "idocument.vala"
static void valide_idocument_real_open (ValideiDocument* self, const char* path, GError** error) {
#line 103 "idocument.vala"
	g_return_if_fail (path != NULL);
#line 105 "idocument.vala"
	g_debug ("idocument.vala:105: The class %s doesn't implement the iDocument.open function", g_type_name (G_TYPE_FROM_INSTANCE ((GObject*) self)));
#line 131 "idocument.c"
}


#line 103 "idocument.vala"
void valide_idocument_open (ValideiDocument* self, const char* path, GError** error) {
#line 103 "idocument.vala"
	VALIDE_IDOCUMENT_GET_INTERFACE (self)->open (self, path, error);
#line 139 "idocument.c"
}


#line 116 "idocument.vala"
static void valide_idocument_real_save (ValideiDocument* self, const char* current_folder) {
#line 118 "idocument.vala"
	g_debug ("idocument.vala:118: The class %s doesn't implement the iDocument.save function", g_type_name (G_TYPE_FROM_INSTANCE ((GObject*) self)));
#line 147 "idocument.c"
}


#line 116 "idocument.vala"
void valide_idocument_save (ValideiDocument* self, const char* current_folder) {
#line 116 "idocument.vala"
	VALIDE_IDOCUMENT_GET_INTERFACE (self)->save (self, current_folder);
#line 155 "idocument.c"
}


#line 127 "idocument.vala"
static void valide_idocument_real_save_as (ValideiDocument* self, const char* current_folder) {
#line 129 "idocument.vala"
	g_debug ("idocument.vala:129: The class %s doesn't implement the iDocument.save_as function", g_type_name (G_TYPE_FROM_INSTANCE ((GObject*) self)));
#line 163 "idocument.c"
}


#line 127 "idocument.vala"
void valide_idocument_save_as (ValideiDocument* self, const char* current_folder) {
#line 127 "idocument.vala"
	VALIDE_IDOCUMENT_GET_INTERFACE (self)->save_as (self, current_folder);
#line 171 "idocument.c"
}


#line 136 "idocument.vala"
static void valide_idocument_real_rename (ValideiDocument* self) {
#line 138 "idocument.vala"
	g_debug ("idocument.vala:138: The class %s doesn't implement the iDocument.rename function", g_type_name (G_TYPE_FROM_INSTANCE ((GObject*) self)));
#line 179 "idocument.c"
}


#line 136 "idocument.vala"
void valide_idocument_rename (ValideiDocument* self) {
#line 136 "idocument.vala"
	VALIDE_IDOCUMENT_GET_INTERFACE (self)->rename (self);
#line 187 "idocument.c"
}


#line 145 "idocument.vala"
static gboolean valide_idocument_real_close (ValideiDocument* self) {
#line 193 "idocument.c"
	gboolean result;
#line 147 "idocument.vala"
	g_debug ("idocument.vala:147: The class %s doesn't implement the iDocument.close function", g_type_name (G_TYPE_FROM_INSTANCE ((GObject*) self)));
#line 197 "idocument.c"
	result = FALSE;
#line 149 "idocument.vala"
	return result;
#line 201 "idocument.c"
}


#line 145 "idocument.vala"
gboolean valide_idocument_close (ValideiDocument* self) {
#line 145 "idocument.vala"
	return VALIDE_IDOCUMENT_GET_INTERFACE (self)->close (self);
#line 209 "idocument.c"
}


#line 157 "idocument.vala"
static GdkPixbuf* valide_idocument_real_get_icon (ValideiDocument* self) {
#line 215 "idocument.c"
	GdkPixbuf* result;
#line 159 "idocument.vala"
	g_debug ("idocument.vala:159: The class %s doesn't implement the iDocument.get_icon function", g_type_name (G_TYPE_FROM_INSTANCE ((GObject*) self)));
#line 219 "idocument.c"
	result = valide_utils_get_pixbuf_for_stock (GTK_STOCK_FILE, GTK_ICON_SIZE_MENU);
#line 161 "idocument.vala"
	return result;
#line 223 "idocument.c"
}


#line 157 "idocument.vala"
GdkPixbuf* valide_idocument_get_icon (ValideiDocument* self) {
#line 157 "idocument.vala"
	return VALIDE_IDOCUMENT_GET_INTERFACE (self)->get_icon (self);
#line 231 "idocument.c"
}


#line 169 "idocument.vala"
static char* valide_idocument_real_get_tooltips (ValideiDocument* self) {
#line 237 "idocument.c"
	char* result;
#line 171 "idocument.vala"
	g_debug ("idocument.vala:171: The class %s doesn't implement the iDocument.get_tooltips function", g_type_name (G_TYPE_FROM_INSTANCE ((GObject*) self)));
#line 241 "idocument.c"
	result = g_strdup ("");
#line 173 "idocument.vala"
	return result;
#line 245 "idocument.c"
}


#line 169 "idocument.vala"
char* valide_idocument_get_tooltips (ValideiDocument* self) {
#line 169 "idocument.vala"
	return VALIDE_IDOCUMENT_GET_INTERFACE (self)->get_tooltips (self);
#line 253 "idocument.c"
}


#line 181 "idocument.vala"
static void valide_idocument_real_setup_ui (ValideiDocument* self, ValideUIManager* ui_manager) {
#line 181 "idocument.vala"
	g_return_if_fail (ui_manager != NULL);
#line 183 "idocument.vala"
	g_debug ("idocument.vala:183: The class %s doesn't implement the iDocument.setup_ui function", g_type_name (G_TYPE_FROM_INSTANCE ((GObject*) self)));
#line 263 "idocument.c"
}


#line 181 "idocument.vala"
void valide_idocument_setup_ui (ValideiDocument* self, ValideUIManager* ui_manager) {
#line 181 "idocument.vala"
	VALIDE_IDOCUMENT_GET_INTERFACE (self)->setup_ui (self, ui_manager);
#line 271 "idocument.c"
}


ValideDocumentState valide_idocument_get_state (ValideiDocument* self) {
	return VALIDE_IDOCUMENT_GET_INTERFACE (self)->get_state (self);
}


void valide_idocument_set_state (ValideiDocument* self, ValideDocumentState value) {
	VALIDE_IDOCUMENT_GET_INTERFACE (self)->set_state (self, value);
}


gboolean valide_idocument_get_is_save (ValideiDocument* self) {
	return VALIDE_IDOCUMENT_GET_INTERFACE (self)->get_is_save (self);
}


void valide_idocument_set_is_save (ValideiDocument* self, gboolean value) {
	VALIDE_IDOCUMENT_GET_INTERFACE (self)->set_is_save (self, value);
}


const char* valide_idocument_get_path (ValideiDocument* self) {
	return VALIDE_IDOCUMENT_GET_INTERFACE (self)->get_path (self);
}


void valide_idocument_set_path (ValideiDocument* self, const char* value) {
	VALIDE_IDOCUMENT_GET_INTERFACE (self)->set_path (self, value);
}


const char* valide_idocument_get_title (ValideiDocument* self) {
	return VALIDE_IDOCUMENT_GET_INTERFACE (self)->get_title (self);
}


const char* valide_idocument_get_filename (ValideiDocument* self) {
	return VALIDE_IDOCUMENT_GET_INTERFACE (self)->get_filename (self);
}


static void valide_idocument_base_init (ValideiDocumentIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
		g_object_interface_install_property (iface, g_param_spec_enum ("state", "state", "state", VALIDE_TYPE_DOCUMENT_STATE, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_boolean ("is-save", "is-save", "is-save", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_string ("path", "path", "path", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
		g_object_interface_install_property (iface, g_param_spec_string ("filename", "filename", "filename", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
		g_signal_new ("saved", VALIDE_TYPE_IDOCUMENT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
		g_signal_new ("closed", VALIDE_TYPE_IDOCUMENT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
		g_signal_new ("title_change", VALIDE_TYPE_IDOCUMENT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
		g_signal_new ("state_change", VALIDE_TYPE_IDOCUMENT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__ENUM, G_TYPE_NONE, 1, VALIDE_TYPE_DOCUMENT_STATE);
	}
	iface->open = valide_idocument_real_open;
	iface->save = valide_idocument_real_save;
	iface->save_as = valide_idocument_real_save_as;
	iface->rename = valide_idocument_real_rename;
	iface->close = valide_idocument_real_close;
	iface->get_icon = valide_idocument_real_get_icon;
	iface->get_tooltips = valide_idocument_real_get_tooltips;
	iface->setup_ui = valide_idocument_real_setup_ui;
}


GType valide_idocument_get_type (void) {
	static GType valide_idocument_type_id = 0;
	if (valide_idocument_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValideiDocumentIface), (GBaseInitFunc) valide_idocument_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		valide_idocument_type_id = g_type_register_static (G_TYPE_INTERFACE, "ValideiDocument", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (valide_idocument_type_id, GTK_TYPE_WIDGET);
	}
	return valide_idocument_type_id;
}




