/* buildable.c generated by valac, the Vala compiler
 * generated from buildable.vala, do not modify */

/* ************
 *
 * Copyright (C) 2009  Yu Feng
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to 
 *
 * the Free Software Foundation, Inc., 
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Yu Feng <rainwoodman@gmail.com>
 * 
 * This work is sponsed by C.Y Liu at Indiana University Cyclotron Facility.
 *
 ***/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>


#define G_YAML_TYPE_BUILDABLE (g_yaml_buildable_get_type ())
#define G_YAML_BUILDABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_YAML_TYPE_BUILDABLE, GYAMLBuildable))
#define G_YAML_IS_BUILDABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_YAML_TYPE_BUILDABLE))
#define G_YAML_BUILDABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), G_YAML_TYPE_BUILDABLE, GYAMLBuildableIface))

typedef struct _GYAMLBuildable GYAMLBuildable;
typedef struct _GYAMLBuildableIface GYAMLBuildableIface;

#define G_YAML_TYPE_BUILDER (g_yaml_builder_get_type ())
#define G_YAML_BUILDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_YAML_TYPE_BUILDER, GYAMLBuilder))
#define G_YAML_BUILDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), G_YAML_TYPE_BUILDER, GYAMLBuilderClass))
#define G_YAML_IS_BUILDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_YAML_TYPE_BUILDER))
#define G_YAML_IS_BUILDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), G_YAML_TYPE_BUILDER))
#define G_YAML_BUILDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), G_YAML_TYPE_BUILDER, GYAMLBuilderClass))

typedef struct _GYAMLBuilder GYAMLBuilder;
typedef struct _GYAMLBuilderClass GYAMLBuilderClass;

#define G_YAML_TYPE_NODE (g_yaml_node_get_type ())
#define G_YAML_NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_YAML_TYPE_NODE, GYAMLNode))
#define G_YAML_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), G_YAML_TYPE_NODE, GYAMLNodeClass))
#define G_YAML_IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_YAML_TYPE_NODE))
#define G_YAML_IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), G_YAML_TYPE_NODE))
#define G_YAML_NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), G_YAML_TYPE_NODE, GYAMLNodeClass))

typedef struct _GYAMLNode GYAMLNode;
typedef struct _GYAMLNodeClass GYAMLNodeClass;

struct _GYAMLBuildableIface {
	GTypeInterface parent_iface;
	const char* (*get_name) (GYAMLBuildable* self);
	void (*set_name) (GYAMLBuildable* self, const char* name);
	void (*add_child) (GYAMLBuildable* self, GYAMLBuilder* builder, GObject* child, const char* type, GError** error);
	char** (*get_child_tags) (GYAMLBuildable* self, int* result_length1);
	GType* (*get_child_types) (GYAMLBuildable* self, int* result_length1);
	GList* (*get_children) (GYAMLBuildable* self, const char* type);
	GObject* (*get_internal_child) (GYAMLBuildable* self, GYAMLBuilder* builder, const char* child_name);
	void (*custom_node) (GYAMLBuildable* self, GYAMLBuilder* builder, const char* tag, GYAMLNode* node, GError** error);
};

typedef enum  {
	G_YAML_ERROR_SYMBOL_NOT_FOUND,
	G_YAML_ERROR_TYPE_NOT_FOUND,
	G_YAML_ERROR_NOT_A_BUILDABLE,
	G_YAML_ERROR_PROPERTY_NOT_FOUND,
	G_YAML_ERROR_OBJECT_NOT_FOUND,
	G_YAML_ERROR_UNKNOWN_PROPERTY_TYPE,
	G_YAML_ERROR_CUSTOM_NODE_ERROR,
	G_YAML_ERROR_UNEXPECTED_NODE,
	G_YAML_ERROR_NOT_IMPLEMENTED,
	G_YAML_ERROR_FILE_NOT_FOUND,
	G_YAML_ERROR_PARSER_ERROR,
	G_YAML_ERROR_UNRESOLVED_ALIAS
} GYAMLError;
#define G_YAML_ERROR g_yaml_error_quark ()


GType g_yaml_builder_get_type (void);
gpointer g_yaml_node_ref (gpointer instance);
void g_yaml_node_unref (gpointer instance);
GParamSpec* g_yaml_param_spec_node (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void g_yaml_value_set_node (GValue* value, gpointer v_object);
gpointer g_yaml_value_get_node (const GValue* value);
GType g_yaml_node_get_type (void);
GType g_yaml_buildable_get_type (void);
const char* g_yaml_buildable_get_name (GYAMLBuildable* self);
static const char* g_yaml_buildable_real_get_name (GYAMLBuildable* self);
void g_yaml_buildable_set_name (GYAMLBuildable* self, const char* name);
static void g_yaml_buildable_real_set_name (GYAMLBuildable* self, const char* name);
void g_yaml_buildable_add_child (GYAMLBuildable* self, GYAMLBuilder* builder, GObject* child, const char* type, GError** error);
static void g_yaml_buildable_real_add_child (GYAMLBuildable* self, GYAMLBuilder* builder, GObject* child, const char* type, GError** error);
char** g_yaml_buildable_get_child_tags (GYAMLBuildable* self, int* result_length1);
static char** g_yaml_buildable_real_get_child_tags (GYAMLBuildable* self, int* result_length1);
GType* g_yaml_buildable_get_child_types (GYAMLBuildable* self, int* result_length1);
static GType* g_yaml_buildable_real_get_child_types (GYAMLBuildable* self, int* result_length1);
GList* g_yaml_buildable_get_children (GYAMLBuildable* self, const char* type);
static GList* g_yaml_buildable_real_get_children (GYAMLBuildable* self, const char* type);
GObject* g_yaml_buildable_get_internal_child (GYAMLBuildable* self, GYAMLBuilder* builder, const char* child_name);
static GObject* g_yaml_buildable_real_get_internal_child (GYAMLBuildable* self, GYAMLBuilder* builder, const char* child_name);
GType g_yaml_buildable_get_child_type (GYAMLBuildable* self, GYAMLBuilder* builder, const char* tag);
GQuark g_yaml_error_quark (void);
void g_yaml_buildable_custom_node (GYAMLBuildable* self, GYAMLBuilder* builder, const char* tag, GYAMLNode* node, GError** error);
static void g_yaml_buildable_real_custom_node (GYAMLBuildable* self, GYAMLBuilder* builder, const char* tag, GYAMLNode* node, GError** error);
static int _vala_strcmp0 (const char * str1, const char * str2);



#line 46 "buildable.vala"
static const char* g_yaml_buildable_real_get_name (GYAMLBuildable* self) {
#line 127 "buildable.c"
	const char* result;
	result = (const char*) g_object_get_data ((GObject*) self, "buildable-name");
#line 47 "buildable.vala"
	return result;
#line 132 "buildable.c"
}


#line 46 "buildable.vala"
const char* g_yaml_buildable_get_name (GYAMLBuildable* self) {
#line 46 "buildable.vala"
	return G_YAML_BUILDABLE_GET_INTERFACE (self)->get_name (self);
#line 140 "buildable.c"
}


#line 54 "buildable.vala"
static void g_yaml_buildable_real_set_name (GYAMLBuildable* self, const char* name) {
#line 55 "buildable.vala"
	if (name != NULL) {
#line 56 "buildable.vala"
		g_object_set_data_full ((GObject*) self, "buildable-name", g_memdup (name, (guint) (((gint) strlen (name)) + 1)), g_free);
#line 150 "buildable.c"
	} else {
#line 58 "buildable.vala"
		g_object_set_data ((GObject*) self, "buildable-name", NULL);
#line 154 "buildable.c"
	}
}


#line 54 "buildable.vala"
void g_yaml_buildable_set_name (GYAMLBuildable* self, const char* name) {
#line 54 "buildable.vala"
	G_YAML_BUILDABLE_GET_INTERFACE (self)->set_name (self, name);
#line 163 "buildable.c"
}


#line 69 "buildable.vala"
static void g_yaml_buildable_real_add_child (GYAMLBuildable* self, GYAMLBuilder* builder, GObject* child, const char* type, GError** error) {
#line 169 "buildable.c"
	GObject* _tmp0_;
#line 69 "buildable.vala"
	g_return_if_fail (builder != NULL);
#line 69 "buildable.vala"
	g_return_if_fail (child != NULL);
#line 70 "buildable.vala"
	g_debug ("buildable.vala:70: Adding %s to %s", g_yaml_buildable_get_name ((_tmp0_ = child, G_YAML_IS_BUILDABLE (_tmp0_) ? ((GYAMLBuildable*) _tmp0_) : NULL)), g_yaml_buildable_get_name (self));
#line 177 "buildable.c"
}


#line 69 "buildable.vala"
void g_yaml_buildable_add_child (GYAMLBuildable* self, GYAMLBuilder* builder, GObject* child, const char* type, GError** error) {
#line 69 "buildable.vala"
	G_YAML_BUILDABLE_GET_INTERFACE (self)->add_child (self, builder, child, type, error);
#line 185 "buildable.c"
}


#line 77 "buildable.vala"
static char** g_yaml_buildable_real_get_child_tags (GYAMLBuildable* self, int* result_length1) {
#line 191 "buildable.c"
	char** result;
	gpointer _tmp0_;
	result = (_tmp0_ = NULL, *result_length1 = 0, _tmp0_);
#line 78 "buildable.vala"
	return result;
#line 197 "buildable.c"
}


#line 77 "buildable.vala"
char** g_yaml_buildable_get_child_tags (GYAMLBuildable* self, int* result_length1) {
#line 77 "buildable.vala"
	return G_YAML_BUILDABLE_GET_INTERFACE (self)->get_child_tags (self, result_length1);
#line 205 "buildable.c"
}


#line 81 "buildable.vala"
static GType* g_yaml_buildable_real_get_child_types (GYAMLBuildable* self, int* result_length1) {
#line 211 "buildable.c"
	GType* result;
	gpointer _tmp0_;
	result = (_tmp0_ = NULL, *result_length1 = 0, _tmp0_);
#line 82 "buildable.vala"
	return result;
#line 217 "buildable.c"
}


#line 81 "buildable.vala"
GType* g_yaml_buildable_get_child_types (GYAMLBuildable* self, int* result_length1) {
#line 81 "buildable.vala"
	return G_YAML_BUILDABLE_GET_INTERFACE (self)->get_child_types (self, result_length1);
#line 225 "buildable.c"
}


#line 92 "buildable.vala"
static GList* g_yaml_buildable_real_get_children (GYAMLBuildable* self, const char* type) {
#line 231 "buildable.c"
	GList* result;
	result = NULL;
#line 93 "buildable.vala"
	return result;
#line 236 "buildable.c"
}


#line 92 "buildable.vala"
GList* g_yaml_buildable_get_children (GYAMLBuildable* self, const char* type) {
#line 92 "buildable.vala"
	return G_YAML_BUILDABLE_GET_INTERFACE (self)->get_children (self, type);
#line 244 "buildable.c"
}


#line 102 "buildable.vala"
static GObject* g_yaml_buildable_real_get_internal_child (GYAMLBuildable* self, GYAMLBuilder* builder, const char* child_name) {
#line 250 "buildable.c"
	GObject* result;
#line 102 "buildable.vala"
	g_return_val_if_fail (builder != NULL, NULL);
#line 102 "buildable.vala"
	g_return_val_if_fail (child_name != NULL, NULL);
#line 256 "buildable.c"
	result = NULL;
#line 103 "buildable.vala"
	return result;
#line 260 "buildable.c"
}


#line 102 "buildable.vala"
GObject* g_yaml_buildable_get_internal_child (GYAMLBuildable* self, GYAMLBuilder* builder, const char* child_name) {
#line 102 "buildable.vala"
	return G_YAML_BUILDABLE_GET_INTERFACE (self)->get_internal_child (self, builder, child_name);
#line 268 "buildable.c"
}


#line 115 "buildable.vala"
GType g_yaml_buildable_get_child_type (GYAMLBuildable* self, GYAMLBuilder* builder, const char* tag) {
#line 274 "buildable.c"
	GType result;
	char** _tmp1_;
	gint tags_size;
	gint tags_length1;
	gint _tmp0_;
	char** tags;
	GType* _tmp3_;
	gint types_size;
	gint types_length1;
	gint _tmp2_;
	GType* types;
#line 115 "buildable.vala"
	g_return_val_if_fail (builder != NULL, 0UL);
#line 115 "buildable.vala"
	g_return_val_if_fail (tag != NULL, 0UL);
#line 290 "buildable.c"
	tags = (_tmp1_ = g_yaml_buildable_get_child_tags (self, &_tmp0_), tags_length1 = _tmp0_, tags_size = tags_length1, _tmp1_);
	types = (_tmp3_ = g_yaml_buildable_get_child_types (self, &_tmp2_), types_length1 = _tmp2_, types_size = types_length1, _tmp3_);
#line 119 "buildable.vala"
	g_assert (types_length1 == tags_length1);
#line 120 "buildable.vala"
	if (tags == NULL) {
#line 297 "buildable.c"
		result = G_TYPE_INVALID;
#line 120 "buildable.vala"
		return result;
#line 301 "buildable.c"
	}
	{
		gint i;
#line 121 "buildable.vala"
		i = 0;
#line 307 "buildable.c"
		{
			gboolean _tmp4_;
#line 121 "buildable.vala"
			_tmp4_ = TRUE;
#line 121 "buildable.vala"
			while (TRUE) {
#line 121 "buildable.vala"
				if (!_tmp4_) {
#line 121 "buildable.vala"
					i++;
#line 318 "buildable.c"
				}
#line 121 "buildable.vala"
				_tmp4_ = FALSE;
#line 121 "buildable.vala"
				if (!(i < tags_length1)) {
#line 121 "buildable.vala"
					break;
#line 326 "buildable.c"
				}
#line 122 "buildable.vala"
				if (_vala_strcmp0 (tags[i], tag) == 0) {
#line 330 "buildable.c"
					result = types[i];
#line 123 "buildable.vala"
					return result;
#line 334 "buildable.c"
				}
			}
		}
	}
	result = G_TYPE_INVALID;
#line 126 "buildable.vala"
	return result;
#line 342 "buildable.c"
}


#line 135 "buildable.vala"
static void g_yaml_buildable_real_custom_node (GYAMLBuildable* self, GYAMLBuilder* builder, const char* tag, GYAMLNode* node, GError** error) {
#line 348 "buildable.c"
	GError * _inner_error_;
#line 135 "buildable.vala"
	g_return_if_fail (builder != NULL);
#line 135 "buildable.vala"
	g_return_if_fail (tag != NULL);
#line 135 "buildable.vala"
	g_return_if_fail (node != NULL);
#line 356 "buildable.c"
	_inner_error_ = NULL;
	_inner_error_ = g_error_new (G_YAML_ERROR, G_YAML_ERROR_PROPERTY_NOT_FOUND, "Property %s.%s not found", g_type_name (G_TYPE_FROM_INSTANCE ((GObject*) self)), tag);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
}


#line 135 "buildable.vala"
void g_yaml_buildable_custom_node (GYAMLBuildable* self, GYAMLBuilder* builder, const char* tag, GYAMLNode* node, GError** error) {
#line 135 "buildable.vala"
	G_YAML_BUILDABLE_GET_INTERFACE (self)->custom_node (self, builder, tag, node, error);
#line 370 "buildable.c"
}


static void g_yaml_buildable_base_init (GYAMLBuildableIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
	iface->get_name = g_yaml_buildable_real_get_name;
	iface->set_name = g_yaml_buildable_real_set_name;
	iface->add_child = g_yaml_buildable_real_add_child;
	iface->get_child_tags = g_yaml_buildable_real_get_child_tags;
	iface->get_child_types = g_yaml_buildable_real_get_child_types;
	iface->get_children = g_yaml_buildable_real_get_children;
	iface->get_internal_child = g_yaml_buildable_real_get_internal_child;
	iface->custom_node = g_yaml_buildable_real_custom_node;
}


GType g_yaml_buildable_get_type (void) {
	static GType g_yaml_buildable_type_id = 0;
	if (g_yaml_buildable_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (GYAMLBuildableIface), (GBaseInitFunc) g_yaml_buildable_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		g_yaml_buildable_type_id = g_type_register_static (G_TYPE_INTERFACE, "GYAMLBuildable", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (g_yaml_buildable_type_id, G_TYPE_OBJECT);
	}
	return g_yaml_buildable_type_id;
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




