/* split-source-view.c generated by valac, the Vala compiler
 * generated from split-source-view.vala, do not modify */

/* split-source-view.vala
 *
 * Copyright (C) 2008-2009  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <nicolas.joseph@valaide.org>
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gtksourceview/gtksourceview.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>


#define VALIDE_TYPE_SPLIT_SOURCE_VIEW (valide_split_source_view_get_type ())
#define VALIDE_SPLIT_SOURCE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_SPLIT_SOURCE_VIEW, ValideSplitSourceView))
#define VALIDE_SPLIT_SOURCE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_SPLIT_SOURCE_VIEW, ValideSplitSourceViewClass))
#define VALIDE_IS_SPLIT_SOURCE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_SPLIT_SOURCE_VIEW))
#define VALIDE_IS_SPLIT_SOURCE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_SPLIT_SOURCE_VIEW))
#define VALIDE_SPLIT_SOURCE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_SPLIT_SOURCE_VIEW, ValideSplitSourceViewClass))

typedef struct _ValideSplitSourceView ValideSplitSourceView;
typedef struct _ValideSplitSourceViewClass ValideSplitSourceViewClass;
typedef struct _ValideSplitSourceViewPrivate ValideSplitSourceViewPrivate;

#define VALIDE_TYPE_SOURCE_VIEW (valide_source_view_get_type ())
#define VALIDE_SOURCE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_SOURCE_VIEW, ValideSourceView))
#define VALIDE_SOURCE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_SOURCE_VIEW, ValideSourceViewClass))
#define VALIDE_IS_SOURCE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_SOURCE_VIEW))
#define VALIDE_IS_SOURCE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_SOURCE_VIEW))
#define VALIDE_SOURCE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_SOURCE_VIEW, ValideSourceViewClass))

typedef struct _ValideSourceView ValideSourceView;
typedef struct _ValideSourceViewClass ValideSourceViewClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define VALIDE_TYPE_SOURCE_BUFFER (valide_source_buffer_get_type ())
#define VALIDE_SOURCE_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_SOURCE_BUFFER, ValideSourceBuffer))
#define VALIDE_SOURCE_BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_SOURCE_BUFFER, ValideSourceBufferClass))
#define VALIDE_IS_SOURCE_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_SOURCE_BUFFER))
#define VALIDE_IS_SOURCE_BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_SOURCE_BUFFER))
#define VALIDE_SOURCE_BUFFER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_SOURCE_BUFFER, ValideSourceBufferClass))

typedef struct _ValideSourceBuffer ValideSourceBuffer;
typedef struct _ValideSourceBufferClass ValideSourceBufferClass;

struct _ValideSplitSourceView {
	GtkVPaned parent_instance;
	ValideSplitSourceViewPrivate * priv;
};

struct _ValideSplitSourceViewClass {
	GtkVPanedClass parent_class;
};

struct _ValideSplitSourceViewPrivate {
	ValideSourceView* last_active;
	char* _language;
	ValideSourceView* _view1;
	ValideSourceView* _view2;
};


static gpointer valide_split_source_view_parent_class = NULL;

GType valide_split_source_view_get_type (void);
GType valide_source_view_get_type (void);
#define VALIDE_SPLIT_SOURCE_VIEW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALIDE_TYPE_SPLIT_SOURCE_VIEW, ValideSplitSourceViewPrivate))
enum  {
	VALIDE_SPLIT_SOURCE_VIEW_DUMMY_PROPERTY,
	VALIDE_SPLIT_SOURCE_VIEW_RIGHT_MARGIN_POSITION,
	VALIDE_SPLIT_SOURCE_VIEW_SHOW_RIGHT_MARGIN,
	VALIDE_SPLIT_SOURCE_VIEW_SHOW_LINE_NUMBERS,
	VALIDE_SPLIT_SOURCE_VIEW_AUTO_INDENT,
	VALIDE_SPLIT_SOURCE_VIEW_HIGHLIGHT_CURRENT_LINE,
	VALIDE_SPLIT_SOURCE_VIEW_INDENT_ON_TAB,
	VALIDE_SPLIT_SOURCE_VIEW_INSERT_SPACES_INSTEAD_OF_TABS,
	VALIDE_SPLIT_SOURCE_VIEW_TAB_WIDTH,
	VALIDE_SPLIT_SOURCE_VIEW_LANGUAGE,
	VALIDE_SPLIT_SOURCE_VIEW_ACTIVE_VIEW
};
static gboolean valide_split_source_view_focus_in_event_cb (ValideSplitSourceView* self, GtkWidget* sender, GdkEventFocus* event);
ValideSplitSourceView* valide_split_source_view_new (const char* language);
ValideSplitSourceView* valide_split_source_view_construct (GType object_type, const char* language);
static ValideSourceView* valide_split_source_view_get_view1 (ValideSplitSourceView* self);
static ValideSourceView* valide_split_source_view_get_view2 (ValideSplitSourceView* self);
void valide_split_source_view_set_editable (ValideSplitSourceView* self, gboolean setting);
guint valide_split_source_view_get_right_margin_position (ValideSplitSourceView* self);
void valide_split_source_view_set_right_margin_position (ValideSplitSourceView* self, guint value);
gboolean valide_split_source_view_get_show_right_margin (ValideSplitSourceView* self);
void valide_split_source_view_set_show_right_margin (ValideSplitSourceView* self, gboolean value);
gboolean valide_split_source_view_get_show_line_numbers (ValideSplitSourceView* self);
void valide_split_source_view_set_show_line_numbers (ValideSplitSourceView* self, gboolean value);
gboolean valide_split_source_view_get_auto_indent (ValideSplitSourceView* self);
void valide_split_source_view_set_auto_indent (ValideSplitSourceView* self, gboolean value);
gboolean valide_split_source_view_get_highlight_current_line (ValideSplitSourceView* self);
void valide_split_source_view_set_highlight_current_line (ValideSplitSourceView* self, gboolean value);
gboolean valide_split_source_view_get_indent_on_tab (ValideSplitSourceView* self);
void valide_split_source_view_set_indent_on_tab (ValideSplitSourceView* self, gboolean value);
gboolean valide_split_source_view_get_insert_spaces_instead_of_tabs (ValideSplitSourceView* self);
void valide_split_source_view_set_insert_spaces_instead_of_tabs (ValideSplitSourceView* self, gboolean value);
guint valide_split_source_view_get_tab_width (ValideSplitSourceView* self);
void valide_split_source_view_set_tab_width (ValideSplitSourceView* self, guint value);
const char* valide_split_source_view_get_language (ValideSplitSourceView* self);
static void valide_split_source_view_set_language (ValideSplitSourceView* self, const char* value);
ValideSourceView* valide_split_source_view_get_active_view (ValideSplitSourceView* self);
static void valide_split_source_view_set_view1 (ValideSplitSourceView* self, ValideSourceView* value);
static void valide_split_source_view_set_view2 (ValideSplitSourceView* self, ValideSourceView* value);
ValideSourceView* valide_source_view_new (const char* language);
ValideSourceView* valide_source_view_construct (GType object_type, const char* language);
static gboolean _valide_split_source_view_focus_in_event_cb_gtk_widget_focus_in_event (GtkWidget* _sender, GdkEventFocus* event, gpointer self);
GType valide_source_buffer_get_type (void);
ValideSourceBuffer* valide_source_view_get_buffer (ValideSourceView* self);
void valide_source_view_set_buffer (ValideSourceView* self, ValideSourceBuffer* value);
static gboolean _lambda5_ (GtkWidget* s, GdkEventKey* e, ValideSplitSourceView* self);
static gboolean __lambda5__gtk_widget_key_press_event (GtkWidget* _sender, GdkEventKey* event, gpointer self);
static gboolean _lambda6_ (GtkWidget* s, GdkEventKey* e, ValideSplitSourceView* self);
static gboolean __lambda6__gtk_widget_key_press_event (GtkWidget* _sender, GdkEventKey* event, gpointer self);
static gboolean _lambda7_ (GtkWidget* s, GdkEventFocus* e, ValideSplitSourceView* self);
static gboolean __lambda7__gtk_widget_focus_out_event (GtkWidget* _sender, GdkEventFocus* event, gpointer self);
static gboolean _lambda8_ (GtkWidget* s, GdkEventFocus* e, ValideSplitSourceView* self);
static gboolean __lambda8__gtk_widget_focus_out_event (GtkWidget* _sender, GdkEventFocus* event, gpointer self);
static gboolean _lambda9_ (GtkWidget* s, GdkEventButton* e, ValideSplitSourceView* self);
static gboolean __lambda9__gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static gboolean _lambda10_ (GtkWidget* s, GdkEventButton* e, ValideSplitSourceView* self);
static gboolean __lambda10__gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static void _lambda11_ (ValideSourceView* s, ValideSplitSourceView* self);
static void __lambda11__valide_source_view_search (ValideSourceView* _sender, gpointer self);
static void _lambda12_ (ValideSourceView* s, ValideSplitSourceView* self);
static void __lambda12__valide_source_view_search (ValideSourceView* _sender, gpointer self);
static void _lambda13_ (ValideSourceView* s, ValideSplitSourceView* self);
static void __lambda13__valide_source_view_find_next (ValideSourceView* _sender, gpointer self);
static void _lambda14_ (ValideSourceView* s, ValideSplitSourceView* self);
static void __lambda14__valide_source_view_find_next (ValideSourceView* _sender, gpointer self);
static void _lambda15_ (ValideSourceView* s, ValideSplitSourceView* self);
static void __lambda15__valide_source_view_find_prev (ValideSourceView* _sender, gpointer self);
static void _lambda16_ (ValideSourceView* s, ValideSplitSourceView* self);
static void __lambda16__valide_source_view_find_prev (ValideSourceView* _sender, gpointer self);
static void _lambda17_ (ValideSourceView* s, ValideSplitSourceView* self);
static void __lambda17__valide_source_view_replace (ValideSourceView* _sender, gpointer self);
static void _lambda18_ (ValideSourceView* s, ValideSplitSourceView* self);
static void __lambda18__valide_source_view_replace (ValideSourceView* _sender, gpointer self);
static GObject * valide_split_source_view_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void valide_split_source_view_finalize (GObject* obj);
static void valide_split_source_view_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void valide_split_source_view_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);



#line 207 "split-source-view.vala"
static gboolean valide_split_source_view_focus_in_event_cb (ValideSplitSourceView* self, GtkWidget* sender, GdkEventFocus* event) {
#line 173 "split-source-view.c"
	gboolean result;
	GtkWidget* _tmp0_;
#line 207 "split-source-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 207 "split-source-view.vala"
	g_return_val_if_fail (sender != NULL, FALSE);
#line 209 "split-source-view.vala"
	self->priv->last_active = (_tmp0_ = sender, VALIDE_IS_SOURCE_VIEW (_tmp0_) ? ((ValideSourceView*) _tmp0_) : NULL);
#line 182 "split-source-view.c"
	result = FALSE;
#line 210 "split-source-view.vala"
	return result;
#line 186 "split-source-view.c"
}


#line 218 "split-source-view.vala"
ValideSplitSourceView* valide_split_source_view_construct (GType object_type, const char* language) {
#line 192 "split-source-view.c"
	ValideSplitSourceView * self;
#line 218 "split-source-view.vala"
	g_return_val_if_fail (language != NULL, NULL);
#line 220 "split-source-view.vala"
	self = (ValideSplitSourceView*) g_object_new (object_type, "language", language, NULL);
#line 198 "split-source-view.c"
	return self;
}


#line 218 "split-source-view.vala"
ValideSplitSourceView* valide_split_source_view_new (const char* language) {
#line 218 "split-source-view.vala"
	return valide_split_source_view_construct (VALIDE_TYPE_SPLIT_SOURCE_VIEW, language);
#line 207 "split-source-view.c"
}


#line 268 "split-source-view.vala"
void valide_split_source_view_set_editable (ValideSplitSourceView* self, gboolean setting) {
#line 268 "split-source-view.vala"
	g_return_if_fail (self != NULL);
#line 270 "split-source-view.vala"
	gtk_text_view_set_editable ((GtkTextView*) self->priv->_view1, setting);
#line 271 "split-source-view.vala"
	gtk_text_view_set_editable ((GtkTextView*) self->priv->_view2, setting);
#line 219 "split-source-view.c"
}


guint valide_split_source_view_get_right_margin_position (ValideSplitSourceView* self) {
	guint result;
	g_return_val_if_fail (self != NULL, 0U);
	result = gtk_source_view_get_right_margin_position ((GtkSourceView*) self->priv->_view1);
#line 41 "split-source-view.vala"
	return result;
#line 229 "split-source-view.c"
}


void valide_split_source_view_set_right_margin_position (ValideSplitSourceView* self, guint value) {
	g_return_if_fail (self != NULL);
#line 45 "split-source-view.vala"
	gtk_source_view_set_right_margin_position ((GtkSourceView*) self->priv->_view1, value);
#line 46 "split-source-view.vala"
	gtk_source_view_set_right_margin_position ((GtkSourceView*) self->priv->_view2, value);
#line 239 "split-source-view.c"
	g_object_notify ((GObject *) self, "right-margin-position");
}


gboolean valide_split_source_view_get_show_right_margin (ValideSplitSourceView* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = gtk_source_view_get_show_right_margin ((GtkSourceView*) self->priv->_view1);
#line 57 "split-source-view.vala"
	return result;
#line 250 "split-source-view.c"
}


void valide_split_source_view_set_show_right_margin (ValideSplitSourceView* self, gboolean value) {
	g_return_if_fail (self != NULL);
#line 61 "split-source-view.vala"
	gtk_source_view_set_show_right_margin ((GtkSourceView*) self->priv->_view1, value);
#line 62 "split-source-view.vala"
	gtk_source_view_set_show_right_margin ((GtkSourceView*) self->priv->_view2, value);
#line 260 "split-source-view.c"
	g_object_notify ((GObject *) self, "show-right-margin");
}


gboolean valide_split_source_view_get_show_line_numbers (ValideSplitSourceView* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = gtk_source_view_get_show_line_numbers ((GtkSourceView*) self->priv->_view1);
#line 73 "split-source-view.vala"
	return result;
#line 271 "split-source-view.c"
}


void valide_split_source_view_set_show_line_numbers (ValideSplitSourceView* self, gboolean value) {
	g_return_if_fail (self != NULL);
#line 77 "split-source-view.vala"
	gtk_source_view_set_show_line_numbers ((GtkSourceView*) self->priv->_view1, value);
#line 78 "split-source-view.vala"
	gtk_source_view_set_show_line_numbers ((GtkSourceView*) self->priv->_view2, value);
#line 281 "split-source-view.c"
	g_object_notify ((GObject *) self, "show-line-numbers");
}


gboolean valide_split_source_view_get_auto_indent (ValideSplitSourceView* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = gtk_source_view_get_auto_indent ((GtkSourceView*) self->priv->_view1);
#line 89 "split-source-view.vala"
	return result;
#line 292 "split-source-view.c"
}


void valide_split_source_view_set_auto_indent (ValideSplitSourceView* self, gboolean value) {
	g_return_if_fail (self != NULL);
#line 93 "split-source-view.vala"
	gtk_source_view_set_auto_indent ((GtkSourceView*) self->priv->_view1, value);
#line 94 "split-source-view.vala"
	gtk_source_view_set_auto_indent ((GtkSourceView*) self->priv->_view2, value);
#line 302 "split-source-view.c"
	g_object_notify ((GObject *) self, "auto-indent");
}


gboolean valide_split_source_view_get_highlight_current_line (ValideSplitSourceView* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = gtk_source_view_get_highlight_current_line ((GtkSourceView*) self->priv->_view1);
#line 105 "split-source-view.vala"
	return result;
#line 313 "split-source-view.c"
}


void valide_split_source_view_set_highlight_current_line (ValideSplitSourceView* self, gboolean value) {
	g_return_if_fail (self != NULL);
#line 109 "split-source-view.vala"
	gtk_source_view_set_highlight_current_line ((GtkSourceView*) self->priv->_view1, value);
#line 110 "split-source-view.vala"
	gtk_source_view_set_highlight_current_line ((GtkSourceView*) self->priv->_view2, value);
#line 323 "split-source-view.c"
	g_object_notify ((GObject *) self, "highlight-current-line");
}


gboolean valide_split_source_view_get_indent_on_tab (ValideSplitSourceView* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = gtk_source_view_get_indent_on_tab ((GtkSourceView*) self->priv->_view1);
#line 121 "split-source-view.vala"
	return result;
#line 334 "split-source-view.c"
}


void valide_split_source_view_set_indent_on_tab (ValideSplitSourceView* self, gboolean value) {
	g_return_if_fail (self != NULL);
#line 125 "split-source-view.vala"
	gtk_source_view_set_indent_on_tab ((GtkSourceView*) self->priv->_view1, value);
#line 126 "split-source-view.vala"
	gtk_source_view_set_indent_on_tab ((GtkSourceView*) self->priv->_view2, value);
#line 344 "split-source-view.c"
	g_object_notify ((GObject *) self, "indent-on-tab");
}


gboolean valide_split_source_view_get_insert_spaces_instead_of_tabs (ValideSplitSourceView* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = gtk_source_view_get_insert_spaces_instead_of_tabs ((GtkSourceView*) self->priv->_view1);
#line 137 "split-source-view.vala"
	return result;
#line 355 "split-source-view.c"
}


void valide_split_source_view_set_insert_spaces_instead_of_tabs (ValideSplitSourceView* self, gboolean value) {
	g_return_if_fail (self != NULL);
#line 141 "split-source-view.vala"
	gtk_source_view_set_insert_spaces_instead_of_tabs ((GtkSourceView*) self->priv->_view1, value);
#line 142 "split-source-view.vala"
	gtk_source_view_set_insert_spaces_instead_of_tabs ((GtkSourceView*) self->priv->_view2, value);
#line 365 "split-source-view.c"
	g_object_notify ((GObject *) self, "insert-spaces-instead-of-tabs");
}


guint valide_split_source_view_get_tab_width (ValideSplitSourceView* self) {
	guint result;
	g_return_val_if_fail (self != NULL, 0U);
	result = gtk_source_view_get_tab_width ((GtkSourceView*) self->priv->_view1);
#line 153 "split-source-view.vala"
	return result;
#line 376 "split-source-view.c"
}


void valide_split_source_view_set_tab_width (ValideSplitSourceView* self, guint value) {
	g_return_if_fail (self != NULL);
#line 157 "split-source-view.vala"
	gtk_source_view_set_tab_width ((GtkSourceView*) self->priv->_view1, value);
#line 158 "split-source-view.vala"
	gtk_source_view_set_tab_width ((GtkSourceView*) self->priv->_view2, value);
#line 386 "split-source-view.c"
	g_object_notify ((GObject *) self, "tab-width");
}


const char* valide_split_source_view_get_language (ValideSplitSourceView* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_language;
#line 167 "split-source-view.vala"
	return result;
#line 397 "split-source-view.c"
}


static void valide_split_source_view_set_language (ValideSplitSourceView* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_language = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_language), _tmp0_);
	g_object_notify ((GObject *) self, "language");
}


ValideSourceView* valide_split_source_view_get_active_view (ValideSplitSourceView* self) {
	ValideSourceView* result;
	g_return_val_if_fail (self != NULL, NULL);
#line 178 "split-source-view.vala"
	if (gtk_paned_get_position ((GtkPaned*) self) == 0) {
#line 414 "split-source-view.c"
		result = self->priv->_view2;
#line 180 "split-source-view.vala"
		return result;
#line 418 "split-source-view.c"
	} else {
		result = self->priv->last_active;
#line 184 "split-source-view.vala"
		return result;
#line 423 "split-source-view.c"
	}
}


static ValideSourceView* valide_split_source_view_get_view1 (ValideSplitSourceView* self) {
	ValideSourceView* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_view1;
#line 194 "split-source-view.vala"
	return result;
#line 434 "split-source-view.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void valide_split_source_view_set_view1 (ValideSplitSourceView* self, ValideSourceView* value) {
	ValideSourceView* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_view1 = (_tmp0_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_view1), _tmp0_);
}


static ValideSourceView* valide_split_source_view_get_view2 (ValideSplitSourceView* self) {
	ValideSourceView* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_view2;
#line 203 "split-source-view.vala"
	return result;
#line 456 "split-source-view.c"
}


static void valide_split_source_view_set_view2 (ValideSplitSourceView* self, ValideSourceView* value) {
	ValideSourceView* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_view2 = (_tmp0_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_view2), _tmp0_);
}


#line 207 "split-source-view.vala"
static gboolean _valide_split_source_view_focus_in_event_cb_gtk_widget_focus_in_event (GtkWidget* _sender, GdkEventFocus* event, gpointer self) {
#line 469 "split-source-view.c"
	return valide_split_source_view_focus_in_event_cb (self, _sender, event);
}


static gboolean _lambda5_ (GtkWidget* s, GdkEventKey* e, ValideSplitSourceView* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (s != NULL, FALSE);
	result = (g_signal_emit_by_name ((GtkWidget*) self, "key-press-event", e, &_tmp0_), _tmp0_);
#line 249 "split-source-view.vala"
	return result;
#line 481 "split-source-view.c"
}


static gboolean __lambda5__gtk_widget_key_press_event (GtkWidget* _sender, GdkEventKey* event, gpointer self) {
	return _lambda5_ (_sender, event, self);
}


static gboolean _lambda6_ (GtkWidget* s, GdkEventKey* e, ValideSplitSourceView* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (s != NULL, FALSE);
	result = (g_signal_emit_by_name ((GtkWidget*) self, "key-press-event", e, &_tmp0_), _tmp0_);
#line 250 "split-source-view.vala"
	return result;
#line 497 "split-source-view.c"
}


static gboolean __lambda6__gtk_widget_key_press_event (GtkWidget* _sender, GdkEventKey* event, gpointer self) {
	return _lambda6_ (_sender, event, self);
}


static gboolean _lambda7_ (GtkWidget* s, GdkEventFocus* e, ValideSplitSourceView* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (s != NULL, FALSE);
	result = (g_signal_emit_by_name ((GtkWidget*) self, "focus-out-event", e, &_tmp0_), _tmp0_);
#line 251 "split-source-view.vala"
	return result;
#line 513 "split-source-view.c"
}


static gboolean __lambda7__gtk_widget_focus_out_event (GtkWidget* _sender, GdkEventFocus* event, gpointer self) {
	return _lambda7_ (_sender, event, self);
}


static gboolean _lambda8_ (GtkWidget* s, GdkEventFocus* e, ValideSplitSourceView* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (s != NULL, FALSE);
	result = (g_signal_emit_by_name ((GtkWidget*) self, "focus-out-event", e, &_tmp0_), _tmp0_);
#line 252 "split-source-view.vala"
	return result;
#line 529 "split-source-view.c"
}


static gboolean __lambda8__gtk_widget_focus_out_event (GtkWidget* _sender, GdkEventFocus* event, gpointer self) {
	return _lambda8_ (_sender, event, self);
}


static gboolean _lambda9_ (GtkWidget* s, GdkEventButton* e, ValideSplitSourceView* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (s != NULL, FALSE);
	result = (g_signal_emit_by_name ((GtkWidget*) self, "button-press-event", e, &_tmp0_), _tmp0_);
#line 253 "split-source-view.vala"
	return result;
#line 545 "split-source-view.c"
}


static gboolean __lambda9__gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	return _lambda9_ (_sender, event, self);
}


static gboolean _lambda10_ (GtkWidget* s, GdkEventButton* e, ValideSplitSourceView* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (s != NULL, FALSE);
	result = (g_signal_emit_by_name ((GtkWidget*) self, "button-press-event", e, &_tmp0_), _tmp0_);
#line 254 "split-source-view.vala"
	return result;
#line 561 "split-source-view.c"
}


static gboolean __lambda10__gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	return _lambda10_ (_sender, event, self);
}


static void _lambda11_ (ValideSourceView* s, ValideSplitSourceView* self) {
	g_return_if_fail (s != NULL);
#line 255 "split-source-view.vala"
	g_signal_emit_by_name (self, "search");
#line 574 "split-source-view.c"
}


static void __lambda11__valide_source_view_search (ValideSourceView* _sender, gpointer self) {
	_lambda11_ (_sender, self);
}


static void _lambda12_ (ValideSourceView* s, ValideSplitSourceView* self) {
	g_return_if_fail (s != NULL);
#line 256 "split-source-view.vala"
	g_signal_emit_by_name (self, "search");
#line 587 "split-source-view.c"
}


static void __lambda12__valide_source_view_search (ValideSourceView* _sender, gpointer self) {
	_lambda12_ (_sender, self);
}


static void _lambda13_ (ValideSourceView* s, ValideSplitSourceView* self) {
	g_return_if_fail (s != NULL);
#line 257 "split-source-view.vala"
	g_signal_emit_by_name (self, "find-next");
#line 600 "split-source-view.c"
}


static void __lambda13__valide_source_view_find_next (ValideSourceView* _sender, gpointer self) {
	_lambda13_ (_sender, self);
}


static void _lambda14_ (ValideSourceView* s, ValideSplitSourceView* self) {
	g_return_if_fail (s != NULL);
#line 258 "split-source-view.vala"
	g_signal_emit_by_name (self, "find-next");
#line 613 "split-source-view.c"
}


static void __lambda14__valide_source_view_find_next (ValideSourceView* _sender, gpointer self) {
	_lambda14_ (_sender, self);
}


static void _lambda15_ (ValideSourceView* s, ValideSplitSourceView* self) {
	g_return_if_fail (s != NULL);
#line 259 "split-source-view.vala"
	g_signal_emit_by_name (self, "find-prev");
#line 626 "split-source-view.c"
}


static void __lambda15__valide_source_view_find_prev (ValideSourceView* _sender, gpointer self) {
	_lambda15_ (_sender, self);
}


static void _lambda16_ (ValideSourceView* s, ValideSplitSourceView* self) {
	g_return_if_fail (s != NULL);
#line 260 "split-source-view.vala"
	g_signal_emit_by_name (self, "find-prev");
#line 639 "split-source-view.c"
}


static void __lambda16__valide_source_view_find_prev (ValideSourceView* _sender, gpointer self) {
	_lambda16_ (_sender, self);
}


static void _lambda17_ (ValideSourceView* s, ValideSplitSourceView* self) {
	g_return_if_fail (s != NULL);
#line 261 "split-source-view.vala"
	g_signal_emit_by_name (self, "replace");
#line 652 "split-source-view.c"
}


static void __lambda17__valide_source_view_replace (ValideSourceView* _sender, gpointer self) {
	_lambda17_ (_sender, self);
}


static void _lambda18_ (ValideSourceView* s, ValideSplitSourceView* self) {
	g_return_if_fail (s != NULL);
#line 262 "split-source-view.vala"
	g_signal_emit_by_name (self, "replace");
#line 665 "split-source-view.c"
}


static void __lambda18__valide_source_view_replace (ValideSourceView* _sender, gpointer self) {
	_lambda18_ (_sender, self);
}


static GObject * valide_split_source_view_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	ValideSplitSourceView * self;
	parent_class = G_OBJECT_CLASS (valide_split_source_view_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = VALIDE_SPLIT_SOURCE_VIEW (obj);
	{
		GtkScrolledWindow* scrolled_window;
		ValideSourceView* _tmp0_;
		ValideSourceView* _tmp1_;
		GtkScrolledWindow* _tmp2_;
		GtkScrolledWindow* _tmp3_;
		scrolled_window = NULL;
#line 228 "split-source-view.vala"
		valide_split_source_view_set_view1 (self, _tmp0_ = g_object_ref_sink (valide_source_view_new (self->priv->_language)));
#line 690 "split-source-view.c"
		_g_object_unref0 (_tmp0_);
#line 229 "split-source-view.vala"
		g_signal_connect_object ((GtkWidget*) self->priv->_view1, "focus-in-event", (GCallback) _valide_split_source_view_focus_in_event_cb_gtk_widget_focus_in_event, self, 0);
#line 230 "split-source-view.vala"
		valide_split_source_view_set_view2 (self, _tmp1_ = g_object_ref_sink (valide_source_view_new (self->priv->_language)));
#line 696 "split-source-view.c"
		_g_object_unref0 (_tmp1_);
#line 231 "split-source-view.vala"
		g_signal_connect_object ((GtkWidget*) self->priv->_view2, "focus-in-event", (GCallback) _valide_split_source_view_focus_in_event_cb_gtk_widget_focus_in_event, self, 0);
#line 233 "split-source-view.vala"
		valide_source_view_set_buffer (self->priv->_view2, valide_source_view_get_buffer (self->priv->_view1));
#line 235 "split-source-view.vala"
		scrolled_window = (_tmp2_ = g_object_ref_sink ((GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL)), _g_object_unref0 (scrolled_window), _tmp2_);
#line 236 "split-source-view.vala"
		gtk_scrolled_window_set_policy (scrolled_window, GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
#line 237 "split-source-view.vala"
		gtk_paned_add1 ((GtkPaned*) self, (GtkWidget*) scrolled_window);
#line 238 "split-source-view.vala"
		gtk_container_add ((GtkContainer*) scrolled_window, (GtkWidget*) self->priv->_view1);
#line 240 "split-source-view.vala"
		scrolled_window = (_tmp3_ = g_object_ref_sink ((GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL)), _g_object_unref0 (scrolled_window), _tmp3_);
#line 241 "split-source-view.vala"
		gtk_scrolled_window_set_policy (scrolled_window, GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
#line 242 "split-source-view.vala"
		gtk_paned_add2 ((GtkPaned*) self, (GtkWidget*) scrolled_window);
#line 243 "split-source-view.vala"
		gtk_container_add ((GtkContainer*) scrolled_window, (GtkWidget*) self->priv->_view2);
#line 245 "split-source-view.vala"
		gtk_paned_set_position ((GtkPaned*) self, 0);
#line 246 "split-source-view.vala"
		self->priv->last_active = self->priv->_view2;
#line 249 "split-source-view.vala"
		g_signal_connect_object ((GtkWidget*) self->priv->_view1, "key-press-event", (GCallback) __lambda5__gtk_widget_key_press_event, self, 0);
#line 250 "split-source-view.vala"
		g_signal_connect_object ((GtkWidget*) self->priv->_view2, "key-press-event", (GCallback) __lambda6__gtk_widget_key_press_event, self, 0);
#line 251 "split-source-view.vala"
		g_signal_connect_object ((GtkWidget*) self->priv->_view1, "focus-out-event", (GCallback) __lambda7__gtk_widget_focus_out_event, self, 0);
#line 252 "split-source-view.vala"
		g_signal_connect_object ((GtkWidget*) self->priv->_view2, "focus-out-event", (GCallback) __lambda8__gtk_widget_focus_out_event, self, 0);
#line 253 "split-source-view.vala"
		g_signal_connect_object ((GtkWidget*) self->priv->_view1, "button-press-event", (GCallback) __lambda9__gtk_widget_button_press_event, self, 0);
#line 254 "split-source-view.vala"
		g_signal_connect_object ((GtkWidget*) self->priv->_view2, "button-press-event", (GCallback) __lambda10__gtk_widget_button_press_event, self, 0);
#line 255 "split-source-view.vala"
		g_signal_connect_object (self->priv->_view1, "search", (GCallback) __lambda11__valide_source_view_search, self, 0);
#line 256 "split-source-view.vala"
		g_signal_connect_object (self->priv->_view2, "search", (GCallback) __lambda12__valide_source_view_search, self, 0);
#line 257 "split-source-view.vala"
		g_signal_connect_object (self->priv->_view1, "find-next", (GCallback) __lambda13__valide_source_view_find_next, self, 0);
#line 258 "split-source-view.vala"
		g_signal_connect_object (self->priv->_view2, "find-next", (GCallback) __lambda14__valide_source_view_find_next, self, 0);
#line 259 "split-source-view.vala"
		g_signal_connect_object (self->priv->_view1, "find-prev", (GCallback) __lambda15__valide_source_view_find_prev, self, 0);
#line 260 "split-source-view.vala"
		g_signal_connect_object (self->priv->_view2, "find-prev", (GCallback) __lambda16__valide_source_view_find_prev, self, 0);
#line 261 "split-source-view.vala"
		g_signal_connect_object (self->priv->_view1, "replace", (GCallback) __lambda17__valide_source_view_replace, self, 0);
#line 262 "split-source-view.vala"
		g_signal_connect_object (self->priv->_view2, "replace", (GCallback) __lambda18__valide_source_view_replace, self, 0);
#line 750 "split-source-view.c"
		_g_object_unref0 (scrolled_window);
	}
	return obj;
}


static void valide_split_source_view_class_init (ValideSplitSourceViewClass * klass) {
	valide_split_source_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValideSplitSourceViewPrivate));
	G_OBJECT_CLASS (klass)->get_property = valide_split_source_view_get_property;
	G_OBJECT_CLASS (klass)->set_property = valide_split_source_view_set_property;
	G_OBJECT_CLASS (klass)->constructor = valide_split_source_view_constructor;
	G_OBJECT_CLASS (klass)->finalize = valide_split_source_view_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_SPLIT_SOURCE_VIEW_RIGHT_MARGIN_POSITION, g_param_spec_uint ("right-margin-position", "right-margin-position", "right-margin-position", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_SPLIT_SOURCE_VIEW_SHOW_RIGHT_MARGIN, g_param_spec_boolean ("show-right-margin", "show-right-margin", "show-right-margin", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_SPLIT_SOURCE_VIEW_SHOW_LINE_NUMBERS, g_param_spec_boolean ("show-line-numbers", "show-line-numbers", "show-line-numbers", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_SPLIT_SOURCE_VIEW_AUTO_INDENT, g_param_spec_boolean ("auto-indent", "auto-indent", "auto-indent", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_SPLIT_SOURCE_VIEW_HIGHLIGHT_CURRENT_LINE, g_param_spec_boolean ("highlight-current-line", "highlight-current-line", "highlight-current-line", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_SPLIT_SOURCE_VIEW_INDENT_ON_TAB, g_param_spec_boolean ("indent-on-tab", "indent-on-tab", "indent-on-tab", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_SPLIT_SOURCE_VIEW_INSERT_SPACES_INSTEAD_OF_TABS, g_param_spec_boolean ("insert-spaces-instead-of-tabs", "insert-spaces-instead-of-tabs", "insert-spaces-instead-of-tabs", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_SPLIT_SOURCE_VIEW_TAB_WIDTH, g_param_spec_uint ("tab-width", "tab-width", "tab-width", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_SPLIT_SOURCE_VIEW_LANGUAGE, g_param_spec_string ("language", "language", "language", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_SPLIT_SOURCE_VIEW_ACTIVE_VIEW, g_param_spec_object ("active-view", "active-view", "active-view", VALIDE_TYPE_SOURCE_VIEW, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_signal_new ("search", VALIDE_TYPE_SPLIT_SOURCE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("find_next", VALIDE_TYPE_SPLIT_SOURCE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("find_prev", VALIDE_TYPE_SPLIT_SOURCE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("replace", VALIDE_TYPE_SPLIT_SOURCE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void valide_split_source_view_instance_init (ValideSplitSourceView * self) {
	self->priv = VALIDE_SPLIT_SOURCE_VIEW_GET_PRIVATE (self);
}


static void valide_split_source_view_finalize (GObject* obj) {
	ValideSplitSourceView * self;
	self = VALIDE_SPLIT_SOURCE_VIEW (obj);
	_g_free0 (self->priv->_language);
	_g_object_unref0 (self->priv->_view1);
	_g_object_unref0 (self->priv->_view2);
	G_OBJECT_CLASS (valide_split_source_view_parent_class)->finalize (obj);
}


GType valide_split_source_view_get_type (void) {
	static GType valide_split_source_view_type_id = 0;
	if (valide_split_source_view_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValideSplitSourceViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valide_split_source_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValideSplitSourceView), 0, (GInstanceInitFunc) valide_split_source_view_instance_init, NULL };
		valide_split_source_view_type_id = g_type_register_static (GTK_TYPE_VPANED, "ValideSplitSourceView", &g_define_type_info, 0);
	}
	return valide_split_source_view_type_id;
}


static void valide_split_source_view_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	ValideSplitSourceView * self;
	self = VALIDE_SPLIT_SOURCE_VIEW (object);
	switch (property_id) {
		case VALIDE_SPLIT_SOURCE_VIEW_RIGHT_MARGIN_POSITION:
		g_value_set_uint (value, valide_split_source_view_get_right_margin_position (self));
		break;
		case VALIDE_SPLIT_SOURCE_VIEW_SHOW_RIGHT_MARGIN:
		g_value_set_boolean (value, valide_split_source_view_get_show_right_margin (self));
		break;
		case VALIDE_SPLIT_SOURCE_VIEW_SHOW_LINE_NUMBERS:
		g_value_set_boolean (value, valide_split_source_view_get_show_line_numbers (self));
		break;
		case VALIDE_SPLIT_SOURCE_VIEW_AUTO_INDENT:
		g_value_set_boolean (value, valide_split_source_view_get_auto_indent (self));
		break;
		case VALIDE_SPLIT_SOURCE_VIEW_HIGHLIGHT_CURRENT_LINE:
		g_value_set_boolean (value, valide_split_source_view_get_highlight_current_line (self));
		break;
		case VALIDE_SPLIT_SOURCE_VIEW_INDENT_ON_TAB:
		g_value_set_boolean (value, valide_split_source_view_get_indent_on_tab (self));
		break;
		case VALIDE_SPLIT_SOURCE_VIEW_INSERT_SPACES_INSTEAD_OF_TABS:
		g_value_set_boolean (value, valide_split_source_view_get_insert_spaces_instead_of_tabs (self));
		break;
		case VALIDE_SPLIT_SOURCE_VIEW_TAB_WIDTH:
		g_value_set_uint (value, valide_split_source_view_get_tab_width (self));
		break;
		case VALIDE_SPLIT_SOURCE_VIEW_LANGUAGE:
		g_value_set_string (value, valide_split_source_view_get_language (self));
		break;
		case VALIDE_SPLIT_SOURCE_VIEW_ACTIVE_VIEW:
		g_value_set_object (value, valide_split_source_view_get_active_view (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void valide_split_source_view_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	ValideSplitSourceView * self;
	self = VALIDE_SPLIT_SOURCE_VIEW (object);
	switch (property_id) {
		case VALIDE_SPLIT_SOURCE_VIEW_RIGHT_MARGIN_POSITION:
		valide_split_source_view_set_right_margin_position (self, g_value_get_uint (value));
		break;
		case VALIDE_SPLIT_SOURCE_VIEW_SHOW_RIGHT_MARGIN:
		valide_split_source_view_set_show_right_margin (self, g_value_get_boolean (value));
		break;
		case VALIDE_SPLIT_SOURCE_VIEW_SHOW_LINE_NUMBERS:
		valide_split_source_view_set_show_line_numbers (self, g_value_get_boolean (value));
		break;
		case VALIDE_SPLIT_SOURCE_VIEW_AUTO_INDENT:
		valide_split_source_view_set_auto_indent (self, g_value_get_boolean (value));
		break;
		case VALIDE_SPLIT_SOURCE_VIEW_HIGHLIGHT_CURRENT_LINE:
		valide_split_source_view_set_highlight_current_line (self, g_value_get_boolean (value));
		break;
		case VALIDE_SPLIT_SOURCE_VIEW_INDENT_ON_TAB:
		valide_split_source_view_set_indent_on_tab (self, g_value_get_boolean (value));
		break;
		case VALIDE_SPLIT_SOURCE_VIEW_INSERT_SPACES_INSTEAD_OF_TABS:
		valide_split_source_view_set_insert_spaces_instead_of_tabs (self, g_value_get_boolean (value));
		break;
		case VALIDE_SPLIT_SOURCE_VIEW_TAB_WIDTH:
		valide_split_source_view_set_tab_width (self, g_value_get_uint (value));
		break;
		case VALIDE_SPLIT_SOURCE_VIEW_LANGUAGE:
		valide_split_source_view_set_language (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}




