/* statusbar.c generated by valac, the Vala compiler
 * generated from statusbar.vala, do not modify */

/* aboutdialog.vala
 *
 * Copyright (C) 2008-2009  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <nicolas.joseph@valaide.org>
 */
/*
 * This code is re-writing in the vala language of GeditStatusbar
 *
 * Copyright (C) 2006-2008  Jürg Billeter, Raffaele Sandrini
 * Copyright (C) 2007  Mathias Hasselmann
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>


#define VALIDE_TYPE_STATUSBAR (valide_statusbar_get_type ())
#define VALIDE_STATUSBAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_STATUSBAR, ValideStatusbar))
#define VALIDE_STATUSBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_STATUSBAR, ValideStatusbarClass))
#define VALIDE_IS_STATUSBAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_STATUSBAR))
#define VALIDE_IS_STATUSBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_STATUSBAR))
#define VALIDE_STATUSBAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_STATUSBAR, ValideStatusbarClass))

typedef struct _ValideStatusbar ValideStatusbar;
typedef struct _ValideStatusbarClass ValideStatusbarClass;
typedef struct _ValideStatusbarPrivate ValideStatusbarPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _ValideStatusbar {
	GtkStatusbar parent_instance;
	ValideStatusbarPrivate * priv;
};

struct _ValideStatusbarClass {
	GtkStatusbarClass parent_class;
};

struct _ValideStatusbarPrivate {
	GtkStatusbar* cursor_position_statusbar;
	guint flash_context_id;
	guint flash_message_id;
	guint flash_timeout;
};


static gpointer valide_statusbar_parent_class = NULL;

GType valide_statusbar_get_type (void);
#define VALIDE_STATUSBAR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALIDE_TYPE_STATUSBAR, ValideStatusbarPrivate))
enum  {
	VALIDE_STATUSBAR_DUMMY_PROPERTY
};
static gboolean valide_statusbar_remove_message_timeout (ValideStatusbar* self);
void valide_statusbar_set_has_resize_grip (ValideStatusbar* self, gboolean show);
void valide_statusbar_set_cursor_position (ValideStatusbar* self, gint line, gint col);
static gboolean _valide_statusbar_remove_message_timeout_gsource_func (gpointer self);
void valide_statusbar_flash_message (ValideStatusbar* self, guint context_id, const char* msg);
ValideStatusbar* valide_statusbar_new (void);
ValideStatusbar* valide_statusbar_construct (GType object_type);
static GObject * valide_statusbar_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void valide_statusbar_finalize (GObject* obj);



#line 39 "statusbar.vala"
static gboolean valide_statusbar_remove_message_timeout (ValideStatusbar* self) {
#line 91 "statusbar.c"
	gboolean result;
#line 39 "statusbar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 41 "statusbar.vala"
	gtk_statusbar_remove ((GtkStatusbar*) self, self->priv->flash_context_id, self->priv->flash_message_id);
#line 44 "statusbar.vala"
	self->priv->flash_timeout = (guint) 0;
#line 99 "statusbar.c"
	result = FALSE;
#line 45 "statusbar.vala"
	return result;
#line 103 "statusbar.c"
}


#line 62 "statusbar.vala"
void valide_statusbar_set_has_resize_grip (ValideStatusbar* self, gboolean show) {
#line 62 "statusbar.vala"
	g_return_if_fail (self != NULL);
#line 64 "statusbar.vala"
	gtk_statusbar_set_has_resize_grip (self->priv->cursor_position_statusbar, show);
#line 113 "statusbar.c"
}


#line 73 "statusbar.vala"
void valide_statusbar_set_cursor_position (ValideStatusbar* self, gint line, gint col) {
#line 119 "statusbar.c"
	char* msg;
	gboolean _tmp0_ = FALSE;
#line 73 "statusbar.vala"
	g_return_if_fail (self != NULL);
#line 124 "statusbar.c"
	msg = NULL;
#line 77 "statusbar.vala"
	gtk_statusbar_pop (self->priv->cursor_position_statusbar, (guint) 0);
#line 79 "statusbar.vala"
	if (line != (-1)) {
#line 79 "statusbar.vala"
		_tmp0_ = TRUE;
#line 132 "statusbar.c"
	} else {
#line 79 "statusbar.vala"
		_tmp0_ = col != (-1);
#line 136 "statusbar.c"
	}
#line 79 "statusbar.vala"
	if (_tmp0_) {
#line 140 "statusbar.c"
		char* _tmp1_;
#line 83 "statusbar.vala"
		msg = (_tmp1_ = g_strdup_printf (_ ("  Ln %d, Col %d"), line, col), _g_free0 (msg), _tmp1_);
#line 85 "statusbar.vala"
		gtk_statusbar_push (self->priv->cursor_position_statusbar, (guint) 0, msg);
#line 146 "statusbar.c"
	}
	_g_free0 (msg);
}


#line 39 "statusbar.vala"
static gboolean _valide_statusbar_remove_message_timeout_gsource_func (gpointer self) {
#line 154 "statusbar.c"
	return valide_statusbar_remove_message_timeout (self);
}


#line 95 "statusbar.vala"
void valide_statusbar_flash_message (ValideStatusbar* self, guint context_id, const char* msg) {
#line 161 "statusbar.c"
	guint32 flash_length;
#line 95 "statusbar.vala"
	g_return_if_fail (self != NULL);
#line 95 "statusbar.vala"
	g_return_if_fail (msg != NULL);
#line 97 "statusbar.vala"
	flash_length = (guint32) 3000;
#line 100 "statusbar.vala"
	if (self->priv->flash_timeout > 0) {
#line 102 "statusbar.vala"
		g_source_remove (self->priv->flash_timeout);
#line 103 "statusbar.vala"
		self->priv->flash_timeout = (guint) 0;
#line 105 "statusbar.vala"
		gtk_statusbar_remove ((GtkStatusbar*) self, self->priv->flash_context_id, self->priv->flash_message_id);
#line 177 "statusbar.c"
	}
#line 108 "statusbar.vala"
	self->priv->flash_context_id = context_id;
#line 109 "statusbar.vala"
	self->priv->flash_message_id = gtk_statusbar_push ((GtkStatusbar*) self, context_id, msg);
#line 111 "statusbar.vala"
	self->priv->flash_timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) flash_length, _valide_statusbar_remove_message_timeout_gsource_func, g_object_ref (self), g_object_unref);
#line 185 "statusbar.c"
}


#line 32 "statusbar.vala"
ValideStatusbar* valide_statusbar_construct (GType object_type) {
#line 191 "statusbar.c"
	ValideStatusbar * self;
	self = g_object_newv (object_type, 0, NULL);
	return self;
}


#line 32 "statusbar.vala"
ValideStatusbar* valide_statusbar_new (void) {
#line 32 "statusbar.vala"
	return valide_statusbar_construct (VALIDE_TYPE_STATUSBAR);
#line 202 "statusbar.c"
}


static GObject * valide_statusbar_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	ValideStatusbar * self;
	parent_class = G_OBJECT_CLASS (valide_statusbar_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = VALIDE_STATUSBAR (obj);
	{
		GtkStatusbar* _tmp0_;
#line 50 "statusbar.vala"
		gtk_statusbar_set_has_resize_grip (GTK_STATUSBAR (self), FALSE);
#line 52 "statusbar.vala"
		self->priv->cursor_position_statusbar = (_tmp0_ = g_object_ref_sink ((GtkStatusbar*) gtk_statusbar_new ()), _g_object_unref0 (self->priv->cursor_position_statusbar), _tmp0_);
#line 53 "statusbar.vala"
		gtk_widget_show ((GtkWidget*) self->priv->cursor_position_statusbar);
#line 54 "statusbar.vala"
		gtk_widget_set_size_request ((GtkWidget*) self->priv->cursor_position_statusbar, 160, 10);
#line 55 "statusbar.vala"
		gtk_statusbar_set_has_resize_grip (self->priv->cursor_position_statusbar, FALSE);
#line 56 "statusbar.vala"
		gtk_box_pack_end ((GtkBox*) self, (GtkWidget*) self->priv->cursor_position_statusbar, FALSE, TRUE, (guint) 0);
#line 227 "statusbar.c"
	}
	return obj;
}


static void valide_statusbar_class_init (ValideStatusbarClass * klass) {
	valide_statusbar_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValideStatusbarPrivate));
	G_OBJECT_CLASS (klass)->constructor = valide_statusbar_constructor;
	G_OBJECT_CLASS (klass)->finalize = valide_statusbar_finalize;
}


static void valide_statusbar_instance_init (ValideStatusbar * self) {
	self->priv = VALIDE_STATUSBAR_GET_PRIVATE (self);
}


static void valide_statusbar_finalize (GObject* obj) {
	ValideStatusbar * self;
	self = VALIDE_STATUSBAR (obj);
	_g_object_unref0 (self->priv->cursor_position_statusbar);
	G_OBJECT_CLASS (valide_statusbar_parent_class)->finalize (obj);
}


GType valide_statusbar_get_type (void) {
	static GType valide_statusbar_type_id = 0;
	if (valide_statusbar_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValideStatusbarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valide_statusbar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValideStatusbar), 0, (GInstanceInitFunc) valide_statusbar_instance_init, NULL };
		valide_statusbar_type_id = g_type_register_static (GTK_TYPE_STATUSBAR, "ValideStatusbar", &g_define_type_info, 0);
	}
	return valide_statusbar_type_id;
}




