/* popup.c generated by valac, the Vala compiler
 * generated from popup.vala, do not modify */

/* popup.vala
 *
 * Copyright (C) 2008-2009 Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <nicolas.joseph@valaide.org>
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>


#define TYPE_POPUP (popup_get_type ())
#define POPUP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_POPUP, Popup))
#define POPUP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_POPUP, PopupClass))
#define IS_POPUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_POPUP))
#define IS_POPUP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_POPUP))
#define POPUP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_POPUP, PopupClass))

typedef struct _Popup Popup;
typedef struct _PopupClass PopupClass;
typedef struct _PopupPrivate PopupPrivate;

#define TYPE_TREE (tree_get_type ())
#define TREE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TREE, Tree))
#define TREE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TREE, TreeClass))
#define IS_TREE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TREE))
#define IS_TREE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TREE))
#define TREE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TREE, TreeClass))

typedef struct _Tree Tree;
typedef struct _TreeClass TreeClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_PROPOSAL (proposal_get_type ())
#define PROPOSAL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROPOSAL, Proposal))
#define PROPOSAL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PROPOSAL, ProposalClass))
#define IS_PROPOSAL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROPOSAL))
#define IS_PROPOSAL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PROPOSAL))
#define PROPOSAL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PROPOSAL, ProposalClass))

typedef struct _Proposal Proposal;
typedef struct _ProposalClass ProposalClass;

struct _Popup {
	GtkWindow parent_instance;
	PopupPrivate * priv;
};

struct _PopupClass {
	GtkWindowClass parent_class;
};

struct _PopupPrivate {
	Tree* completion_tree;
};


static gpointer popup_parent_class = NULL;

GType popup_get_type (void);
GType tree_get_type (void);
#define POPUP_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_POPUP, PopupPrivate))
enum  {
	POPUP_DUMMY_PROPERTY,
	POPUP_PROPOSALS
};
#define POPUP_WIDTH 350
#define POPUP_HEIGHT 200
static gboolean popup_delete_event_cb (Popup* self, GtkWidget* widget, GdkEvent* event);
GType proposal_get_type (void);
static void popup_proposal_selected_cb (Popup* self, Tree* sender, Proposal* proposal);
Popup* popup_new (void);
Popup* popup_construct (GType object_type);
gboolean popup_has_proposals (Popup* self);
static void popup_real_show (GtkWidget* base);
static void popup_real_realize (GtkWidget* base);
void tree_select_first (Tree* self);
void popup_select_first (Popup* self);
void tree_select_last (Tree* self);
void popup_select_last (Popup* self);
void tree_select_previous (Tree* self, gint rows);
void popup_select_previous (Popup* self, gint rows);
void tree_select_next (Tree* self, gint rows);
void popup_select_next (Popup* self, gint rows);
gboolean tree_get_selected_proposal (Tree* self, Proposal** proposal);
gboolean popup_get_selected_proposal (Popup* self, Proposal** proposal);
gint tree_get_num_proposals (Tree* self);
gint popup_get_num_proposals (Popup* self);
void tree_filter (Tree* self, const char* filter);
void popup_filter (Popup* self, const char* filter);
void tree_clear (Tree* self);
void popup_clear (Popup* self);
void tree_add_data (Tree* self, Proposal* data);
void popup_set_proposals (Popup* self, GList* value);
Tree* tree_new (void);
Tree* tree_construct (GType object_type);
static void _popup_proposal_selected_cb_tree_proposal_selected (Tree* _sender, Proposal* proposal, gpointer self);
static gboolean _popup_delete_event_cb_gtk_widget_delete_event (GtkWidget* _sender, GdkEvent* event, gpointer self);
static GObject * popup_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void popup_finalize (GObject* obj);
static void popup_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);



#line 51 "popup.vala"
static gboolean popup_delete_event_cb (Popup* self, GtkWidget* widget, GdkEvent* event) {
#line 129 "popup.c"
	gboolean result;
#line 51 "popup.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 51 "popup.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 51 "popup.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 137 "popup.c"
	result = TRUE;
#line 54 "popup.vala"
	return result;
#line 141 "popup.c"
}


#line 57 "popup.vala"
static void popup_proposal_selected_cb (Popup* self, Tree* sender, Proposal* proposal) {
#line 57 "popup.vala"
	g_return_if_fail (self != NULL);
#line 57 "popup.vala"
	g_return_if_fail (sender != NULL);
#line 57 "popup.vala"
	g_return_if_fail (proposal != NULL);
#line 59 "popup.vala"
	g_signal_emit_by_name (self, "proposal-selected", proposal);
#line 155 "popup.c"
}


#line 65 "popup.vala"
Popup* popup_construct (GType object_type) {
#line 161 "popup.c"
	Popup * self;
#line 67 "popup.vala"
	self = (Popup*) g_object_new (object_type, "type", GTK_WINDOW_POPUP, NULL);
#line 165 "popup.c"
	return self;
}


#line 65 "popup.vala"
Popup* popup_new (void) {
#line 65 "popup.vala"
	return popup_construct (TYPE_POPUP);
#line 174 "popup.c"
}


#line 84 "popup.vala"
static void popup_real_show (GtkWidget* base) {
#line 180 "popup.c"
	Popup * self;
	gboolean _tmp0_ = FALSE;
	self = (Popup*) base;
#line 86 "popup.vala"
	if (!gtk_widget_get_visible ((GtkWidget*) self)) {
#line 86 "popup.vala"
		_tmp0_ = popup_has_proposals (self);
#line 188 "popup.c"
	} else {
#line 86 "popup.vala"
		_tmp0_ = FALSE;
#line 192 "popup.c"
	}
#line 86 "popup.vala"
	if (_tmp0_) {
#line 88 "popup.vala"
		GTK_WIDGET_CLASS (popup_parent_class)->show ((GtkWidget*) GTK_WINDOW (self));
#line 198 "popup.c"
	}
}


#line 95 "popup.vala"
static void popup_real_realize (GtkWidget* base) {
#line 205 "popup.c"
	Popup * self;
	self = (Popup*) base;
#line 97 "popup.vala"
	gtk_container_set_border_width ((GtkContainer*) self, (guint) 1);
#line 98 "popup.vala"
	gtk_widget_set_size_request ((GtkWidget*) self, POPUP_WIDTH, POPUP_HEIGHT);
#line 99 "popup.vala"
	gtk_window_set_resizable ((GtkWindow*) self, TRUE);
#line 100 "popup.vala"
	GTK_WIDGET_CLASS (popup_parent_class)->realize ((GtkWidget*) GTK_WINDOW (self));
#line 216 "popup.c"
}


#line 106 "popup.vala"
void popup_select_first (Popup* self) {
#line 106 "popup.vala"
	g_return_if_fail (self != NULL);
#line 108 "popup.vala"
	tree_select_first (self->priv->completion_tree);
#line 226 "popup.c"
}


#line 114 "popup.vala"
void popup_select_last (Popup* self) {
#line 114 "popup.vala"
	g_return_if_fail (self != NULL);
#line 116 "popup.vala"
	tree_select_last (self->priv->completion_tree);
#line 236 "popup.c"
}


#line 122 "popup.vala"
void popup_select_previous (Popup* self, gint rows) {
#line 122 "popup.vala"
	g_return_if_fail (self != NULL);
#line 124 "popup.vala"
	tree_select_previous (self->priv->completion_tree, rows);
#line 246 "popup.c"
}


#line 130 "popup.vala"
void popup_select_next (Popup* self, gint rows) {
#line 130 "popup.vala"
	g_return_if_fail (self != NULL);
#line 132 "popup.vala"
	tree_select_next (self->priv->completion_tree, rows);
#line 256 "popup.c"
}


#line 138 "popup.vala"
gboolean popup_get_selected_proposal (Popup* self, Proposal** proposal) {
#line 262 "popup.c"
	gboolean result;
	Proposal* _tmp2_;
	gboolean _tmp1_;
	Proposal* _tmp0_ = NULL;
#line 138 "popup.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 269 "popup.c"
	if (proposal != NULL) {
		*proposal = NULL;
	}
	result = (_tmp1_ = tree_get_selected_proposal (self->priv->completion_tree, &_tmp0_), *proposal = (_tmp2_ = _tmp0_, _g_object_unref0 (*proposal), _tmp2_), _tmp1_);
#line 140 "popup.vala"
	return result;
#line 276 "popup.c"
}


#line 146 "popup.vala"
gint popup_get_num_proposals (Popup* self) {
#line 282 "popup.c"
	gint result;
#line 146 "popup.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 286 "popup.c"
	result = tree_get_num_proposals (self->priv->completion_tree);
#line 148 "popup.vala"
	return result;
#line 290 "popup.c"
}


#line 156 "popup.vala"
gboolean popup_has_proposals (Popup* self) {
#line 296 "popup.c"
	gboolean result;
#line 156 "popup.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 300 "popup.c"
	result = popup_get_num_proposals (self) > 0;
#line 158 "popup.vala"
	return result;
#line 304 "popup.c"
}


#line 164 "popup.vala"
void popup_filter (Popup* self, const char* filter) {
#line 164 "popup.vala"
	g_return_if_fail (self != NULL);
#line 164 "popup.vala"
	g_return_if_fail (filter != NULL);
#line 166 "popup.vala"
	tree_filter (self->priv->completion_tree, filter);
#line 316 "popup.c"
}


#line 172 "popup.vala"
void popup_clear (Popup* self) {
#line 172 "popup.vala"
	g_return_if_fail (self != NULL);
#line 174 "popup.vala"
	tree_clear (self->priv->completion_tree);
#line 326 "popup.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void popup_set_proposals (Popup* self, GList* value) {
	g_return_if_fail (self != NULL);
#line 43 "popup.vala"
	tree_clear (self->priv->completion_tree);
#line 339 "popup.c"
	{
		GList* proposal_collection;
		GList* proposal_it;
#line 44 "popup.vala"
		proposal_collection = value;
#line 345 "popup.c"
		for (proposal_it = proposal_collection; proposal_it != NULL; proposal_it = proposal_it->next) {
			Proposal* proposal;
#line 44 "popup.vala"
			proposal = _g_object_ref0 ((Proposal*) proposal_it->data);
#line 350 "popup.c"
			{
#line 46 "popup.vala"
				tree_add_data (self->priv->completion_tree, proposal);
#line 354 "popup.c"
				_g_object_unref0 (proposal);
			}
		}
	}
	g_object_notify ((GObject *) self, "proposals");
}


#line 57 "popup.vala"
static void _popup_proposal_selected_cb_tree_proposal_selected (Tree* _sender, Proposal* proposal, gpointer self) {
#line 365 "popup.c"
	popup_proposal_selected_cb (self, _sender, proposal);
}


#line 51 "popup.vala"
static gboolean _popup_delete_event_cb_gtk_widget_delete_event (GtkWidget* _sender, GdkEvent* event, gpointer self) {
#line 372 "popup.c"
	return popup_delete_event_cb (self, _sender, event);
}


static GObject * popup_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	Popup * self;
	parent_class = G_OBJECT_CLASS (popup_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = POPUP (obj);
	{
		Tree* _tmp0_;
#line 72 "popup.vala"
		self->priv->completion_tree = (_tmp0_ = g_object_ref_sink (tree_new ()), _g_object_unref0 (self->priv->completion_tree), _tmp0_);
#line 73 "popup.vala"
		g_object_set ((GtkWidget*) self->priv->completion_tree, "can-focus", FALSE, NULL);
#line 74 "popup.vala"
		g_signal_connect_object (self->priv->completion_tree, "proposal-selected", (GCallback) _popup_proposal_selected_cb_tree_proposal_selected, self, 0);
#line 75 "popup.vala"
		gtk_widget_show ((GtkWidget*) self->priv->completion_tree);
#line 76 "popup.vala"
		gtk_container_add ((GtkContainer*) self, (GtkWidget*) self->priv->completion_tree);
#line 78 "popup.vala"
		g_signal_connect_object ((GtkWidget*) self, "delete-event", (GCallback) _popup_delete_event_cb_gtk_widget_delete_event, self, 0);
#line 398 "popup.c"
	}
	return obj;
}


static void popup_class_init (PopupClass * klass) {
	popup_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PopupPrivate));
	GTK_WIDGET_CLASS (klass)->show = popup_real_show;
	GTK_WIDGET_CLASS (klass)->realize = popup_real_realize;
	G_OBJECT_CLASS (klass)->set_property = popup_set_property;
	G_OBJECT_CLASS (klass)->constructor = popup_constructor;
	G_OBJECT_CLASS (klass)->finalize = popup_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), POPUP_PROPOSALS, g_param_spec_pointer ("proposals", "proposals", "proposals", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE));
	g_signal_new ("proposal_selected", TYPE_POPUP, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_PROPOSAL);
}


static void popup_instance_init (Popup * self) {
	self->priv = POPUP_GET_PRIVATE (self);
}


static void popup_finalize (GObject* obj) {
	Popup * self;
	self = POPUP (obj);
	_g_object_unref0 (self->priv->completion_tree);
	G_OBJECT_CLASS (popup_parent_class)->finalize (obj);
}


GType popup_get_type (void) {
	static GType popup_type_id = 0;
	if (popup_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (PopupClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) popup_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Popup), 0, (GInstanceInitFunc) popup_instance_init, NULL };
		popup_type_id = g_type_register_static (GTK_TYPE_WINDOW, "Popup", &g_define_type_info, 0);
	}
	return popup_type_id;
}


static void popup_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	Popup * self;
	self = POPUP (object);
	switch (property_id) {
		case POPUP_PROPOSALS:
		popup_set_proposals (self, g_value_get_pointer (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}




