/* tree.c generated by valac, the Vala compiler
 * generated from tree.vala, do not modify */

/* tree.vala
 *
 * Copyright (C) 2008-2009 Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <nicolas.joseph@valaide.org>
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <float.h>
#include <math.h>


#define TYPE_TREE (tree_get_type ())
#define TREE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TREE, Tree))
#define TREE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TREE, TreeClass))
#define IS_TREE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TREE))
#define IS_TREE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TREE))
#define TREE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TREE, TreeClass))

typedef struct _Tree Tree;
typedef struct _TreeClass TreeClass;
typedef struct _TreePrivate TreePrivate;

#define TREE_TYPE_COL (tree_col_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_PROPOSAL (proposal_get_type ())
#define PROPOSAL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROPOSAL, Proposal))
#define PROPOSAL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PROPOSAL, ProposalClass))
#define IS_PROPOSAL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROPOSAL))
#define IS_PROPOSAL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PROPOSAL))
#define PROPOSAL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PROPOSAL, ProposalClass))

typedef struct _Proposal Proposal;
typedef struct _ProposalClass ProposalClass;
#define _gtk_tree_path_free0(var) ((var == NULL) ? NULL : (var = (gtk_tree_path_free (var), NULL)))

struct _Tree {
	GtkScrolledWindow parent_instance;
	TreePrivate * priv;
};

struct _TreeClass {
	GtkScrolledWindowClass parent_class;
};

struct _TreePrivate {
	gboolean destroy_has_run;
	char* current_filter;
	gboolean active_filter;
	GtkTreeView* tree_view;
	GtkListStore* list_store;
	GtkTreeModelFilter* model_filter;
};

typedef enum  {
	TREE_COL_PIXBUF,
	TREE_COL_NAME,
	TREE_COL_DATA,
	TREE_COL_NB
} TreeCol;


static gpointer tree_parent_class = NULL;

GType tree_get_type (void);
#define TREE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_TREE, TreePrivate))
enum  {
	TREE_DUMMY_PROPERTY
};
static GType tree_col_get_type (void);
GType proposal_get_type (void);
static void tree_tree_row_activated_cb (Tree* self, GtkTreeView* tree_view, GtkTreePath* path, GtkTreeViewColumn* column);
static gboolean tree_filter_by_name_func (Tree* self, GtkTreeModel* model, GtkTreeIter* iter);
gboolean tree_get_selected_proposal (Tree* self, Proposal** proposal);
const char* proposal_get_label (Proposal* self);
GdkPixbuf* proposal_get_icon (Proposal* self);
void tree_add_data (Tree* self, Proposal* data);
void tree_clear (Tree* self);
void tree_select_first (Tree* self);
void tree_select_last (Tree* self);
void tree_select_previous (Tree* self, gint rows);
void tree_select_next (Tree* self, gint rows);
gint tree_get_num_proposals (Tree* self);
void tree_filter (Tree* self, const char* filter);
Tree* tree_new (void);
Tree* tree_construct (GType object_type);
static gboolean _tree_filter_by_name_func_gtk_tree_model_filter_visible_func (GtkTreeModel* model, GtkTreeIter* iter, gpointer self);
static void _tree_tree_row_activated_cb_gtk_tree_view_row_activated (GtkTreeView* _sender, GtkTreePath* path, GtkTreeViewColumn* column, gpointer self);
static GObject * tree_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void tree_finalize (GObject* obj);
static int _vala_strcmp0 (const char * str1, const char * str2);




static GType tree_col_get_type (void) {
	static GType tree_col_type_id = 0;
	if (G_UNLIKELY (tree_col_type_id == 0)) {
		static const GEnumValue values[] = {{TREE_COL_PIXBUF, "TREE_COL_PIXBUF", "pixbuf"}, {TREE_COL_NAME, "TREE_COL_NAME", "name"}, {TREE_COL_DATA, "TREE_COL_DATA", "data"}, {TREE_COL_NB, "TREE_COL_NB", "nb"}, {0, NULL, NULL}};
		tree_col_type_id = g_enum_register_static ("TreeCol", values);
	}
	return tree_col_type_id;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 47 "tree.vala"
static void tree_tree_row_activated_cb (Tree* self, GtkTreeView* tree_view, GtkTreePath* path, GtkTreeViewColumn* column) {
#line 138 "tree.c"
	GtkTreeIter iter = {0};
	GtkTreeModel* model;
	Proposal* proposal;
	GtkTreeModel* _tmp0_;
#line 47 "tree.vala"
	g_return_if_fail (self != NULL);
#line 47 "tree.vala"
	g_return_if_fail (tree_view != NULL);
#line 47 "tree.vala"
	g_return_if_fail (path != NULL);
#line 47 "tree.vala"
	g_return_if_fail (column != NULL);
#line 151 "tree.c"
	model = NULL;
	proposal = NULL;
#line 55 "tree.vala"
	model = (_tmp0_ = _g_object_ref0 (gtk_tree_view_get_model (tree_view)), _g_object_unref0 (model), _tmp0_);
#line 57 "tree.vala"
	gtk_tree_model_get_iter (model, &iter, path);
#line 58 "tree.vala"
	gtk_tree_model_get (model, &iter, TREE_COL_DATA, &proposal, -1);
#line 60 "tree.vala"
	g_signal_emit_by_name (self, "proposal-selected", proposal);
#line 162 "tree.c"
	_g_object_unref0 (model);
	_g_object_unref0 (proposal);
}


#line 63 "tree.vala"
static gboolean tree_filter_by_name_func (Tree* self, GtkTreeModel* model, GtkTreeIter* iter) {
#line 170 "tree.c"
	gboolean result;
	glong len_cur = 0L;
	char* filter;
	char* current_name;
	char* _tmp0_;
	char* _tmp1_;
	gboolean _tmp2_;
#line 63 "tree.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 63 "tree.vala"
	g_return_val_if_fail (model != NULL, FALSE);
#line 182 "tree.c"
	filter = NULL;
	current_name = NULL;
#line 69 "tree.vala"
	if (!self->priv->active_filter) {
#line 187 "tree.c"
		result = TRUE;
		_g_free0 (filter);
		_g_free0 (current_name);
#line 71 "tree.vala"
		return result;
#line 193 "tree.c"
	}
#line 74 "tree.vala"
	filter = (_tmp0_ = g_strdup (self->priv->current_filter), _g_free0 (filter), _tmp0_);
#line 75 "tree.vala"
	if (filter == NULL) {
#line 199 "tree.c"
		result = TRUE;
		_g_free0 (filter);
		_g_free0 (current_name);
#line 77 "tree.vala"
		return result;
#line 205 "tree.c"
	}
#line 80 "tree.vala"
	gtk_tree_model_get (model, iter, TREE_COL_NAME, &current_name, -1);
#line 81 "tree.vala"
	if (current_name == NULL) {
#line 211 "tree.c"
		result = TRUE;
		_g_free0 (filter);
		_g_free0 (current_name);
#line 83 "tree.vala"
		return result;
#line 217 "tree.c"
	}
#line 86 "tree.vala"
	len_cur = g_utf8_strlen (filter, -1);
#line 87 "tree.vala"
	if ((_tmp2_ = _vala_strcmp0 (filter, _tmp1_ = g_strndup (current_name, (gsize) len_cur)) == 0, _g_free0 (_tmp1_), _tmp2_)) {
#line 223 "tree.c"
		result = TRUE;
		_g_free0 (filter);
		_g_free0 (current_name);
#line 89 "tree.vala"
		return result;
#line 229 "tree.c"
	}
	result = FALSE;
	_g_free0 (filter);
	_g_free0 (current_name);
#line 91 "tree.vala"
	return result;
#line 236 "tree.c"
}


#line 153 "tree.vala"
gboolean tree_get_selected_proposal (Tree* self, Proposal** proposal) {
#line 242 "tree.c"
	gboolean result;
	GtkTreeIter iter = {0};
	GtkTreeModel* model;
	GtkTreeSelection* selection;
	GtkTreeSelection* _tmp0_;
#line 153 "tree.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 250 "tree.c"
	if (proposal != NULL) {
		*proposal = NULL;
	}
	model = NULL;
	selection = NULL;
#line 159 "tree.vala"
	selection = (_tmp0_ = _g_object_ref0 (gtk_tree_view_get_selection (self->priv->tree_view)), _g_object_unref0 (selection), _tmp0_);
#line 160 "tree.vala"
	if (gtk_tree_selection_get_selected (selection, NULL, &iter)) {
#line 260 "tree.c"
		GtkTreeModel* _tmp1_;
#line 162 "tree.vala"
		model = (_tmp1_ = _g_object_ref0 (gtk_tree_view_get_model (self->priv->tree_view)), _g_object_unref0 (model), _tmp1_);
#line 163 "tree.vala"
		gtk_tree_model_get (model, &iter, TREE_COL_DATA, proposal, -1);
#line 266 "tree.c"
		result = TRUE;
		_g_object_unref0 (model);
		_g_object_unref0 (selection);
#line 164 "tree.vala"
		return result;
#line 272 "tree.c"
	}
	result = FALSE;
	_g_object_unref0 (model);
	_g_object_unref0 (selection);
#line 166 "tree.vala"
	return result;
#line 279 "tree.c"
}


#line 174 "tree.vala"
void tree_add_data (Tree* self, Proposal* data) {
#line 174 "tree.vala"
	g_return_if_fail (self != NULL);
#line 174 "tree.vala"
	g_return_if_fail (data != NULL);
#line 176 "tree.vala"
	if (proposal_get_label (data) != NULL) {
#line 291 "tree.c"
		GtkTreeIter iter = {0};
		GtkListStore* store;
		GtkListStore* _tmp0_;
		store = NULL;
#line 181 "tree.vala"
		store = (_tmp0_ = _g_object_ref0 (self->priv->list_store), _g_object_unref0 (store), _tmp0_);
#line 182 "tree.vala"
		gtk_list_store_append (store, &iter);
#line 183 "tree.vala"
		gtk_list_store_set (store, &iter, TREE_COL_PIXBUF, proposal_get_icon (data), TREE_COL_NAME, proposal_get_label (data), TREE_COL_DATA, data, -1);
#line 302 "tree.c"
		_g_object_unref0 (store);
	}
}


#line 192 "tree.vala"
void tree_clear (Tree* self) {
#line 192 "tree.vala"
	g_return_if_fail (self != NULL);
#line 194 "tree.vala"
	gtk_list_store_clear (self->priv->list_store);
#line 314 "tree.c"
}


#line 200 "tree.vala"
void tree_select_first (Tree* self) {
#line 200 "tree.vala"
	g_return_if_fail (self != NULL);
#line 202 "tree.vala"
	if (gtk_widget_get_visible ((GtkWidget*) self)) {
#line 324 "tree.c"
		GtkTreeIter iter = {0};
		GtkTreePath* path;
		GtkTreeModel* model;
		GtkTreeSelection* selection;
		GtkTreeSelection* _tmp0_;
		GtkTreeModel* _tmp1_;
		path = NULL;
		model = NULL;
		selection = NULL;
#line 209 "tree.vala"
		selection = (_tmp0_ = _g_object_ref0 (gtk_tree_view_get_selection (self->priv->tree_view)), _g_object_unref0 (selection), _tmp0_);
#line 211 "tree.vala"
		model = (_tmp1_ = _g_object_ref0 (gtk_tree_view_get_model (self->priv->tree_view)), _g_object_unref0 (model), _tmp1_);
#line 212 "tree.vala"
		if (gtk_tree_model_get_iter_first (model, &iter)) {
#line 340 "tree.c"
			GtkTreePath* _tmp2_;
#line 214 "tree.vala"
			gtk_tree_selection_select_iter (selection, &iter);
#line 215 "tree.vala"
			path = (_tmp2_ = gtk_tree_model_get_path (model, &iter), _gtk_tree_path_free0 (path), _tmp2_);
#line 216 "tree.vala"
			gtk_tree_view_scroll_to_cell (self->priv->tree_view, path, NULL, FALSE, (float) 0, (float) 0);
#line 348 "tree.c"
		}
		_gtk_tree_path_free0 (path);
		_g_object_unref0 (model);
		_g_object_unref0 (selection);
	}
}


#line 224 "tree.vala"
void tree_select_last (Tree* self) {
#line 224 "tree.vala"
	g_return_if_fail (self != NULL);
#line 226 "tree.vala"
	if (gtk_widget_get_visible ((GtkWidget*) self)) {
#line 363 "tree.c"
		GtkTreeIter iter = {0};
		GtkTreeModel* model;
		GtkTreeSelection* selection;
		GtkTreePath* path;
		gint children = 0;
		GtkTreeSelection* _tmp0_;
		GtkTreeModel* _tmp1_;
		model = NULL;
		selection = NULL;
		path = NULL;
#line 234 "tree.vala"
		selection = (_tmp0_ = _g_object_ref0 (gtk_tree_view_get_selection (self->priv->tree_view)), _g_object_unref0 (selection), _tmp0_);
#line 235 "tree.vala"
		model = (_tmp1_ = _g_object_ref0 (gtk_tree_view_get_model (self->priv->tree_view)), _g_object_unref0 (model), _tmp1_);
#line 237 "tree.vala"
		children = gtk_tree_model_iter_n_children (model, NULL);
#line 238 "tree.vala"
		if (children > 0) {
#line 382 "tree.c"
			GtkTreePath* _tmp2_;
#line 240 "tree.vala"
			gtk_tree_model_iter_nth_child (model, &iter, NULL, children - 1);
#line 242 "tree.vala"
			gtk_tree_selection_select_iter (selection, &iter);
#line 243 "tree.vala"
			path = (_tmp2_ = gtk_tree_model_get_path (model, &iter), _gtk_tree_path_free0 (path), _tmp2_);
#line 244 "tree.vala"
			gtk_tree_view_scroll_to_cell (self->priv->tree_view, path, NULL, FALSE, (float) 0, (float) 0);
#line 392 "tree.c"
		}
		_g_object_unref0 (model);
		_g_object_unref0 (selection);
		_gtk_tree_path_free0 (path);
	}
}


#line 254 "tree.vala"
void tree_select_previous (Tree* self, gint rows) {
#line 254 "tree.vala"
	g_return_if_fail (self != NULL);
#line 256 "tree.vala"
	if (gtk_widget_get_visible ((GtkWidget*) self)) {
#line 407 "tree.c"
		GtkTreeIter iter = {0};
		GtkTreePath* path;
		GtkTreeModel* model;
		GtkTreeSelection* selection;
		GtkTreeSelection* _tmp0_;
		GtkTreeModel* _tmp3_;
		gboolean _tmp2_;
		GtkTreeModel* _tmp1_ = NULL;
		path = NULL;
		model = NULL;
		selection = NULL;
#line 263 "tree.vala"
		selection = (_tmp0_ = _g_object_ref0 (gtk_tree_view_get_selection (self->priv->tree_view)), _g_object_unref0 (selection), _tmp0_);
#line 265 "tree.vala"
		if ((_tmp2_ = gtk_tree_selection_get_selected (selection, &_tmp1_, &iter), model = (_tmp3_ = _g_object_ref0 (_tmp1_), _g_object_unref0 (model), _tmp3_), _tmp2_)) {
#line 423 "tree.c"
			GtkTreePath* _tmp4_;
#line 267 "tree.vala"
			path = (_tmp4_ = gtk_tree_model_get_path (model, &iter), _gtk_tree_path_free0 (path), _tmp4_);
#line 427 "tree.c"
			{
				gint i;
#line 268 "tree.vala"
				i = 0;
#line 432 "tree.c"
				{
					gboolean _tmp5_;
#line 268 "tree.vala"
					_tmp5_ = TRUE;
#line 268 "tree.vala"
					while (TRUE) {
#line 268 "tree.vala"
						if (!_tmp5_) {
#line 268 "tree.vala"
							i++;
#line 443 "tree.c"
						}
#line 268 "tree.vala"
						_tmp5_ = FALSE;
#line 268 "tree.vala"
						if (!(i < rows)) {
#line 268 "tree.vala"
							break;
#line 451 "tree.c"
						}
#line 270 "tree.vala"
						gtk_tree_path_prev (path);
#line 455 "tree.c"
					}
				}
			}
#line 273 "tree.vala"
			if (gtk_tree_model_get_iter (model, &iter, path)) {
#line 275 "tree.vala"
				gtk_tree_selection_select_iter (selection, &iter);
#line 276 "tree.vala"
				gtk_tree_view_scroll_to_cell (self->priv->tree_view, path, NULL, FALSE, (float) 0, (float) 0);
#line 465 "tree.c"
			}
		} else {
#line 281 "tree.vala"
			tree_select_first (self);
#line 470 "tree.c"
		}
		_gtk_tree_path_free0 (path);
		_g_object_unref0 (model);
		_g_object_unref0 (selection);
	}
}


#line 291 "tree.vala"
void tree_select_next (Tree* self, gint rows) {
#line 291 "tree.vala"
	g_return_if_fail (self != NULL);
#line 293 "tree.vala"
	if (gtk_widget_get_visible ((GtkWidget*) self)) {
#line 485 "tree.c"
		GtkTreeIter iter = {0};
		GtkTreeModel* model;
		GtkTreeSelection* selection;
		GtkTreeSelection* _tmp0_;
		GtkTreeModel* _tmp3_;
		gboolean _tmp2_;
		GtkTreeModel* _tmp1_ = NULL;
		model = NULL;
		selection = NULL;
#line 299 "tree.vala"
		selection = (_tmp0_ = _g_object_ref0 (gtk_tree_view_get_selection (self->priv->tree_view)), _g_object_unref0 (selection), _tmp0_);
#line 301 "tree.vala"
		if ((_tmp2_ = gtk_tree_selection_get_selected (selection, &_tmp1_, &iter), model = (_tmp3_ = _g_object_ref0 (_tmp1_), _g_object_unref0 (model), _tmp3_), _tmp2_)) {
#line 499 "tree.c"
			GtkTreePath* path;
			GtkTreePath* _tmp4_;
			GtkTreePath* _tmp6_;
			path = NULL;
#line 305 "tree.vala"
			path = (_tmp4_ = gtk_tree_model_get_path (model, &iter), _gtk_tree_path_free0 (path), _tmp4_);
#line 506 "tree.c"
			{
				gint i;
#line 306 "tree.vala"
				i = 0;
#line 511 "tree.c"
				{
					gboolean _tmp5_;
#line 306 "tree.vala"
					_tmp5_ = TRUE;
#line 306 "tree.vala"
					while (TRUE) {
#line 306 "tree.vala"
						if (!_tmp5_) {
#line 306 "tree.vala"
							i++;
#line 522 "tree.c"
						}
#line 306 "tree.vala"
						_tmp5_ = FALSE;
#line 306 "tree.vala"
						if (!(i < rows)) {
#line 306 "tree.vala"
							break;
#line 530 "tree.c"
						}
#line 308 "tree.vala"
						if (!gtk_tree_model_iter_next (model, &iter)) {
#line 310 "tree.vala"
							tree_select_last (self);
#line 536 "tree.c"
							_gtk_tree_path_free0 (path);
							_g_object_unref0 (model);
							_g_object_unref0 (selection);
#line 311 "tree.vala"
							return;
#line 542 "tree.c"
						}
					}
				}
			}
#line 315 "tree.vala"
			gtk_tree_selection_select_iter (selection, &iter);
#line 316 "tree.vala"
			path = (_tmp6_ = gtk_tree_model_get_path (model, &iter), _gtk_tree_path_free0 (path), _tmp6_);
#line 317 "tree.vala"
			gtk_tree_view_scroll_to_cell (self->priv->tree_view, path, NULL, FALSE, (float) 0, (float) 0);
#line 553 "tree.c"
			_gtk_tree_path_free0 (path);
		} else {
#line 321 "tree.vala"
			tree_select_first (self);
#line 558 "tree.c"
		}
		_g_object_unref0 (model);
		_g_object_unref0 (selection);
	}
}


#line 329 "tree.vala"
gint tree_get_num_proposals (Tree* self) {
#line 568 "tree.c"
	gint result;
	GtkTreeModel* model;
	GtkTreeModel* _tmp0_;
#line 329 "tree.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 574 "tree.c"
	model = NULL;
#line 333 "tree.vala"
	model = (_tmp0_ = _g_object_ref0 (gtk_tree_view_get_model (self->priv->tree_view)), _g_object_unref0 (model), _tmp0_);
#line 578 "tree.c"
	result = gtk_tree_model_iter_n_children (model, NULL);
	_g_object_unref0 (model);
#line 334 "tree.vala"
	return result;
#line 583 "tree.c"
}


#line 342 "tree.vala"
void tree_filter (Tree* self, const char* filter) {
#line 589 "tree.c"
	char* _tmp0_;
	char* _tmp1_;
#line 342 "tree.vala"
	g_return_if_fail (self != NULL);
#line 342 "tree.vala"
	g_return_if_fail (filter != NULL);
#line 344 "tree.vala"
	self->priv->active_filter = TRUE;
#line 345 "tree.vala"
	self->priv->current_filter = (_tmp0_ = g_strdup (filter), _g_free0 (self->priv->current_filter), _tmp0_);
#line 346 "tree.vala"
	gtk_tree_model_filter_refilter (self->priv->model_filter);
#line 347 "tree.vala"
	self->priv->active_filter = FALSE;
#line 348 "tree.vala"
	self->priv->current_filter = (_tmp1_ = NULL, _g_free0 (self->priv->current_filter), _tmp1_);
#line 606 "tree.c"
}


#line 25 "tree.vala"
Tree* tree_construct (GType object_type) {
#line 612 "tree.c"
	Tree * self;
	self = g_object_newv (object_type, 0, NULL);
	return self;
}


#line 25 "tree.vala"
Tree* tree_new (void) {
#line 25 "tree.vala"
	return tree_construct (TYPE_TREE);
#line 623 "tree.c"
}


#line 63 "tree.vala"
static gboolean _tree_filter_by_name_func_gtk_tree_model_filter_visible_func (GtkTreeModel* model, GtkTreeIter* iter, gpointer self) {
#line 629 "tree.c"
	return tree_filter_by_name_func (self, model, iter);
}


#line 47 "tree.vala"
static void _tree_tree_row_activated_cb_gtk_tree_view_row_activated (GtkTreeView* _sender, GtkTreePath* path, GtkTreeViewColumn* column, gpointer self) {
#line 636 "tree.c"
	tree_tree_row_activated_cb (self, _sender, path, column);
}


static GObject * tree_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	Tree * self;
	parent_class = G_OBJECT_CLASS (tree_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = TREE (obj);
	{
		GtkCellRendererText* renderer;
		GtkTreeViewColumn* column;
		GtkCellRendererPixbuf* renderer_pixbuf;
		GtkTreeViewColumn* column_pixbuf;
		GtkTreeSelection* selection;
		char* _tmp0_;
		GtkTreeView* _tmp1_;
		GtkCellRendererPixbuf* _tmp2_;
		GtkTreeViewColumn* _tmp3_;
		GtkTreeViewColumn* _tmp4_;
		GtkCellRendererText* _tmp5_;
		GtkListStore* _tmp6_;
		GtkTreeModelFilter* _tmp7_;
		GtkTreeSelection* _tmp8_;
		renderer = NULL;
		column = NULL;
		renderer_pixbuf = NULL;
		column_pixbuf = NULL;
		selection = NULL;
#line 102 "tree.vala"
		self->priv->destroy_has_run = FALSE;
#line 103 "tree.vala"
		self->priv->current_filter = (_tmp0_ = NULL, _g_free0 (self->priv->current_filter), _tmp0_);
#line 104 "tree.vala"
		self->priv->active_filter = FALSE;
#line 105 "tree.vala"
		gtk_scrolled_window_set_policy ((GtkScrolledWindow*) self, GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
#line 107 "tree.vala"
		self->priv->tree_view = (_tmp1_ = g_object_ref_sink ((GtkTreeView*) gtk_tree_view_new ()), _g_object_unref0 (self->priv->tree_view), _tmp1_);
#line 108 "tree.vala"
		g_object_set ((GtkWidget*) self->priv->tree_view, "can-focus", FALSE, NULL);
#line 109 "tree.vala"
		gtk_tree_view_set_headers_visible (self->priv->tree_view, FALSE);
#line 110 "tree.vala"
		gtk_widget_show ((GtkWidget*) self->priv->tree_view);
#line 112 "tree.vala"
		gtk_container_add ((GtkContainer*) self, (GtkWidget*) self->priv->tree_view);
#line 115 "tree.vala"
		renderer_pixbuf = (_tmp2_ = g_object_ref_sink ((GtkCellRendererPixbuf*) gtk_cell_renderer_pixbuf_new ()), _g_object_unref0 (renderer_pixbuf), _tmp2_);
#line 116 "tree.vala"
		column_pixbuf = (_tmp3_ = g_object_ref_sink (gtk_tree_view_column_new_with_attributes ("Pixbuf", (GtkCellRenderer*) renderer_pixbuf, "pixbuf", TREE_COL_PIXBUF, NULL)), _g_object_unref0 (column_pixbuf), _tmp3_);
#line 121 "tree.vala"
		column = (_tmp4_ = g_object_ref_sink (gtk_tree_view_column_new ()), _g_object_unref0 (column), _tmp4_);
#line 122 "tree.vala"
		renderer = (_tmp5_ = g_object_ref_sink ((GtkCellRendererText*) gtk_cell_renderer_text_new ()), _g_object_unref0 (renderer), _tmp5_);
#line 123 "tree.vala"
		gtk_cell_layout_pack_start ((GtkCellLayout*) column, (GtkCellRenderer*) renderer, FALSE);
#line 124 "tree.vala"
		gtk_tree_view_column_set_attributes (column, (GtkCellRenderer*) renderer, "text", TREE_COL_NAME, NULL);
#line 126 "tree.vala"
		gtk_tree_view_append_column (self->priv->tree_view, column_pixbuf);
#line 127 "tree.vala"
		gtk_tree_view_append_column (self->priv->tree_view, column);
#line 130 "tree.vala"
		self->priv->list_store = (_tmp6_ = gtk_list_store_new ((gint) TREE_COL_NB, GDK_TYPE_PIXBUF, G_TYPE_STRING, TYPE_PROPOSAL, NULL), _g_object_unref0 (self->priv->list_store), _tmp6_);
#line 133 "tree.vala"
		gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) self->priv->list_store, (gint) TREE_COL_NAME, GTK_SORT_ASCENDING);
#line 135 "tree.vala"
		self->priv->model_filter = (_tmp7_ = (GtkTreeModelFilter*) gtk_tree_model_filter_new ((GtkTreeModel*) self->priv->list_store, NULL), _g_object_unref0 (self->priv->model_filter), _tmp7_);
#line 136 "tree.vala"
		gtk_tree_model_filter_set_visible_func (self->priv->model_filter, _tree_filter_by_name_func_gtk_tree_model_filter_visible_func, g_object_ref (self), g_object_unref);
#line 137 "tree.vala"
		gtk_tree_view_set_model (self->priv->tree_view, (GtkTreeModel*) self->priv->model_filter);
#line 141 "tree.vala"
		g_signal_connect_object (self->priv->tree_view, "row-activated", (GCallback) _tree_tree_row_activated_cb_gtk_tree_view_row_activated, self, 0);
#line 143 "tree.vala"
		selection = (_tmp8_ = _g_object_ref0 (gtk_tree_view_get_selection (self->priv->tree_view)), _g_object_unref0 (selection), _tmp8_);
#line 716 "tree.c"
		_g_object_unref0 (renderer);
		_g_object_unref0 (column);
		_g_object_unref0 (renderer_pixbuf);
		_g_object_unref0 (column_pixbuf);
		_g_object_unref0 (selection);
	}
	return obj;
}


static void tree_class_init (TreeClass * klass) {
	tree_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (TreePrivate));
	G_OBJECT_CLASS (klass)->constructor = tree_constructor;
	G_OBJECT_CLASS (klass)->finalize = tree_finalize;
	g_signal_new ("proposal_selected", TYPE_TREE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_PROPOSAL);
}


static void tree_instance_init (Tree * self) {
	self->priv = TREE_GET_PRIVATE (self);
}


static void tree_finalize (GObject* obj) {
	Tree * self;
	self = TREE (obj);
	_g_free0 (self->priv->current_filter);
	_g_object_unref0 (self->priv->tree_view);
	_g_object_unref0 (self->priv->list_store);
	_g_object_unref0 (self->priv->model_filter);
	G_OBJECT_CLASS (tree_parent_class)->finalize (obj);
}


GType tree_get_type (void) {
	static GType tree_type_id = 0;
	if (tree_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (TreeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tree_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Tree), 0, (GInstanceInitFunc) tree_instance_init, NULL };
		tree_type_id = g_type_register_static (GTK_TYPE_SCROLLED_WINDOW, "Tree", &g_define_type_info, 0);
	}
	return tree_type_id;
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




