/* util.c generated by valac, the Vala compiler
 * generated from util.vala, do not modify */

/* Copyright 2009 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <valagee.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>


#define TYPE_STACK (stack_get_type ())
#define STACK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STACK, Stack))
#define STACK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STACK, StackClass))
#define IS_STACK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STACK))
#define IS_STACK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STACK))
#define STACK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STACK, StackClass))

typedef struct _Stack Stack;
typedef struct _StackClass StackClass;
typedef struct _StackPrivate StackPrivate;
#define _vala_collection_object_unref0(var) ((var == NULL) ? NULL : (var = (vala_collection_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_io_channel_unref0(var) ((var == NULL) ? NULL : (var = (g_io_channel_unref (var), NULL)))

struct _Stack {
	GObject parent_instance;
	StackPrivate * priv;
};

struct _StackClass {
	GObjectClass parent_class;
};

struct _StackPrivate {
	GType g_type;
	GBoxedCopyFunc g_dup_func;
	GDestroyNotify g_destroy_func;
	ValaArrayList* container;
};


static gpointer stack_parent_class = NULL;

void qsort (void* p, gsize num, gsize size, GCompareFunc func);
GType stack_get_type (void);
#define STACK_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_STACK, StackPrivate))
enum  {
	STACK_DUMMY_PROPERTY,
	STACK_G_TYPE,
	STACK_G_DUP_FUNC,
	STACK_G_DESTROY_FUNC
};
Stack* stack_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func);
Stack* stack_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func);
void stack_push (Stack* self, gconstpointer item);
gpointer stack_top (Stack* self);
void stack_pop (Stack* self);
gint stack_size (Stack* self);
static void stack_finalize (GObject* obj);
static void stack_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void stack_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
gboolean dir_has_parent (const char* dir, const char* parent);
gint compare_string (void* a, void* b);
char* filename_to_uri (const char* filename);
void make_pipe (gint fd, GIOFunc func, void* func_target, GError** error);
void idle_add (GSourceFunc function, void* function_target, gint priority);
static int _vala_strcmp0 (const char * str1, const char * str2);



#line 14 "util.vala"
Stack* stack_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func) {
#line 83 "util.c"
	Stack * self;
	ValaArrayList* _tmp0_;
#line 14 "util.vala"
	self = (Stack*) g_object_new (object_type, NULL);
#line 14 "util.vala"
	self->priv->g_type = g_type;
#line 14 "util.vala"
	self->priv->g_dup_func = g_dup_func;
#line 14 "util.vala"
	self->priv->g_destroy_func = g_destroy_func;
#line 15 "util.vala"
	self->priv->container = (_tmp0_ = vala_array_list_new (g_type, (GBoxedCopyFunc) g_dup_func, g_destroy_func, g_direct_equal), _vala_collection_object_unref0 (self->priv->container), _tmp0_);
#line 96 "util.c"
	return self;
}


#line 14 "util.vala"
Stack* stack_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func) {
#line 14 "util.vala"
	return stack_construct (TYPE_STACK, g_type, g_dup_func, g_destroy_func);
#line 105 "util.c"
}


#line 18 "util.vala"
void stack_push (Stack* self, gconstpointer item) {
#line 18 "util.vala"
	g_return_if_fail (self != NULL);
#line 19 "util.vala"
	vala_collection_add ((ValaCollection*) self->priv->container, item);
#line 115 "util.c"
}


#line 22 "util.vala"
gpointer stack_top (Stack* self) {
#line 121 "util.c"
	gpointer result;
#line 22 "util.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "util.vala"
	g_assert (vala_collection_get_size ((ValaCollection*) self->priv->container) > 0);
#line 127 "util.c"
	result = vala_list_get ((ValaList*) self->priv->container, vala_collection_get_size ((ValaCollection*) self->priv->container) - 1);
#line 24 "util.vala"
	return result;
#line 131 "util.c"
}


#line 27 "util.vala"
void stack_pop (Stack* self) {
#line 27 "util.vala"
	g_return_if_fail (self != NULL);
#line 28 "util.vala"
	g_assert (vala_collection_get_size ((ValaCollection*) self->priv->container) > 0);
#line 29 "util.vala"
	vala_list_remove_at ((ValaList*) self->priv->container, vala_collection_get_size ((ValaCollection*) self->priv->container) - 1);
#line 143 "util.c"
}


#line 32 "util.vala"
gint stack_size (Stack* self) {
#line 149 "util.c"
	gint result;
#line 32 "util.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 153 "util.c"
	result = vala_collection_get_size ((ValaCollection*) self->priv->container);
#line 33 "util.vala"
	return result;
#line 157 "util.c"
}


static void stack_class_init (StackClass * klass) {
	stack_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (StackPrivate));
	G_OBJECT_CLASS (klass)->get_property = stack_get_property;
	G_OBJECT_CLASS (klass)->set_property = stack_set_property;
	G_OBJECT_CLASS (klass)->finalize = stack_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), STACK_G_TYPE, g_param_spec_gtype ("g-type", "type", "type", G_TYPE_NONE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), STACK_G_DUP_FUNC, g_param_spec_pointer ("g-dup-func", "dup func", "dup func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), STACK_G_DESTROY_FUNC, g_param_spec_pointer ("g-destroy-func", "destroy func", "destroy func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}


static void stack_instance_init (Stack * self) {
	self->priv = STACK_GET_PRIVATE (self);
}


static void stack_finalize (GObject* obj) {
	Stack * self;
	self = STACK (obj);
	_vala_collection_object_unref0 (self->priv->container);
	G_OBJECT_CLASS (stack_parent_class)->finalize (obj);
}


GType stack_get_type (void) {
	static GType stack_type_id = 0;
	if (stack_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (StackClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) stack_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Stack), 0, (GInstanceInitFunc) stack_instance_init, NULL };
		stack_type_id = g_type_register_static (G_TYPE_OBJECT, "Stack", &g_define_type_info, 0);
	}
	return stack_type_id;
}


static void stack_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	Stack * self;
	self = STACK (object);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void stack_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	Stack * self;
	self = STACK (object);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
		case STACK_G_TYPE:
		self->priv->g_type = g_value_get_gtype (value);
		break;
		case STACK_G_DUP_FUNC:
		self->priv->g_dup_func = g_value_get_pointer (value);
		break;
		case STACK_G_DESTROY_FUNC:
		self->priv->g_destroy_func = g_value_get_pointer (value);
		break;
	}
}


#line 39 "util.vala"
gboolean dir_has_parent (const char* dir, const char* parent) {
#line 229 "util.c"
	gboolean result;
	GFile* new_path;
#line 39 "util.vala"
	g_return_val_if_fail (dir != NULL, FALSE);
#line 39 "util.vala"
	g_return_val_if_fail (parent != NULL, FALSE);
#line 40 "util.vala"
	new_path = g_file_new_for_path (dir);
#line 41 "util.vala"
	while (TRUE) {
#line 240 "util.c"
		char* _tmp0_;
		gboolean _tmp1_;
		GFile* _tmp2_;
#line 41 "util.vala"
		if ((_tmp1_ = !(_vala_strcmp0 (parent, _tmp0_ = g_file_get_path (new_path)) != 0), _g_free0 (_tmp0_), _tmp1_)) {
#line 41 "util.vala"
			break;
#line 248 "util.c"
		}
#line 42 "util.vala"
		new_path = (_tmp2_ = g_file_get_parent (new_path), _g_object_unref0 (new_path), _tmp2_);
#line 44 "util.vala"
		if (new_path == NULL) {
#line 254 "util.c"
			result = FALSE;
			_g_object_unref0 (new_path);
#line 45 "util.vala"
			return result;
#line 259 "util.c"
		}
	}
	result = TRUE;
	_g_object_unref0 (new_path);
#line 48 "util.vala"
	return result;
#line 266 "util.c"
}


#line 51 "util.vala"
gint compare_string (void* a, void* b) {
#line 272 "util.c"
	gint result;
	gchar** a_string;
	gchar** b_string;
#line 52 "util.vala"
	a_string = a;
#line 53 "util.vala"
	b_string = b;
#line 280 "util.c"
	result = strcmp (*a_string, *b_string);
#line 55 "util.vala"
	return result;
#line 284 "util.c"
}


#line 58 "util.vala"
char* filename_to_uri (const char* filename) {
#line 290 "util.c"
	char* result;
	GError * _inner_error_;
#line 58 "util.vala"
	g_return_val_if_fail (filename != NULL, NULL);
#line 295 "util.c"
	_inner_error_ = NULL;
	{
		char* _tmp0_;
#line 60 "util.vala"
		_tmp0_ = g_filename_to_uri (filename, NULL, &_inner_error_);
#line 301 "util.c"
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_CONVERT_ERROR) {
				goto __catch15_g_convert_error;
			}
			goto __finally15;
		}
		result = _tmp0_;
#line 60 "util.vala"
		return result;
#line 311 "util.c"
	}
	goto __finally15;
	__catch15_g_convert_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			result = NULL;
			_g_error_free0 (e);
#line 61 "util.vala"
			return result;
#line 324 "util.c"
		}
	}
	__finally15:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


#line 64 "util.vala"
void make_pipe (gint fd, GIOFunc func, void* func_target, GError** error) {
#line 338 "util.c"
	GError * _inner_error_;
	GIOChannel* pipe;
	_inner_error_ = NULL;
#line 65 "util.vala"
	pipe = g_io_channel_unix_new (fd);
#line 66 "util.vala"
	g_io_channel_set_flags (pipe, G_IO_FLAG_NONBLOCK, &_inner_error_);
#line 346 "util.c"
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_IO_CHANNEL_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_io_channel_unref0 (pipe);
			return;
		} else {
			_g_io_channel_unref0 (pipe);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
#line 67 "util.vala"
	g_io_add_watch (pipe, G_IO_IN | G_IO_HUP, func, func_target);
#line 361 "util.c"
	_g_io_channel_unref0 (pipe);
}


#line 71 "util.vala"
void idle_add (GSourceFunc function, void* function_target, gint priority) {
#line 72 "util.vala"
	g_idle_add_full (priority, function, function_target, NULL);
#line 370 "util.c"
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




