/* configure-executable.c generated by valac, the Vala compiler
 * generated from configure-executable.vala, do not modify */

/* configure-executable.vala
 *
 * Copyright (C) 2008-2009  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <nicolas.joseph@valaide.org>
 */

#include <glib.h>
#include <glib-object.h>
#include <valide-0.0.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>


#define TYPE_CONFIGURE_EXECUTABLE (configure_executable_get_type ())
#define CONFIGURE_EXECUTABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIGURE_EXECUTABLE, ConfigureExecutable))
#define CONFIGURE_EXECUTABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIGURE_EXECUTABLE, ConfigureExecutableClass))
#define IS_CONFIGURE_EXECUTABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIGURE_EXECUTABLE))
#define IS_CONFIGURE_EXECUTABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIGURE_EXECUTABLE))
#define CONFIGURE_EXECUTABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIGURE_EXECUTABLE, ConfigureExecutableClass))

typedef struct _ConfigureExecutable ConfigureExecutable;
typedef struct _ConfigureExecutableClass ConfigureExecutableClass;
typedef struct _ConfigureExecutablePrivate ConfigureExecutablePrivate;

struct _ConfigureExecutable {
	ValideExecutable parent_instance;
	ConfigureExecutablePrivate * priv;
};

struct _ConfigureExecutableClass {
	ValideExecutableClass parent_class;
};


static gpointer configure_executable_parent_class = NULL;

GType configure_executable_get_type (void);
enum  {
	CONFIGURE_EXECUTABLE_DUMMY_PROPERTY,
	CONFIGURE_EXECUTABLE_EXECUTABLE
};
#define CONFIGURE_EXECUTABLE_EXECUTABLE_PATH "./configure"
static void configure_executable_real_get_color_line (ValideExecutable* base, char** line, GdkColor* color);
ConfigureExecutable* configure_executable_new (void);
ConfigureExecutable* configure_executable_construct (GType object_type);
static void configure_executable_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void configure_executable_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);



#line 39 "configure-executable.vala"
static void configure_executable_real_get_color_line (ValideExecutable* base, char** line, GdkColor* color) {
#line 73 "configure-executable.c"
	ConfigureExecutable * self;
	self = (ConfigureExecutable*) base;
#line 39 "configure-executable.vala"
	g_return_if_fail (line != NULL);
#line 41 "configure-executable.vala"
	VALIDE_EXECUTABLE_CLASS (configure_executable_parent_class)->get_color_line (VALIDE_EXECUTABLE (self), line, color);
#line 42 "configure-executable.vala"
	if (g_str_has_suffix (*line, "finished successfully")) {
#line 44 "configure-executable.vala"
		gdk_color_parse (VALIDE_UTILS_COLOR_SUCCESS, color);
#line 84 "configure-executable.c"
	} else {
#line 48 "configure-executable.vala"
		if (g_str_has_suffix (*line, "yes")) {
#line 50 "configure-executable.vala"
			gdk_color_parse (VALIDE_UTILS_COLOR_SUCCESS, color);
#line 90 "configure-executable.c"
		} else {
#line 52 "configure-executable.vala"
			if (g_str_has_suffix (*line, "no")) {
#line 54 "configure-executable.vala"
				gdk_color_parse (VALIDE_UTILS_COLOR_WARNING, color);
#line 96 "configure-executable.c"
			} else {
#line 56 "configure-executable.vala"
				if (g_str_has_prefix (*line, "configure: error:")) {
#line 58 "configure-executable.vala"
					gdk_color_parse (VALIDE_UTILS_COLOR_ERROR, color);
#line 102 "configure-executable.c"
				}
			}
		}
	}
}


#line 24 "configure-executable.vala"
ConfigureExecutable* configure_executable_construct (GType object_type) {
#line 112 "configure-executable.c"
	ConfigureExecutable * self;
#line 24 "configure-executable.vala"
	self = (ConfigureExecutable*) valide_executable_construct (object_type);
#line 116 "configure-executable.c"
	return self;
}


#line 24 "configure-executable.vala"
ConfigureExecutable* configure_executable_new (void) {
#line 24 "configure-executable.vala"
	return configure_executable_construct (TYPE_CONFIGURE_EXECUTABLE);
#line 125 "configure-executable.c"
}


static const char* configure_executable_real_get_executable (ValideExecutable* base) {
	const char* result;
	ConfigureExecutable* self;
	self = (ConfigureExecutable*) base;
	result = CONFIGURE_EXECUTABLE_EXECUTABLE_PATH;
#line 32 "configure-executable.vala"
	return result;
#line 136 "configure-executable.c"
}


static void configure_executable_real_set_executable (ValideExecutable* base, const char* value) {
	ConfigureExecutable* self;
	self = (ConfigureExecutable*) base;
	g_object_notify ((GObject *) self, "executable");
}


static void configure_executable_class_init (ConfigureExecutableClass * klass) {
	configure_executable_parent_class = g_type_class_peek_parent (klass);
	VALIDE_EXECUTABLE_CLASS (klass)->get_color_line = configure_executable_real_get_color_line;
	VALIDE_EXECUTABLE_CLASS (klass)->get_executable = configure_executable_real_get_executable;
	VALIDE_EXECUTABLE_CLASS (klass)->set_executable = configure_executable_real_set_executable;
	G_OBJECT_CLASS (klass)->get_property = configure_executable_get_property;
	G_OBJECT_CLASS (klass)->set_property = configure_executable_set_property;
	g_object_class_override_property (G_OBJECT_CLASS (klass), CONFIGURE_EXECUTABLE_EXECUTABLE, "executable");
}


static void configure_executable_instance_init (ConfigureExecutable * self) {
}


GType configure_executable_get_type (void) {
	static GType configure_executable_type_id = 0;
	if (configure_executable_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ConfigureExecutableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) configure_executable_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ConfigureExecutable), 0, (GInstanceInitFunc) configure_executable_instance_init, NULL };
		configure_executable_type_id = g_type_register_static (VALIDE_TYPE_EXECUTABLE, "ConfigureExecutable", &g_define_type_info, 0);
	}
	return configure_executable_type_id;
}


static void configure_executable_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	ConfigureExecutable * self;
	self = CONFIGURE_EXECUTABLE (object);
	switch (property_id) {
		case CONFIGURE_EXECUTABLE_EXECUTABLE:
		g_value_set_string (value, valide_executable_get_executable ((ValideExecutable*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void configure_executable_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	ConfigureExecutable * self;
	self = CONFIGURE_EXECUTABLE (object);
	switch (property_id) {
		case CONFIGURE_EXECUTABLE_EXECUTABLE:
		valide_executable_set_executable ((ValideExecutable*) self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}




