/* opened-documents.c generated by valac, the Vala compiler
 * generated from opened-documents.vala, do not modify */

/* opened-documents.vala
 *
 * Copyright (C) 2009 Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <nicolas.joseph@valaide.org>
 */

#include <glib.h>
#include <glib-object.h>
#include <valide-0.0.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <pango/pango.h>
#include <gdl/gdl.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <glib/gi18n-lib.h>


#define TYPE_OPENED_DOCUMENTS (opened_documents_get_type ())
#define OPENED_DOCUMENTS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_OPENED_DOCUMENTS, OpenedDocuments))
#define OPENED_DOCUMENTS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_OPENED_DOCUMENTS, OpenedDocumentsClass))
#define IS_OPENED_DOCUMENTS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_OPENED_DOCUMENTS))
#define IS_OPENED_DOCUMENTS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_OPENED_DOCUMENTS))
#define OPENED_DOCUMENTS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_OPENED_DOCUMENTS, OpenedDocumentsClass))

typedef struct _OpenedDocuments OpenedDocuments;
typedef struct _OpenedDocumentsClass OpenedDocumentsClass;
typedef struct _OpenedDocumentsPrivate OpenedDocumentsPrivate;

#define OPENED_DOCUMENTS_TYPE_COL (opened_documents_col_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _OpenedDocuments {
	GObject parent_instance;
	OpenedDocumentsPrivate * priv;
};

struct _OpenedDocumentsClass {
	GObjectClass parent_class;
};

struct _OpenedDocumentsPrivate {
	GtkVBox* box;
	GtkTreeView* tree_view;
	ValideDocumentManager* documents;
	char* _path;
	ValideWindow* _window;
};

typedef enum  {
	OPENED_DOCUMENTS_COL_ICON,
	OPENED_DOCUMENTS_COL_NAME,
	OPENED_DOCUMENTS_COL_DOCUMENT,
	OPENED_DOCUMENTS_COL_STYLE,
	OPENED_DOCUMENTS_COL_TOOLTIP,
	OPENED_DOCUMENTS_COL_NB
} OpenedDocumentsCol;


static gpointer opened_documents_parent_class = NULL;
static ValidePluginIface* opened_documents_valide_plugin_parent_iface = NULL;

GType opened_documents_get_type (void);
#define OPENED_DOCUMENTS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_OPENED_DOCUMENTS, OpenedDocumentsPrivate))
enum  {
	OPENED_DOCUMENTS_DUMMY_PROPERTY,
	OPENED_DOCUMENTS_PATH,
	OPENED_DOCUMENTS_WINDOW
};
static GType opened_documents_col_get_type (void);
static void opened_documents_on_tab_changed (OpenedDocuments* self);
static gboolean opened_documents_populate_asc (OpenedDocuments* self);
static gboolean _opened_documents_populate_asc_gsource_func (gpointer self);
static void opened_documents_populate (OpenedDocuments* self);
static void opened_documents_on_cursor_change (OpenedDocuments* self, GtkTreeView* sender);
OpenedDocuments* opened_documents_new (void);
OpenedDocuments* opened_documents_construct (GType object_type);
static void _opened_documents_on_cursor_change_gtk_tree_view_cursor_changed (GtkTreeView* _sender, gpointer self);
static void _opened_documents_populate_valide_document_manager_tab_removed (ValideDocumentManager* _sender, ValideiDocument* document, gpointer self);
static void _opened_documents_populate_valide_document_manager_tab_added (ValideDocumentManager* _sender, ValideiDocument* document, gpointer self);
static void _opened_documents_populate_valide_document_manager_tab_state_changed (ValideDocumentManager* _sender, ValideiDocument* document, gpointer self);
static void _opened_documents_on_tab_changed_valide_document_manager_tab_changed (ValideDocumentManager* _sender, ValideiDocument* document, gpointer self);
static GObject * opened_documents_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void opened_documents_finalize (GObject* obj);
static void opened_documents_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void opened_documents_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
GType register_plugin (void);




static GType opened_documents_col_get_type (void) {
	static GType opened_documents_col_type_id = 0;
	if (G_UNLIKELY (opened_documents_col_type_id == 0)) {
		static const GEnumValue values[] = {{OPENED_DOCUMENTS_COL_ICON, "OPENED_DOCUMENTS_COL_ICON", "icon"}, {OPENED_DOCUMENTS_COL_NAME, "OPENED_DOCUMENTS_COL_NAME", "name"}, {OPENED_DOCUMENTS_COL_DOCUMENT, "OPENED_DOCUMENTS_COL_DOCUMENT", "document"}, {OPENED_DOCUMENTS_COL_STYLE, "OPENED_DOCUMENTS_COL_STYLE", "style"}, {OPENED_DOCUMENTS_COL_TOOLTIP, "OPENED_DOCUMENTS_COL_TOOLTIP", "tooltip"}, {OPENED_DOCUMENTS_COL_NB, "OPENED_DOCUMENTS_COL_NB", "nb"}, {0, NULL, NULL}};
		opened_documents_col_type_id = g_enum_register_static ("OpenedDocumentsCol", values);
	}
	return opened_documents_col_type_id;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 44 "opened-documents.vala"
static gboolean opened_documents_populate_asc (OpenedDocuments* self) {
#line 129 "opened-documents.c"
	gboolean result;
	GtkTreeIter iter = {0};
	GtkListStore* model;
	GtkListStore* _tmp1_;
	GtkTreeModel* _tmp0_;
#line 44 "opened-documents.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 137 "opened-documents.c"
	model = NULL;
#line 49 "opened-documents.vala"
	model = (_tmp1_ = _g_object_ref0 ((_tmp0_ = gtk_tree_view_get_model (self->priv->tree_view), GTK_IS_LIST_STORE (_tmp0_) ? ((GtkListStore*) _tmp0_) : NULL)), _g_object_unref0 (model), _tmp1_);
#line 50 "opened-documents.vala"
	gtk_list_store_clear (model);
#line 143 "opened-documents.c"
	{
		GList* document_collection;
		GList* document_it;
#line 52 "opened-documents.vala"
		document_collection = valide_document_manager_get_documents (self->priv->documents);
#line 149 "opened-documents.c"
		for (document_it = document_collection; document_it != NULL; document_it = document_it->next) {
			ValideiDocument* document;
#line 52 "opened-documents.vala"
			document = _g_object_ref0 ((ValideiDocument*) document_it->data);
#line 154 "opened-documents.c"
			{
				char* tooltip;
				PangoStyle style = 0;
				char* _tmp2_;
				GdkPixbuf* _tmp3_;
				tooltip = NULL;
#line 57 "opened-documents.vala"
				if (valide_idocument_get_is_save (document)) {
#line 59 "opened-documents.vala"
					style = PANGO_STYLE_NORMAL;
#line 165 "opened-documents.c"
				} else {
#line 63 "opened-documents.vala"
					style = PANGO_STYLE_ITALIC;
#line 169 "opened-documents.c"
				}
#line 65 "opened-documents.vala"
				tooltip = (_tmp2_ = valide_idocument_get_tooltips (document), _g_free0 (tooltip), _tmp2_);
#line 66 "opened-documents.vala"
				gtk_list_store_append (model, &iter);
#line 67 "opened-documents.vala"
				gtk_list_store_set (model, &iter, OPENED_DOCUMENTS_COL_ICON, _tmp3_ = valide_idocument_get_icon (document), OPENED_DOCUMENTS_COL_NAME, valide_idocument_get_filename (document), OPENED_DOCUMENTS_COL_DOCUMENT, document, OPENED_DOCUMENTS_COL_STYLE, style, OPENED_DOCUMENTS_COL_TOOLTIP, tooltip, -1);
#line 177 "opened-documents.c"
				_g_object_unref0 (_tmp3_);
				_g_object_unref0 (document);
				_g_free0 (tooltip);
			}
		}
	}
#line 73 "opened-documents.vala"
	opened_documents_on_tab_changed (self);
#line 186 "opened-documents.c"
	result = FALSE;
	_g_object_unref0 (model);
#line 74 "opened-documents.vala"
	return result;
#line 191 "opened-documents.c"
}


#line 44 "opened-documents.vala"
static gboolean _opened_documents_populate_asc_gsource_func (gpointer self) {
#line 197 "opened-documents.c"
	return opened_documents_populate_asc (self);
}


#line 77 "opened-documents.vala"
static void opened_documents_populate (OpenedDocuments* self) {
#line 77 "opened-documents.vala"
	g_return_if_fail (self != NULL);
#line 79 "opened-documents.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _opened_documents_populate_asc_gsource_func, g_object_ref (self), g_object_unref);
#line 208 "opened-documents.c"
}


#line 82 "opened-documents.vala"
static void opened_documents_on_cursor_change (OpenedDocuments* self, GtkTreeView* sender) {
#line 214 "opened-documents.c"
	ValideiDocument* document;
	GtkTreeModel* model;
	GtkTreeIter iter = {0};
	GtkTreeSelection* selection;
	GtkTreeSelection* _tmp0_;
	GtkTreeModel* _tmp3_;
	gboolean _tmp2_;
	GtkTreeModel* _tmp1_ = NULL;
#line 82 "opened-documents.vala"
	g_return_if_fail (self != NULL);
#line 82 "opened-documents.vala"
	g_return_if_fail (sender != NULL);
#line 227 "opened-documents.c"
	document = NULL;
	model = NULL;
	selection = NULL;
#line 89 "opened-documents.vala"
	selection = (_tmp0_ = _g_object_ref0 (gtk_tree_view_get_selection (self->priv->tree_view)), _g_object_unref0 (selection), _tmp0_);
#line 91 "opened-documents.vala"
	if ((_tmp2_ = gtk_tree_selection_get_selected (selection, &_tmp1_, &iter), model = (_tmp3_ = _g_object_ref0 (_tmp1_), _g_object_unref0 (model), _tmp3_), _tmp2_)) {
#line 93 "opened-documents.vala"
		gtk_tree_model_get (model, &iter, OPENED_DOCUMENTS_COL_DOCUMENT, &document, -1);
#line 94 "opened-documents.vala"
		valide_document_manager_set_current (self->priv->documents, document);
#line 239 "opened-documents.c"
	}
	_g_object_unref0 (document);
	_g_object_unref0 (model);
	_g_object_unref0 (selection);
}


#line 98 "opened-documents.vala"
static void opened_documents_on_tab_changed (OpenedDocuments* self) {
#line 249 "opened-documents.c"
	GtkTreeIter iter = {0};
	ValideiDocument* document;
	GtkListStore* list_store;
	GtkListStore* _tmp1_;
	GtkTreeModel* _tmp0_;
#line 98 "opened-documents.vala"
	g_return_if_fail (self != NULL);
#line 257 "opened-documents.c"
	document = NULL;
	list_store = NULL;
#line 104 "opened-documents.vala"
	list_store = (_tmp1_ = _g_object_ref0 ((_tmp0_ = gtk_tree_view_get_model (self->priv->tree_view), GTK_IS_LIST_STORE (_tmp0_) ? ((GtkListStore*) _tmp0_) : NULL)), _g_object_unref0 (list_store), _tmp1_);
#line 105 "opened-documents.vala"
	if (gtk_tree_model_get_iter_first ((GtkTreeModel*) list_store, &iter)) {
#line 264 "opened-documents.c"
		{
			gboolean _tmp2_;
#line 107 "opened-documents.vala"
			_tmp2_ = TRUE;
#line 107 "opened-documents.vala"
			while (TRUE) {
#line 107 "opened-documents.vala"
				if (!_tmp2_) {
#line 115 "opened-documents.vala"
					if (!gtk_tree_model_iter_next ((GtkTreeModel*) list_store, &iter)) {
#line 115 "opened-documents.vala"
						break;
#line 277 "opened-documents.c"
					}
				}
#line 107 "opened-documents.vala"
				_tmp2_ = FALSE;
#line 109 "opened-documents.vala"
				gtk_tree_model_get ((GtkTreeModel*) list_store, &iter, OPENED_DOCUMENTS_COL_DOCUMENT, &document, -1);
#line 110 "opened-documents.vala"
				if (document == valide_document_manager_get_current (self->priv->documents)) {
#line 112 "opened-documents.vala"
					gtk_tree_selection_select_iter (gtk_tree_view_get_selection (self->priv->tree_view), &iter);
#line 113 "opened-documents.vala"
					break;
#line 290 "opened-documents.c"
				}
			}
		}
	}
	_g_object_unref0 (document);
	_g_object_unref0 (list_store);
}


#line 24 "opened-documents.vala"
OpenedDocuments* opened_documents_construct (GType object_type) {
#line 302 "opened-documents.c"
	OpenedDocuments * self;
	self = g_object_newv (object_type, 0, NULL);
	return self;
}


#line 24 "opened-documents.vala"
OpenedDocuments* opened_documents_new (void) {
#line 24 "opened-documents.vala"
	return opened_documents_construct (TYPE_OPENED_DOCUMENTS);
#line 313 "opened-documents.c"
}


static const char* opened_documents_real_get_path (ValidePlugin* base) {
	const char* result;
	OpenedDocuments* self;
	self = (OpenedDocuments*) base;
	result = self->priv->_path;
#line 41 "opened-documents.vala"
	return result;
#line 324 "opened-documents.c"
}


static void opened_documents_real_set_path (ValidePlugin* base, const char* value) {
	OpenedDocuments* self;
	char* _tmp0_;
	self = (OpenedDocuments*) base;
	self->priv->_path = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_path), _tmp0_);
	g_object_notify ((GObject *) self, "path");
}


static ValideWindow* opened_documents_real_get_window (ValidePlugin* base) {
	ValideWindow* result;
	OpenedDocuments* self;
	self = (OpenedDocuments*) base;
	result = self->priv->_window;
#line 42 "opened-documents.vala"
	return result;
#line 344 "opened-documents.c"
}


static void opened_documents_real_set_window (ValidePlugin* base, ValideWindow* value) {
	OpenedDocuments* self;
	ValideWindow* _tmp0_;
	self = (OpenedDocuments*) base;
	self->priv->_window = (_tmp0_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_window), _tmp0_);
	g_object_notify ((GObject *) self, "window");
}


#line 82 "opened-documents.vala"
static void _opened_documents_on_cursor_change_gtk_tree_view_cursor_changed (GtkTreeView* _sender, gpointer self) {
#line 359 "opened-documents.c"
	opened_documents_on_cursor_change (self, _sender);
}


#line 77 "opened-documents.vala"
static void _opened_documents_populate_valide_document_manager_tab_removed (ValideDocumentManager* _sender, ValideiDocument* document, gpointer self) {
#line 366 "opened-documents.c"
	opened_documents_populate (self);
}


#line 77 "opened-documents.vala"
static void _opened_documents_populate_valide_document_manager_tab_added (ValideDocumentManager* _sender, ValideiDocument* document, gpointer self) {
#line 373 "opened-documents.c"
	opened_documents_populate (self);
}


#line 77 "opened-documents.vala"
static void _opened_documents_populate_valide_document_manager_tab_state_changed (ValideDocumentManager* _sender, ValideiDocument* document, gpointer self) {
#line 380 "opened-documents.c"
	opened_documents_populate (self);
}


#line 98 "opened-documents.vala"
static void _opened_documents_on_tab_changed_valide_document_manager_tab_changed (ValideDocumentManager* _sender, ValideiDocument* document, gpointer self) {
#line 387 "opened-documents.c"
	opened_documents_on_tab_changed (self);
}


static GObject * opened_documents_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	OpenedDocuments * self;
	parent_class = G_OBJECT_CLASS (opened_documents_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = OPENED_DOCUMENTS (obj);
	{
		GtkListStore* store;
		GdlDockItem* parent;
		GtkTreeViewColumn* col;
		GtkCellRenderer* renderer;
		GtkScrolledWindow* scrolled;
		GtkVBox* _tmp0_;
		GtkScrolledWindow* _tmp1_;
		GtkTreeView* _tmp2_;
		GtkListStore* _tmp3_;
		GtkTreeViewColumn* _tmp4_;
		GtkCellRenderer* _tmp5_;
		GtkCellRenderer* _tmp6_;
		ValideDocumentManager* _tmp7_;
		store = NULL;
		parent = NULL;
		col = NULL;
		renderer = NULL;
		scrolled = NULL;
#line 127 "opened-documents.vala"
		self->priv->box = (_tmp0_ = g_object_ref_sink ((GtkVBox*) gtk_vbox_new (FALSE, 0)), _g_object_unref0 (self->priv->box), _tmp0_);
#line 130 "opened-documents.vala"
		gtk_box_set_spacing ((GtkBox*) self->priv->box, 2);
#line 131 "opened-documents.vala"
		gtk_container_set_border_width ((GtkContainer*) self->priv->box, (guint) 2);
#line 134 "opened-documents.vala"
		scrolled = (_tmp1_ = g_object_ref_sink ((GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL)), _g_object_unref0 (scrolled), _tmp1_);
#line 135 "opened-documents.vala"
		gtk_scrolled_window_set_policy (scrolled, GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
#line 136 "opened-documents.vala"
		gtk_scrolled_window_set_shadow_type (scrolled, GTK_SHADOW_IN);
#line 137 "opened-documents.vala"
		gtk_box_pack_start ((GtkBox*) self->priv->box, (GtkWidget*) scrolled, TRUE, TRUE, (guint) 0);
#line 139 "opened-documents.vala"
		self->priv->tree_view = (_tmp2_ = g_object_ref_sink ((GtkTreeView*) gtk_tree_view_new ()), _g_object_unref0 (self->priv->tree_view), _tmp2_);
#line 140 "opened-documents.vala"
		gtk_tree_view_set_rules_hint (self->priv->tree_view, FALSE);
#line 141 "opened-documents.vala"
		gtk_tree_view_set_headers_visible (self->priv->tree_view, FALSE);
#line 142 "opened-documents.vala"
		gtk_container_add ((GtkContainer*) scrolled, (GtkWidget*) self->priv->tree_view);
#line 145 "opened-documents.vala"
		store = (_tmp3_ = gtk_list_store_new ((gint) OPENED_DOCUMENTS_COL_NB, GDK_TYPE_PIXBUF, G_TYPE_STRING, VALIDE_TYPE_IDOCUMENT, PANGO_TYPE_STYLE, G_TYPE_STRING, NULL), _g_object_unref0 (store), _tmp3_);
#line 148 "opened-documents.vala"
		gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) store, (gint) OPENED_DOCUMENTS_COL_NAME, GTK_SORT_ASCENDING);
#line 151 "opened-documents.vala"
		col = (_tmp4_ = g_object_ref_sink (gtk_tree_view_column_new ()), _g_object_unref0 (col), _tmp4_);
#line 152 "opened-documents.vala"
		gtk_tree_view_column_set_title (col, _ ("File"));
#line 154 "opened-documents.vala"
		renderer = (_tmp5_ = (GtkCellRenderer*) g_object_ref_sink ((GtkCellRendererPixbuf*) gtk_cell_renderer_pixbuf_new ()), _g_object_unref0 (renderer), _tmp5_);
#line 155 "opened-documents.vala"
		gtk_cell_layout_pack_start ((GtkCellLayout*) col, renderer, FALSE);
#line 156 "opened-documents.vala"
		gtk_tree_view_column_set_attributes (col, renderer, "pixbuf", OPENED_DOCUMENTS_COL_ICON, NULL);
#line 158 "opened-documents.vala"
		renderer = (_tmp6_ = (GtkCellRenderer*) g_object_ref_sink ((GtkCellRendererText*) gtk_cell_renderer_text_new ()), _g_object_unref0 (renderer), _tmp6_);
#line 159 "opened-documents.vala"
		gtk_cell_layout_pack_start ((GtkCellLayout*) col, renderer, FALSE);
#line 160 "opened-documents.vala"
		gtk_tree_view_column_set_attributes (col, renderer, "markup", OPENED_DOCUMENTS_COL_NAME, "style", OPENED_DOCUMENTS_COL_STYLE, NULL);
#line 162 "opened-documents.vala"
		gtk_tree_view_append_column (self->priv->tree_view, col);
#line 163 "opened-documents.vala"
		gtk_tree_view_set_model (self->priv->tree_view, (GtkTreeModel*) store);
#line 165 "opened-documents.vala"
		gtk_tree_view_set_tooltip_column (self->priv->tree_view, (gint) OPENED_DOCUMENTS_COL_TOOLTIP);
#line 168 "opened-documents.vala"
		g_signal_connect_object (self->priv->tree_view, "cursor-changed", (GCallback) _opened_documents_on_cursor_change_gtk_tree_view_cursor_changed, self, 0);
#line 170 "opened-documents.vala"
		self->priv->documents = (_tmp7_ = _g_object_ref0 (valide_window_get_documents (valide_plugin_get_window ((ValidePlugin*) self))), _g_object_unref0 (self->priv->documents), _tmp7_);
#line 172 "opened-documents.vala"
		g_signal_connect_object (self->priv->documents, "tab-removed", (GCallback) _opened_documents_populate_valide_document_manager_tab_removed, self, 0);
#line 173 "opened-documents.vala"
		g_signal_connect_object (self->priv->documents, "tab-added", (GCallback) _opened_documents_populate_valide_document_manager_tab_added, self, 0);
#line 174 "opened-documents.vala"
		g_signal_connect_object (self->priv->documents, "tab-state-changed", (GCallback) _opened_documents_populate_valide_document_manager_tab_state_changed, self, 0);
#line 175 "opened-documents.vala"
		g_signal_connect_object (self->priv->documents, "tab-changed", (GCallback) _opened_documents_on_tab_changed_valide_document_manager_tab_changed, self, 0);
#line 177 "opened-documents.vala"
		opened_documents_populate (self);
#line 179 "opened-documents.vala"
		valide_window_add_widget (valide_plugin_get_window ((ValidePlugin*) self), (GtkWidget*) self->priv->box, "opened-documents-plugin", _ ("Documents"), VALIDE_WINDOW_PLACEMENT_LEFT, GTK_STOCK_FILE);
#line 482 "opened-documents.c"
		_g_object_unref0 (store);
		_g_object_unref0 (parent);
		_g_object_unref0 (col);
		_g_object_unref0 (renderer);
		_g_object_unref0 (scrolled);
	}
	return obj;
}


static void opened_documents_class_init (OpenedDocumentsClass * klass) {
	opened_documents_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (OpenedDocumentsPrivate));
	G_OBJECT_CLASS (klass)->get_property = opened_documents_get_property;
	G_OBJECT_CLASS (klass)->set_property = opened_documents_set_property;
	G_OBJECT_CLASS (klass)->constructor = opened_documents_constructor;
	G_OBJECT_CLASS (klass)->finalize = opened_documents_finalize;
	g_object_class_override_property (G_OBJECT_CLASS (klass), OPENED_DOCUMENTS_PATH, "path");
	g_object_class_override_property (G_OBJECT_CLASS (klass), OPENED_DOCUMENTS_WINDOW, "window");
}


static void opened_documents_valide_plugin_interface_init (ValidePluginIface * iface) {
	opened_documents_valide_plugin_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_path = opened_documents_real_get_path;
	iface->set_path = opened_documents_real_set_path;
	iface->get_window = opened_documents_real_get_window;
	iface->set_window = opened_documents_real_set_window;
}


static void opened_documents_instance_init (OpenedDocuments * self) {
	self->priv = OPENED_DOCUMENTS_GET_PRIVATE (self);
}


static void opened_documents_finalize (GObject* obj) {
	OpenedDocuments * self;
	self = OPENED_DOCUMENTS (obj);
	{
		guint _tmp8_;
		guint _tmp9_;
		guint _tmp10_;
		guint _tmp11_;
#line 185 "opened-documents.vala"
		g_signal_handlers_disconnect_matched (self->priv->documents, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, (g_signal_parse_name ("tab-removed", VALIDE_TYPE_DOCUMENT_MANAGER, &_tmp8_, NULL, FALSE), _tmp8_), 0, NULL, (GCallback) _opened_documents_populate_valide_document_manager_tab_removed, self);
#line 186 "opened-documents.vala"
		g_signal_handlers_disconnect_matched (self->priv->documents, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, (g_signal_parse_name ("tab-added", VALIDE_TYPE_DOCUMENT_MANAGER, &_tmp9_, NULL, FALSE), _tmp9_), 0, NULL, (GCallback) _opened_documents_populate_valide_document_manager_tab_added, self);
#line 187 "opened-documents.vala"
		g_signal_handlers_disconnect_matched (self->priv->documents, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, (g_signal_parse_name ("tab-state-changed", VALIDE_TYPE_DOCUMENT_MANAGER, &_tmp10_, NULL, FALSE), _tmp10_), 0, NULL, (GCallback) _opened_documents_populate_valide_document_manager_tab_state_changed, self);
#line 188 "opened-documents.vala"
		g_signal_handlers_disconnect_matched (self->priv->documents, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, (g_signal_parse_name ("tab-changed", VALIDE_TYPE_DOCUMENT_MANAGER, &_tmp11_, NULL, FALSE), _tmp11_), 0, NULL, (GCallback) _opened_documents_on_tab_changed_valide_document_manager_tab_changed, self);
#line 190 "opened-documents.vala"
		valide_window_remove_widget (valide_plugin_get_window ((ValidePlugin*) self), (GtkWidget*) self->priv->box);
#line 537 "opened-documents.c"
	}
	_g_object_unref0 (self->priv->box);
	_g_object_unref0 (self->priv->tree_view);
	_g_object_unref0 (self->priv->documents);
	_g_free0 (self->priv->_path);
	_g_object_unref0 (self->priv->_window);
	G_OBJECT_CLASS (opened_documents_parent_class)->finalize (obj);
}


GType opened_documents_get_type (void) {
	static GType opened_documents_type_id = 0;
	if (opened_documents_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (OpenedDocumentsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) opened_documents_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (OpenedDocuments), 0, (GInstanceInitFunc) opened_documents_instance_init, NULL };
		static const GInterfaceInfo valide_plugin_info = { (GInterfaceInitFunc) opened_documents_valide_plugin_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		opened_documents_type_id = g_type_register_static (G_TYPE_OBJECT, "OpenedDocuments", &g_define_type_info, 0);
		g_type_add_interface_static (opened_documents_type_id, VALIDE_TYPE_PLUGIN, &valide_plugin_info);
	}
	return opened_documents_type_id;
}


static void opened_documents_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	OpenedDocuments * self;
	self = OPENED_DOCUMENTS (object);
	switch (property_id) {
		case OPENED_DOCUMENTS_PATH:
		g_value_set_string (value, valide_plugin_get_path ((ValidePlugin*) self));
		break;
		case OPENED_DOCUMENTS_WINDOW:
		g_value_set_object (value, valide_plugin_get_window ((ValidePlugin*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void opened_documents_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	OpenedDocuments * self;
	self = OPENED_DOCUMENTS (object);
	switch (property_id) {
		case OPENED_DOCUMENTS_PATH:
		valide_plugin_set_path ((ValidePlugin*) self, g_value_get_string (value));
		break;
		case OPENED_DOCUMENTS_WINDOW:
		valide_plugin_set_window ((ValidePlugin*) self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


#line 195 "opened-documents.vala"
GType register_plugin (void) {
#line 596 "opened-documents.c"
	GType result;
	result = TYPE_OPENED_DOCUMENTS;
#line 197 "opened-documents.vala"
	return result;
#line 601 "opened-documents.c"
}




