/* symbol.c generated by valac, the Vala compiler
 * generated from symbol.vala, do not modify */

/* symbol-browser.vala
 *
 * Copyright (C) 2008-2009  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <nicolas.joseph@valaide.org>
 */
/*
 * This code is re-writing in the vala language of GeditSymbolBrowserPlugin
 *
 * Copyright (C) 2007 - Micah Carrick
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <valide-0.0.h>
#include <gtk/gtk.h>
#include <config.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <glib/gstdio.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>


#define TYPE_SYMBOL (symbol_get_type ())
#define SYMBOL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SYMBOL, Symbol))
#define SYMBOL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SYMBOL, SymbolClass))
#define IS_SYMBOL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SYMBOL))
#define IS_SYMBOL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SYMBOL))
#define SYMBOL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SYMBOL, SymbolClass))

typedef struct _Symbol Symbol;
typedef struct _SymbolClass SymbolClass;
typedef struct _SymbolPrivate SymbolPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _symbol_unref0(var) ((var == NULL) ? NULL : (var = (symbol_unref (var), NULL)))
typedef struct _ParamSpecSymbol ParamSpecSymbol;

#define TYPE_SYMBOL_BROWSER (symbol_browser_get_type ())
#define SYMBOL_BROWSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SYMBOL_BROWSER, SymbolBrowser))
#define SYMBOL_BROWSER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SYMBOL_BROWSER, SymbolBrowserClass))
#define IS_SYMBOL_BROWSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SYMBOL_BROWSER))
#define IS_SYMBOL_BROWSER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SYMBOL_BROWSER))
#define SYMBOL_BROWSER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SYMBOL_BROWSER, SymbolBrowserClass))

typedef struct _SymbolBrowser SymbolBrowser;
typedef struct _SymbolBrowserClass SymbolBrowserClass;
typedef struct _SymbolBrowserPrivate SymbolBrowserPrivate;

#define SYMBOL_BROWSER_TYPE_COL (symbol_browser_col_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __g_slist_free_g_free0(var) ((var == NULL) ? NULL : (var = (_g_slist_free_g_free (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _gtk_tree_path_free0(var) ((var == NULL) ? NULL : (var = (gtk_tree_path_free (var), NULL)))

struct _Symbol {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SymbolPrivate * priv;
	char* name;
	char* full_name;
	char* signature;
	char** inherits;
	gint inherits_length1;
	gint inherits_size;
	char* typeref;
	char* access;
	char* implementation;
	char* type;
	char* file;
	char* language;
	gint line;
	Symbol* root;
	ValideAbstractTextDocument* document;
};

struct _SymbolClass {
	GTypeClass parent_class;
	void (*finalize) (Symbol *self);
};

struct _ParamSpecSymbol {
	GParamSpec parent_instance;
};

typedef enum  {
	SYMBOL_ERROR_KIND
} SymbolError;
#define SYMBOL_ERROR symbol_error_quark ()
struct _SymbolBrowser {
	GObject parent_instance;
	SymbolBrowserPrivate * priv;
};

struct _SymbolBrowserClass {
	GObjectClass parent_class;
};

struct _SymbolBrowserPrivate {
	gint atom;
	GtkVBox* box;
	GtkLabel* label;
	guint status_context;
	GtkTreeStore* model;
	GtkTreeView* tree_view;
	GSList* expanded_rows;
	GtkTreeViewColumn* language_column;
	GtkTreeViewColumn* source_file_column;
	GtkTreeViewColumn* line_number_column;
	GHashTable* root_nodes;
	char* _path;
	ValideWindow* _window;
};

typedef enum  {
	SYMBOL_BROWSER_COL_ICON,
	SYMBOL_BROWSER_COL_NAME,
	SYMBOL_BROWSER_COL_FILE,
	SYMBOL_BROWSER_COL_LINE,
	SYMBOL_BROWSER_COL_LANGUAGE,
	SYMBOL_BROWSER_COL_NB
} SymbolBrowserCol;


static gpointer symbol_parent_class = NULL;
static gpointer symbol_browser_parent_class = NULL;
static ValidePluginIface* symbol_browser_valide_plugin_parent_iface = NULL;

gpointer symbol_ref (gpointer instance);
void symbol_unref (gpointer instance);
GParamSpec* param_spec_symbol (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_symbol (GValue* value, gpointer v_object);
gpointer value_get_symbol (const GValue* value);
GType symbol_get_type (void);
enum  {
	SYMBOL_DUMMY_PROPERTY
};
Symbol* symbol_new (void);
Symbol* symbol_construct (GType object_type);
static void symbol_finalize (Symbol* obj);
GQuark symbol_error_quark (void);
GType symbol_browser_get_type (void);
#define SYMBOL_BROWSER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SYMBOL_BROWSER, SymbolBrowserPrivate))
enum  {
	SYMBOL_BROWSER_DUMMY_PROPERTY,
	SYMBOL_BROWSER_PATH,
	SYMBOL_BROWSER_WINDOW
};
static GType symbol_browser_col_get_type (void);
static void _g_slist_free_g_free (GSList* self);
static void symbol_browser_save_expanded_rows (SymbolBrowser* self);
static gboolean symbol_browser_is_expanded_row (SymbolBrowser* self, const char* name);
static void symbol_browser_add_expanded_row (SymbolBrowser* self, const char* name);
static void symbol_browser_remove_expanded_row (SymbolBrowser* self, const char* name);
static char* symbol_browser_exec_ctags (SymbolBrowser* self, const char* filename, GError** error);
static char** _vala_array_dup1 (char** self, int length);
static Symbol* symbol_browser_parse_line (SymbolBrowser* self, const char* line);
static void symbol_browser_clear_data (SymbolBrowser* self);
static gboolean symbol_browser_get_hierarchic_view (SymbolBrowser* self);
static GtkTreeIter* _gtk_tree_iter_dup (GtkTreeIter* self);
static gboolean symbol_browser_add_symbol (SymbolBrowser* self, Symbol* symbol);
static gboolean symbol_browser_populate_symbols_asc (SymbolBrowser* self);
static gboolean _symbol_browser_populate_symbols_asc_gsource_func (gpointer self);
static void symbol_browser_populate_symbols (SymbolBrowser* self);
static void symbol_browser_restore_expanded_rows (SymbolBrowser* self);
static void symbol_browser_on_row_activated (SymbolBrowser* self, GtkTreeView* sender, GtkTreePath* path, GtkTreeViewColumn* column);
static void symbol_browser_on_cursor_changed (SymbolBrowser* self, GtkTreeView* sender);
static void symbol_browser_on_row_expanded (SymbolBrowser* self, GtkTreeView* sender, GtkTreeIter* iter, GtkTreePath* path);
static void symbol_browser_on_row_collapsed (SymbolBrowser* self, GtkTreeView* sender, GtkTreeIter* iter, GtkTreePath* path);
SymbolBrowser* symbol_browser_new (const char* path);
SymbolBrowser* symbol_browser_construct (GType object_type, const char* path);
static gboolean symbol_browser_get_show_language_column (SymbolBrowser* self);
static void symbol_browser_set_show_language_column (SymbolBrowser* self, gboolean value);
static void _lambda0_ (GtkToggleButton* s, SymbolBrowser* self);
static void __lambda0__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
static gboolean symbol_browser_get_show_source_file_column (SymbolBrowser* self);
static void symbol_browser_set_show_source_file_column (SymbolBrowser* self, gboolean value);
static void _lambda1_ (GtkToggleButton* s, SymbolBrowser* self);
static void __lambda1__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
static gboolean symbol_browser_get_show_line_number_column (SymbolBrowser* self);
static void symbol_browser_set_show_line_number_column (SymbolBrowser* self, gboolean value);
static void _lambda2_ (GtkToggleButton* s, SymbolBrowser* self);
static void __lambda2__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
static void symbol_browser_set_hierarchic_view (SymbolBrowser* self, gboolean value);
static void _lambda3_ (GtkToggleButton* s, SymbolBrowser* self);
static void __lambda3__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
GtkWidget* symbol_browser_create_configure_dialog (SymbolBrowser* self);
static void _symbol_browser_on_row_activated_gtk_tree_view_row_activated (GtkTreeView* _sender, GtkTreePath* path, GtkTreeViewColumn* column, gpointer self);
static void _symbol_browser_on_cursor_changed_gtk_tree_view_cursor_changed (GtkTreeView* _sender, gpointer self);
static void _symbol_browser_on_row_expanded_gtk_tree_view_row_expanded (GtkTreeView* _sender, GtkTreeIter* iter, GtkTreePath* path, gpointer self);
static void _symbol_browser_on_row_collapsed_gtk_tree_view_row_collapsed (GtkTreeView* _sender, GtkTreeIter* iter, GtkTreePath* path, gpointer self);
static void _symbol_browser_populate_symbols_valide_document_manager_tab_removed (ValideDocumentManager* _sender, ValideiDocument* document, gpointer self);
static void _symbol_browser_populate_symbols_valide_document_manager_tab_changed (ValideDocumentManager* _sender, ValideiDocument* document, gpointer self);
static void _symbol_browser_populate_symbols_valide_document_manager_tab_saved (ValideDocumentManager* _sender, ValideiDocument* document, gpointer self);
static GObject * symbol_browser_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void symbol_browser_finalize (GObject* obj);
static void symbol_browser_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void symbol_browser_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
GType register_plugin (void);
GtkWidget* create_configure_dialog (SymbolBrowser* _self_);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);
static int _vala_strcmp0 (const char * str1, const char * str2);



#line 31 "symbol.vala"
Symbol* symbol_construct (GType object_type) {
#line 233 "symbol.c"
	Symbol* self;
	self = (Symbol*) g_type_create_instance (object_type);
	return self;
}


#line 31 "symbol.vala"
Symbol* symbol_new (void) {
#line 31 "symbol.vala"
	return symbol_construct (TYPE_SYMBOL);
#line 244 "symbol.c"
}


static void value_symbol_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_symbol_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		symbol_unref (value->data[0].v_pointer);
	}
}


static void value_symbol_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = symbol_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_symbol_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_symbol_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		Symbol* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = symbol_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_symbol_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	Symbol** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags && G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = symbol_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_symbol (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecSymbol* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_SYMBOL), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_symbol (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SYMBOL), NULL);
	return value->data[0].v_pointer;
}


void value_set_symbol (GValue* value, gpointer v_object) {
	Symbol* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SYMBOL));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SYMBOL));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		symbol_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		symbol_unref (old);
	}
}


static void symbol_class_init (SymbolClass * klass) {
	symbol_parent_class = g_type_class_peek_parent (klass);
	SYMBOL_CLASS (klass)->finalize = symbol_finalize;
}


static void symbol_instance_init (Symbol * self) {
	self->ref_count = 1;
}


static void symbol_finalize (Symbol* obj) {
	Symbol * self;
	self = SYMBOL (obj);
	_g_free0 (self->name);
	_g_free0 (self->full_name);
	_g_free0 (self->signature);
	self->inherits = (_vala_array_free (self->inherits, self->inherits_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (self->typeref);
	_g_free0 (self->access);
	_g_free0 (self->implementation);
	_g_free0 (self->type);
	_g_free0 (self->file);
	_g_free0 (self->language);
	_symbol_unref0 (self->root);
}


GType symbol_get_type (void) {
	static GType symbol_type_id = 0;
	if (symbol_type_id == 0) {
		static const GTypeValueTable g_define_type_value_table = { value_symbol_init, value_symbol_free_value, value_symbol_copy_value, value_symbol_peek_pointer, "p", value_symbol_collect_value, "p", value_symbol_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (SymbolClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) symbol_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Symbol), 0, (GInstanceInitFunc) symbol_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		symbol_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Symbol", &g_define_type_info, &g_define_type_fundamental_info, 0);
	}
	return symbol_type_id;
}


gpointer symbol_ref (gpointer instance) {
	Symbol* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void symbol_unref (gpointer instance) {
	Symbol* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		SYMBOL_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


GQuark symbol_error_quark (void) {
	return g_quark_from_static_string ("symbol_error-quark");
}



static GType symbol_browser_col_get_type (void) {
	static GType symbol_browser_col_type_id = 0;
	if (G_UNLIKELY (symbol_browser_col_type_id == 0)) {
		static const GEnumValue values[] = {{SYMBOL_BROWSER_COL_ICON, "SYMBOL_BROWSER_COL_ICON", "icon"}, {SYMBOL_BROWSER_COL_NAME, "SYMBOL_BROWSER_COL_NAME", "name"}, {SYMBOL_BROWSER_COL_FILE, "SYMBOL_BROWSER_COL_FILE", "file"}, {SYMBOL_BROWSER_COL_LINE, "SYMBOL_BROWSER_COL_LINE", "line"}, {SYMBOL_BROWSER_COL_LANGUAGE, "SYMBOL_BROWSER_COL_LANGUAGE", "language"}, {SYMBOL_BROWSER_COL_NB, "SYMBOL_BROWSER_COL_NB", "nb"}, {0, NULL, NULL}};
		symbol_browser_col_type_id = g_enum_register_static ("SymbolBrowserCol", values);
	}
	return symbol_browser_col_type_id;
}


static void _g_slist_free_g_free (GSList* self) {
	g_slist_foreach (self, (GFunc) g_free, NULL);
	g_slist_free (self);
}


#line 147 "symbol.vala"
static void symbol_browser_save_expanded_rows (SymbolBrowser* self) {
#line 147 "symbol.vala"
	g_return_if_fail (self != NULL);
#line 425 "symbol.c"
}


#line 172 "symbol.vala"
static gboolean symbol_browser_is_expanded_row (SymbolBrowser* self, const char* name) {
#line 431 "symbol.c"
	gboolean result;
	gboolean ret;
#line 172 "symbol.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 172 "symbol.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 174 "symbol.vala"
	ret = FALSE;
#line 440 "symbol.c"
	{
		GSList* i_collection;
		GSList* i_it;
#line 176 "symbol.vala"
		i_collection = self->priv->expanded_rows;
#line 446 "symbol.c"
		for (i_it = i_collection; i_it != NULL; i_it = i_it->next) {
			char* i;
#line 176 "symbol.vala"
			i = g_strdup ((const char*) i_it->data);
#line 451 "symbol.c"
			{
#line 178 "symbol.vala"
				if (_vala_strcmp0 (i, name) == 0) {
#line 180 "symbol.vala"
					ret = TRUE;
#line 457 "symbol.c"
					_g_free0 (i);
#line 181 "symbol.vala"
					break;
#line 461 "symbol.c"
				}
				_g_free0 (i);
			}
		}
	}
	result = ret;
#line 184 "symbol.vala"
	return result;
#line 470 "symbol.c"
}


#line 187 "symbol.vala"
static void symbol_browser_add_expanded_row (SymbolBrowser* self, const char* name) {
#line 187 "symbol.vala"
	g_return_if_fail (self != NULL);
#line 187 "symbol.vala"
	g_return_if_fail (name != NULL);
#line 189 "symbol.vala"
	if (!symbol_browser_is_expanded_row (self, name)) {
#line 191 "symbol.vala"
		self->priv->expanded_rows = g_slist_prepend (self->priv->expanded_rows, g_strdup (name));
#line 192 "symbol.vala"
		symbol_browser_save_expanded_rows (self);
#line 486 "symbol.c"
	}
}


#line 196 "symbol.vala"
static void symbol_browser_remove_expanded_row (SymbolBrowser* self, const char* name) {
#line 493 "symbol.c"
	GSList* l;
#line 196 "symbol.vala"
	g_return_if_fail (self != NULL);
#line 196 "symbol.vala"
	g_return_if_fail (name != NULL);
#line 499 "symbol.c"
	l = NULL;
#line 200 "symbol.vala"
	if (symbol_browser_is_expanded_row (self, name) == TRUE) {
#line 503 "symbol.c"
		{
			gboolean _tmp0_;
#line 202 "symbol.vala"
			l = self->priv->expanded_rows;
#line 202 "symbol.vala"
			_tmp0_ = TRUE;
#line 202 "symbol.vala"
			while (TRUE) {
#line 202 "symbol.vala"
				if (!_tmp0_) {
#line 202 "symbol.vala"
					l = l->next;
#line 516 "symbol.c"
				}
#line 202 "symbol.vala"
				_tmp0_ = FALSE;
#line 202 "symbol.vala"
				if (!(l != NULL)) {
#line 202 "symbol.vala"
					break;
#line 524 "symbol.c"
				}
#line 204 "symbol.vala"
				if (_vala_strcmp0 ((const char*) l->data, name) == 0) {
#line 206 "symbol.vala"
					self->priv->expanded_rows = g_slist_remove_all (self->priv->expanded_rows, (const char*) l->data);
#line 530 "symbol.c"
				}
			}
		}
#line 209 "symbol.vala"
		symbol_browser_save_expanded_rows (self);
#line 536 "symbol.c"
	}
}


#line 216 "symbol.vala"
static char* symbol_browser_exec_ctags (SymbolBrowser* self, const char* filename, GError** error) {
#line 543 "symbol.c"
	char* result;
	GError * _inner_error_;
	char* output;
	char* command;
	char* _tmp0_;
	char* _tmp3_;
	gboolean _tmp2_;
	char* _tmp1_ = NULL;
#line 216 "symbol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 216 "symbol.vala"
	g_return_val_if_fail (filename != NULL, NULL);
#line 556 "symbol.c"
	_inner_error_ = NULL;
	output = NULL;
	command = NULL;
#line 222 "symbol.vala"
	command = (_tmp0_ = g_strdup_printf ("%s --extra=+q --fields=afmiKlnsStz -f - \"%s\"", VALIDE_CTAGS_EXEC, filename), _g_free0 (command), _tmp0_);
#line 225 "symbol.vala"
	_tmp2_ = g_spawn_command_line_sync (command, &_tmp1_, NULL, NULL, &_inner_error_);
#line 225 "symbol.vala"
	output = (_tmp3_ = _tmp1_, _g_free0 (output), _tmp3_);
#line 225 "symbol.vala"
	_tmp2_;
#line 568 "symbol.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_free0 (output);
		_g_free0 (command);
		return NULL;
	}
	result = output;
	_g_free0 (command);
#line 227 "symbol.vala"
	return result;
#line 579 "symbol.c"
}


static char** _vala_array_dup1 (char** self, int length) {
	char** result;
	int i;
	result = g_new0 (char*, length + 1);
	for (i = 0; i < length; i++) {
		result[i] = g_strdup (self[i]);
	}
	return result;
}


#line 236 "symbol.vala"
static Symbol* symbol_browser_parse_line (SymbolBrowser* self, const char* line) {
#line 596 "symbol.c"
	Symbol* result;
	gint fields_size;
	gint fields_length1;
	char** fields;
	Symbol* symbol;
	char** _tmp1_;
	char** _tmp0_;
#line 236 "symbol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 236 "symbol.vala"
	g_return_val_if_fail (line != NULL, NULL);
#line 608 "symbol.c"
	fields = (fields_length1 = 0, NULL);
#line 248 "symbol.vala"
	symbol = NULL;
#line 250 "symbol.vala"
	fields = (_tmp1_ = _tmp0_ = g_strsplit (line, "\t", 0), fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL), fields_length1 = _vala_array_length (_tmp0_), fields_size = fields_length1, _tmp1_);
#line 251 "symbol.vala"
	if (fields[0] != NULL) {
#line 616 "symbol.c"
		char* filename;
		char* name;
		char* full_name;
		char* kind;
		gint file_position = 0;
		char* language;
		char* access;
		char** _tmp2_;
		gint inherits_size;
		gint inherits_length1;
		char** inherits;
		char* typeref;
		char* signature;
		char* implementation;
		gint splits_size;
		gint splits_length1;
		char** splits;
		Symbol* _tmp3_;
		char* _tmp4_;
		char* _tmp7_;
		char** _tmp9_;
		char** _tmp8_;
		char* _tmp10_;
		char** _tmp12_;
		char** _tmp11_;
		char** _tmp14_;
		char** _tmp13_;
		char* _tmp15_;
		GQuark _tmp60_;
		const char* _tmp59_;
		static GQuark _tmp60__label0 = 0;
		static GQuark _tmp60__label1 = 0;
		static GQuark _tmp60__label2 = 0;
		static GQuark _tmp60__label3 = 0;
		static GQuark _tmp60__label4 = 0;
		static GQuark _tmp60__label5 = 0;
		static GQuark _tmp60__label6 = 0;
		static GQuark _tmp60__label7 = 0;
		static GQuark _tmp60__label8 = 0;
		static GQuark _tmp60__label9 = 0;
		static GQuark _tmp60__label10 = 0;
		static GQuark _tmp60__label11 = 0;
		static GQuark _tmp60__label12 = 0;
		static GQuark _tmp60__label13 = 0;
		static GQuark _tmp60__label14 = 0;
		char* _tmp61_;
		char* _tmp62_;
		char* _tmp63_;
		char* _tmp64_;
		char** _tmp66_;
		char** _tmp65_;
		char* _tmp67_;
		Symbol* _tmp68_;
		filename = NULL;
		name = NULL;
		full_name = NULL;
		kind = NULL;
		language = NULL;
#line 259 "symbol.vala"
		access = NULL;
#line 677 "symbol.c"
		inherits = (_tmp2_ = NULL, inherits_length1 = 0, inherits_size = inherits_length1, _tmp2_);
#line 261 "symbol.vala"
		typeref = NULL;
#line 262 "symbol.vala"
		signature = NULL;
#line 263 "symbol.vala"
		implementation = NULL;
#line 685 "symbol.c"
		splits = (splits_length1 = 0, NULL);
#line 266 "symbol.vala"
		symbol = (_tmp3_ = symbol_new (), _symbol_unref0 (symbol), _tmp3_);
#line 267 "symbol.vala"
		full_name = (_tmp4_ = g_strdup (fields[0]), _g_free0 (full_name), _tmp4_);
#line 268 "symbol.vala"
		if (g_utf8_strrchr (full_name, (gssize) (-1), (gunichar) '.') != NULL) {
#line 693 "symbol.c"
			char* _tmp5_;
#line 270 "symbol.vala"
			name = (_tmp5_ = g_strdup (g_utf8_offset_to_pointer (g_utf8_strrchr (full_name, (gssize) (-1), (gunichar) '.'), (glong) 1)), _g_free0 (name), _tmp5_);
#line 697 "symbol.c"
		} else {
			char* _tmp6_;
#line 274 "symbol.vala"
			name = (_tmp6_ = g_strdup (full_name), _g_free0 (name), _tmp6_);
#line 702 "symbol.c"
		}
#line 276 "symbol.vala"
		filename = (_tmp7_ = g_strdup (fields[1]), _g_free0 (filename), _tmp7_);
#line 277 "symbol.vala"
		splits = (_tmp9_ = _tmp8_ = g_strsplit (fields[3], ":", 0), splits = (_vala_array_free (splits, splits_length1, (GDestroyNotify) g_free), NULL), splits_length1 = _vala_array_length (_tmp8_), splits_size = splits_length1, _tmp9_);
#line 278 "symbol.vala"
		kind = (_tmp10_ = g_strdup (splits[1]), _g_free0 (kind), _tmp10_);
#line 279 "symbol.vala"
		if (kind == NULL) {
#line 712 "symbol.c"
			result = NULL;
			_g_free0 (filename);
			_g_free0 (name);
			_g_free0 (full_name);
			_g_free0 (kind);
			_g_free0 (language);
			_g_free0 (access);
			inherits = (_vala_array_free (inherits, inherits_length1, (GDestroyNotify) g_free), NULL);
			_g_free0 (typeref);
			_g_free0 (signature);
			_g_free0 (implementation);
			splits = (_vala_array_free (splits, splits_length1, (GDestroyNotify) g_free), NULL);
			fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
			_symbol_unref0 (symbol);
#line 281 "symbol.vala"
			return result;
#line 729 "symbol.c"
		}
#line 284 "symbol.vala"
		splits = (_tmp12_ = _tmp11_ = g_strsplit (fields[4], ":", 0), splits = (_vala_array_free (splits, splits_length1, (GDestroyNotify) g_free), NULL), splits_length1 = _vala_array_length (_tmp11_), splits_size = splits_length1, _tmp12_);
#line 285 "symbol.vala"
		file_position = atoi (splits[1]);
#line 287 "symbol.vala"
		splits = (_tmp14_ = _tmp13_ = g_strsplit (fields[5], ":", 0), splits = (_vala_array_free (splits, splits_length1, (GDestroyNotify) g_free), NULL), splits_length1 = _vala_array_length (_tmp13_), splits_size = splits_length1, _tmp14_);
#line 288 "symbol.vala"
		language = (_tmp15_ = g_strdup (fields[1]), _g_free0 (language), _tmp15_);
#line 739 "symbol.c"
		_tmp59_ = kind;
		_tmp60_ = (NULL == _tmp59_) ? 0 : g_quark_from_string (_tmp59_);
		if ((((((_tmp60_ == ((0 != _tmp60__label0) ? _tmp60__label0 : (_tmp60__label0 = g_quark_from_static_string ("enumvalue")))) || (_tmp60_ == ((0 != _tmp60__label1) ? _tmp60__label1 : (_tmp60__label1 = g_quark_from_static_string ("errorcode"))))) || (_tmp60_ == ((0 != _tmp60__label2) ? _tmp60__label2 : (_tmp60__label2 = g_quark_from_static_string ("errordomain"))))) || (_tmp60_ == ((0 != _tmp60__label3) ? _tmp60__label3 : (_tmp60__label3 = g_quark_from_static_string ("enum"))))) || (_tmp60_ == ((0 != _tmp60__label4) ? _tmp60__label4 : (_tmp60__label4 = g_quark_from_static_string ("namespace"))))) || (_tmp60_ == ((0 != _tmp60__label5) ? _tmp60__label5 : (_tmp60__label5 = g_quark_from_static_string ("struct")))))
		do {
			char** _tmp17_;
			char** _tmp16_;
			char* _tmp18_;
#line 298 "symbol.vala"
			splits = (_tmp17_ = _tmp16_ = g_strsplit (fields[5], ":", 0), splits = (_vala_array_free (splits, splits_length1, (GDestroyNotify) g_free), NULL), splits_length1 = _vala_array_length (_tmp16_), splits_size = splits_length1, _tmp17_);
#line 299 "symbol.vala"
			access = (_tmp18_ = g_strdup (splits[1]), _g_free0 (access), _tmp18_);
#line 300 "symbol.vala"
			break;
#line 753 "symbol.c"
		} while (0); else if (_tmp60_ == ((0 != _tmp60__label6) ? _tmp60__label6 : (_tmp60__label6 = g_quark_from_static_string ("field"))))
		do {
			char** _tmp20_;
			char** _tmp19_;
			char* _tmp21_;
#line 302 "symbol.vala"
			splits = (_tmp20_ = _tmp19_ = g_strsplit (fields[6], ":", 0), splits = (_vala_array_free (splits, splits_length1, (GDestroyNotify) g_free), NULL), splits_length1 = _vala_array_length (_tmp19_), splits_size = splits_length1, _tmp20_);
#line 303 "symbol.vala"
			access = (_tmp21_ = g_strdup (splits[1]), _g_free0 (access), _tmp21_);
#line 304 "symbol.vala"
			break;
#line 765 "symbol.c"
		} while (0); else if (_tmp60_ == ((0 != _tmp60__label7) ? _tmp60__label7 : (_tmp60__label7 = g_quark_from_static_string ("class"))))
		do {
			char** _tmp23_;
			char** _tmp22_;
			gboolean _tmp24_ = FALSE;
			char** _tmp28_;
			char** _tmp27_;
			char* _tmp29_;
			char** _tmp31_;
			char** _tmp30_;
			char* _tmp32_;
#line 306 "symbol.vala"
			splits = (_tmp23_ = _tmp22_ = g_strsplit (fields[6], ":", 0), splits = (_vala_array_free (splits, splits_length1, (GDestroyNotify) g_free), NULL), splits_length1 = _vala_array_length (_tmp22_), splits_size = splits_length1, _tmp23_);
#line 307 "symbol.vala"
			if (splits != NULL) {
#line 307 "symbol.vala"
				_tmp24_ = splits[1] != NULL;
#line 783 "symbol.c"
			} else {
#line 307 "symbol.vala"
				_tmp24_ = FALSE;
#line 787 "symbol.c"
			}
#line 307 "symbol.vala"
			if (_tmp24_) {
#line 791 "symbol.c"
				char** _tmp26_;
				char** _tmp25_;
#line 309 "symbol.vala"
				inherits = (_tmp26_ = _tmp25_ = g_strsplit (splits[1], ",", 0), inherits = (_vala_array_free (inherits, inherits_length1, (GDestroyNotify) g_free), NULL), inherits_length1 = _vala_array_length (_tmp25_), inherits_size = inherits_length1, _tmp26_);
#line 796 "symbol.c"
			}
#line 311 "symbol.vala"
			splits = (_tmp28_ = _tmp27_ = g_strsplit (fields[7], ":", 0), splits = (_vala_array_free (splits, splits_length1, (GDestroyNotify) g_free), NULL), splits_length1 = _vala_array_length (_tmp27_), splits_size = splits_length1, _tmp28_);
#line 312 "symbol.vala"
			access = (_tmp29_ = g_strdup (splits[1]), _g_free0 (access), _tmp29_);
#line 313 "symbol.vala"
			splits = (_tmp31_ = _tmp30_ = g_strsplit (fields[8], ":", 0), splits = (_vala_array_free (splits, splits_length1, (GDestroyNotify) g_free), NULL), splits_length1 = _vala_array_length (_tmp30_), splits_size = splits_length1, _tmp31_);
#line 314 "symbol.vala"
			implementation = (_tmp32_ = g_strdup (splits[1]), _g_free0 (implementation), _tmp32_);
#line 315 "symbol.vala"
			break;
#line 808 "symbol.c"
		} while (0); else if (((_tmp60_ == ((0 != _tmp60__label8) ? _tmp60__label8 : (_tmp60__label8 = g_quark_from_static_string ("delegate")))) || (_tmp60_ == ((0 != _tmp60__label9) ? _tmp60__label9 : (_tmp60__label9 = g_quark_from_static_string ("method"))))) || (_tmp60_ == ((0 != _tmp60__label10) ? _tmp60__label10 : (_tmp60__label10 = g_quark_from_static_string ("signal")))))
		do {
			char** _tmp34_;
			char** _tmp33_;
			char* _tmp35_;
			char** _tmp37_;
			char** _tmp36_;
			char* _tmp38_;
			char** _tmp40_;
			char** _tmp39_;
			char* _tmp41_;
#line 319 "symbol.vala"
			splits = (_tmp34_ = _tmp33_ = g_strsplit (fields[6], ":", 0), splits = (_vala_array_free (splits, splits_length1, (GDestroyNotify) g_free), NULL), splits_length1 = _vala_array_length (_tmp33_), splits_size = splits_length1, _tmp34_);
#line 320 "symbol.vala"
			access = (_tmp35_ = g_strdup (splits[1]), _g_free0 (access), _tmp35_);
#line 321 "symbol.vala"
			splits = (_tmp37_ = _tmp36_ = g_strsplit (fields[7], ":", 0), splits = (_vala_array_free (splits, splits_length1, (GDestroyNotify) g_free), NULL), splits_length1 = _vala_array_length (_tmp36_), splits_size = splits_length1, _tmp37_);
#line 322 "symbol.vala"
			implementation = (_tmp38_ = g_strdup (splits[1]), _g_free0 (implementation), _tmp38_);
#line 323 "symbol.vala"
			splits = (_tmp40_ = _tmp39_ = g_strsplit (fields[8], ":", 0), splits = (_vala_array_free (splits, splits_length1, (GDestroyNotify) g_free), NULL), splits_length1 = _vala_array_length (_tmp39_), splits_size = splits_length1, _tmp40_);
#line 324 "symbol.vala"
			signature = (_tmp41_ = g_strdup (splits[1]), _g_free0 (signature), _tmp41_);
#line 325 "symbol.vala"
			break;
#line 834 "symbol.c"
		} while (0); else if (_tmp60_ == ((0 != _tmp60__label11) ? _tmp60__label11 : (_tmp60__label11 = g_quark_from_static_string ("interface"))))
		do {
			char** _tmp43_;
			char** _tmp42_;
			gboolean _tmp44_ = FALSE;
			char** _tmp48_;
			char** _tmp47_;
			char* _tmp49_;
#line 327 "symbol.vala"
			splits = (_tmp43_ = _tmp42_ = g_strsplit (fields[6], ":", 0), splits = (_vala_array_free (splits, splits_length1, (GDestroyNotify) g_free), NULL), splits_length1 = _vala_array_length (_tmp42_), splits_size = splits_length1, _tmp43_);
#line 328 "symbol.vala"
			if (splits != NULL) {
#line 328 "symbol.vala"
				_tmp44_ = splits[1] != NULL;
#line 849 "symbol.c"
			} else {
#line 328 "symbol.vala"
				_tmp44_ = FALSE;
#line 853 "symbol.c"
			}
#line 328 "symbol.vala"
			if (_tmp44_) {
#line 857 "symbol.c"
				char** _tmp46_;
				char** _tmp45_;
#line 330 "symbol.vala"
				inherits = (_tmp46_ = _tmp45_ = g_strsplit (splits[1], ",", 0), inherits = (_vala_array_free (inherits, inherits_length1, (GDestroyNotify) g_free), NULL), inherits_length1 = _vala_array_length (_tmp45_), inherits_size = inherits_length1, _tmp46_);
#line 862 "symbol.c"
			}
#line 332 "symbol.vala"
			splits = (_tmp48_ = _tmp47_ = g_strsplit (fields[7], ":", 0), splits = (_vala_array_free (splits, splits_length1, (GDestroyNotify) g_free), NULL), splits_length1 = _vala_array_length (_tmp47_), splits_size = splits_length1, _tmp48_);
#line 333 "symbol.vala"
			access = (_tmp49_ = g_strdup (splits[1]), _g_free0 (access), _tmp49_);
#line 334 "symbol.vala"
			break;
#line 870 "symbol.c"
		} while (0); else if (_tmp60_ == ((0 != _tmp60__label12) ? _tmp60__label12 : (_tmp60__label12 = g_quark_from_static_string ("property"))))
		do {
			char** _tmp51_;
			char** _tmp50_;
			char* _tmp52_;
			char** _tmp54_;
			char** _tmp53_;
			char* _tmp55_;
#line 336 "symbol.vala"
			splits = (_tmp51_ = _tmp50_ = g_strsplit (fields[6], ":", 0), splits = (_vala_array_free (splits, splits_length1, (GDestroyNotify) g_free), NULL), splits_length1 = _vala_array_length (_tmp50_), splits_size = splits_length1, _tmp51_);
#line 337 "symbol.vala"
			access = (_tmp52_ = g_strdup (splits[1]), _g_free0 (access), _tmp52_);
#line 338 "symbol.vala"
			splits = (_tmp54_ = _tmp53_ = g_strsplit (fields[7], ":", 0), splits = (_vala_array_free (splits, splits_length1, (GDestroyNotify) g_free), NULL), splits_length1 = _vala_array_length (_tmp53_), splits_size = splits_length1, _tmp54_);
#line 339 "symbol.vala"
			implementation = (_tmp55_ = g_strdup (splits[1]), _g_free0 (implementation), _tmp55_);
#line 340 "symbol.vala"
			break;
#line 889 "symbol.c"
		} while (0); else if (_tmp60_ == ((0 != _tmp60__label13) ? _tmp60__label13 : (_tmp60__label13 = g_quark_from_static_string ("function"))))
		do {
			char** _tmp57_;
			char** _tmp56_;
			char* _tmp58_;
#line 342 "symbol.vala"
			splits = (_tmp57_ = _tmp56_ = g_strsplit (fields[5], ":", 0), splits = (_vala_array_free (splits, splits_length1, (GDestroyNotify) g_free), NULL), splits_length1 = _vala_array_length (_tmp56_), splits_size = splits_length1, _tmp57_);
#line 343 "symbol.vala"
			signature = (_tmp58_ = g_strdup (splits[1]), _g_free0 (signature), _tmp58_);
#line 344 "symbol.vala"
			break;
#line 901 "symbol.c"
		} while (0); else if (_tmp60_ == ((0 != _tmp60__label14) ? _tmp60__label14 : (_tmp60__label14 = g_quark_from_static_string ("variable"))))
		do {
#line 346 "symbol.vala"
			break;
#line 906 "symbol.c"
		} while (0); else
		do {
#line 348 "symbol.vala"
			g_debug ("symbol.vala:348: Unknow kind '%s' for symbol '%s'", kind, name);
#line 349 "symbol.vala"
			break;
#line 913 "symbol.c"
		} while (0);
#line 352 "symbol.vala"
		symbol->name = (_tmp61_ = g_strdup (name), _g_free0 (symbol->name), _tmp61_);
#line 353 "symbol.vala"
		symbol->full_name = (_tmp62_ = g_strdup (full_name), _g_free0 (symbol->full_name), _tmp62_);
#line 354 "symbol.vala"
		symbol->file = (_tmp63_ = g_strdup (filename), _g_free0 (symbol->file), _tmp63_);
#line 355 "symbol.vala"
		symbol->line = file_position;
#line 356 "symbol.vala"
		symbol->signature = (_tmp64_ = g_strdup (signature), _g_free0 (symbol->signature), _tmp64_);
#line 357 "symbol.vala"
		symbol->inherits = (_tmp66_ = (_tmp65_ = inherits, (_tmp65_ == NULL) ? ((gpointer) _tmp65_) : _vala_array_dup1 (_tmp65_, inherits_length1)), symbol->inherits = (_vala_array_free (symbol->inherits, symbol->inherits_length1, (GDestroyNotify) g_free), NULL), symbol->inherits_length1 = inherits_length1, symbol->inherits_size = symbol->inherits_length1, _tmp66_);
#line 358 "symbol.vala"
		symbol->typeref = (_tmp67_ = g_strdup (typeref), _g_free0 (symbol->typeref), _tmp67_);
#line 359 "symbol.vala"
		symbol->root = (_tmp68_ = NULL, _symbol_unref0 (symbol->root), _tmp68_);
#line 360 "symbol.vala"
		if (kind != NULL) {
#line 933 "symbol.c"
			char* _tmp69_;
#line 362 "symbol.vala"
			symbol->type = (_tmp69_ = g_strdup (kind), _g_free0 (symbol->type), _tmp69_);
#line 937 "symbol.c"
		}
#line 364 "symbol.vala"
		if (access != NULL) {
#line 941 "symbol.c"
			char* _tmp70_;
#line 366 "symbol.vala"
			symbol->access = (_tmp70_ = g_strdup (access), _g_free0 (symbol->access), _tmp70_);
#line 945 "symbol.c"
		}
#line 368 "symbol.vala"
		if (implementation != NULL) {
#line 949 "symbol.c"
			char* _tmp71_;
#line 370 "symbol.vala"
			symbol->implementation = (_tmp71_ = g_strdup (implementation), _g_free0 (symbol->implementation), _tmp71_);
#line 953 "symbol.c"
		}
		_g_free0 (filename);
		_g_free0 (name);
		_g_free0 (full_name);
		_g_free0 (kind);
		_g_free0 (language);
		_g_free0 (access);
		inherits = (_vala_array_free (inherits, inherits_length1, (GDestroyNotify) g_free), NULL);
		_g_free0 (typeref);
		_g_free0 (signature);
		_g_free0 (implementation);
		splits = (_vala_array_free (splits, splits_length1, (GDestroyNotify) g_free), NULL);
	}
	result = symbol;
	fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 373 "symbol.vala"
	return result;
#line 971 "symbol.c"
}


#line 376 "symbol.vala"
static void symbol_browser_clear_data (SymbolBrowser* self) {
#line 977 "symbol.c"
	GHashTable* _tmp0_;
#line 376 "symbol.vala"
	g_return_if_fail (self != NULL);
#line 378 "symbol.vala"
	gtk_tree_store_clear (self->priv->model);
#line 379 "symbol.vala"
	self->priv->root_nodes = (_tmp0_ = g_hash_table_new (g_str_hash, g_str_equal), _g_hash_table_unref0 (self->priv->root_nodes), _tmp0_);
#line 380 "symbol.vala"
	gtk_widget_set_sensitive ((GtkWidget*) self->priv->box, FALSE);
#line 381 "symbol.vala"
	gtk_label_set_text (self->priv->label, "");
#line 989 "symbol.c"
}


#line 1027 "glib-2.0.vapi"
static char* string_replace (const char* self, const char* old, const char* replacement) {
#line 995 "symbol.c"
	char* result;
	GError * _inner_error_;
#line 1027 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1027 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1027 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1004 "symbol.c"
	_inner_error_ = NULL;
	{
		char* _tmp0_;
		GRegex* _tmp1_;
		GRegex* regex;
		char* _tmp2_;
#line 1029 "glib-2.0.vapi"
		regex = (_tmp1_ = g_regex_new (_tmp0_ = g_regex_escape_string (old, -1), 0, 0, &_inner_error_), _g_free0 (_tmp0_), _tmp1_);
#line 1013 "symbol.c"
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			goto __finally0;
		}
#line 1030 "glib-2.0.vapi"
		_tmp2_ = g_regex_replace_literal (regex, self, (gssize) (-1), 0, replacement, 0, &_inner_error_);
#line 1022 "symbol.c"
		if (_inner_error_ != NULL) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			goto __finally0;
		}
		result = _tmp2_;
		_g_regex_unref0 (regex);
#line 1030 "glib-2.0.vapi"
		return result;
#line 1034 "symbol.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
#line 1032 "glib-2.0.vapi"
			g_assert_not_reached ();
#line 1045 "symbol.c"
			_g_error_free0 (e);
		}
	}
	__finally0:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


static GtkTreeIter* _gtk_tree_iter_dup (GtkTreeIter* self) {
	GtkTreeIter* dup;
	dup = g_new0 (GtkTreeIter, 1);
	memcpy (dup, self, sizeof (GtkTreeIter));
	return dup;
}


static gpointer __gtk_tree_iter_dup0 (gpointer self) {
	return self ? _gtk_tree_iter_dup (self) : NULL;
}


#line 388 "symbol.vala"
static gboolean symbol_browser_add_symbol (SymbolBrowser* self, Symbol* symbol) {
#line 1073 "symbol.c"
	gboolean result;
	char* markup;
	GdkPixbuf* pixbuf;
	GtkTreeIter iter = {0};
	GtkTreeIter* parent = NULL;
	char* _tmp0_;
	char* _tmp1_;
	GdkPixbuf* _tmp2_;
#line 388 "symbol.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 388 "symbol.vala"
	g_return_val_if_fail (symbol != NULL, FALSE);
#line 1086 "symbol.c"
	markup = NULL;
	pixbuf = NULL;
#line 395 "symbol.vala"
	valide_utils_process_gtk_events ();
#line 396 "symbol.vala"
	symbol->name = (_tmp0_ = string_replace (symbol->name, "<", "&lt;"), _g_free0 (symbol->name), _tmp0_);
#line 397 "symbol.vala"
	symbol->name = (_tmp1_ = string_replace (symbol->name, ">", "&gt;"), _g_free0 (symbol->name), _tmp1_);
#line 399 "symbol.vala"
	pixbuf = (_tmp2_ = valide_utils_get_symbol_pixbuf (symbol->type), _g_object_unref0 (pixbuf), _tmp2_);
#line 401 "symbol.vala"
	if (!symbol_browser_get_hierarchic_view (self)) {
#line 1099 "symbol.c"
		char* _tmp3_;
		GtkTreeIter* _tmp4_;
#line 404 "symbol.vala"
		markup = (_tmp3_ = g_strdup_printf ("<b>%s</b>", symbol->name), _g_free0 (markup), _tmp3_);
#line 407 "symbol.vala"
		parent = (_tmp4_ = __gtk_tree_iter_dup0 ((GtkTreeIter*) g_hash_table_lookup (self->priv->root_nodes, markup)), _g_free0 (parent), _tmp4_);
#line 409 "symbol.vala"
		if (parent == NULL) {
#line 1108 "symbol.c"
			GtkTreeIter tmp = {0};
			GtkTreeIter* _tmp5_;
#line 413 "symbol.vala"
			gtk_tree_store_append (self->priv->model, &tmp, NULL);
#line 414 "symbol.vala"
			parent = (_tmp5_ = __gtk_tree_iter_dup0 (&tmp), _g_free0 (parent), _tmp5_);
#line 415 "symbol.vala"
			gtk_tree_store_set (self->priv->model, parent, SYMBOL_BROWSER_COL_ICON, pixbuf, SYMBOL_BROWSER_COL_NAME, markup, -1);
#line 416 "symbol.vala"
			g_hash_table_insert (self->priv->root_nodes, g_strdup (markup), __gtk_tree_iter_dup0 (parent));
#line 1119 "symbol.c"
		}
#line 419 "symbol.vala"
		gtk_tree_store_append (self->priv->model, &iter, parent);
#line 421 "symbol.vala"
		gtk_tree_store_set (self->priv->model, &iter, SYMBOL_BROWSER_COL_ICON, pixbuf, SYMBOL_BROWSER_COL_NAME, symbol->name, SYMBOL_BROWSER_COL_FILE, symbol->file, SYMBOL_BROWSER_COL_LINE, symbol->line, SYMBOL_BROWSER_COL_LANGUAGE, symbol->language, -1);
#line 1125 "symbol.c"
	} else {
#line 429 "symbol.vala"
		if (symbol->root != NULL) {
#line 1129 "symbol.c"
			GtkTreeIter* _tmp6_;
#line 431 "symbol.vala"
			parent = (_tmp6_ = __gtk_tree_iter_dup0 ((GtkTreeIter*) g_hash_table_lookup (self->priv->root_nodes, symbol->root->full_name)), _g_free0 (parent), _tmp6_);
#line 432 "symbol.vala"
			gtk_tree_store_append (self->priv->model, &iter, parent);
#line 1135 "symbol.c"
		} else {
			GtkTreeIter* _tmp7_;
#line 436 "symbol.vala"
			gtk_tree_store_append (self->priv->model, &iter, NULL);
#line 437 "symbol.vala"
			parent = (_tmp7_ = __gtk_tree_iter_dup0 (&iter), _g_free0 (parent), _tmp7_);
#line 1142 "symbol.c"
		}
#line 439 "symbol.vala"
		gtk_tree_store_set (self->priv->model, &iter, SYMBOL_BROWSER_COL_ICON, pixbuf, SYMBOL_BROWSER_COL_NAME, symbol->name, SYMBOL_BROWSER_COL_FILE, symbol->file, SYMBOL_BROWSER_COL_LINE, symbol->line, SYMBOL_BROWSER_COL_LANGUAGE, symbol->language, -1);
#line 444 "symbol.vala"
		g_hash_table_insert (self->priv->root_nodes, g_strdup (symbol->full_name), __gtk_tree_iter_dup0 (&iter));
#line 1148 "symbol.c"
	}
	result = TRUE;
	_g_free0 (markup);
	_g_object_unref0 (pixbuf);
	_g_free0 (parent);
#line 446 "symbol.vala"
	return result;
#line 1156 "symbol.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static gpointer _symbol_ref0 (gpointer self) {
	return self ? symbol_ref (self) : NULL;
}


#line 449 "symbol.vala"
static gboolean symbol_browser_populate_symbols_asc (SymbolBrowser* self) {
#line 1172 "symbol.c"
	gboolean result;
	GError * _inner_error_;
#line 449 "symbol.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1177 "symbol.c"
	_inner_error_ = NULL;
#line 451 "symbol.vala"
	if (g_atomic_int_compare_and_exchange (&self->priv->atom, 0, 1)) {
#line 1181 "symbol.c"
		ValideiDocument* document;
		GtkTreeStore* _tmp1_;
		GtkTreeModel* _tmp0_;
		ValideiDocument* _tmp2_;
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
		document = NULL;
#line 455 "symbol.vala"
		self->priv->model = (_tmp1_ = _g_object_ref0 ((_tmp0_ = gtk_tree_view_get_model (self->priv->tree_view), GTK_IS_TREE_STORE (_tmp0_) ? ((GtkTreeStore*) _tmp0_) : NULL)), _g_object_unref0 (self->priv->model), _tmp1_);
#line 456 "symbol.vala"
		gtk_tree_view_set_model (self->priv->tree_view, NULL);
#line 457 "symbol.vala"
		gtk_widget_freeze_child_notify ((GtkWidget*) self->priv->tree_view);
#line 459 "symbol.vala"
		document = (_tmp2_ = _g_object_ref0 (valide_document_manager_get_current (valide_window_get_documents (valide_plugin_get_window ((ValidePlugin*) self)))), _g_object_unref0 (document), _tmp2_);
#line 460 "symbol.vala"
		if (document != NULL) {
#line 460 "symbol.vala"
			_tmp5_ = VALIDE_IS_ABSTRACT_TEXT_DOCUMENT (document);
#line 1202 "symbol.c"
		} else {
#line 460 "symbol.vala"
			_tmp5_ = FALSE;
#line 1206 "symbol.c"
		}
#line 460 "symbol.vala"
		if (_tmp5_) {
#line 461 "symbol.vala"
			_tmp4_ = valide_idocument_get_path (document) != NULL;
#line 1212 "symbol.c"
		} else {
#line 460 "symbol.vala"
			_tmp4_ = FALSE;
#line 1216 "symbol.c"
		}
#line 460 "symbol.vala"
		if (_tmp4_) {
#line 462 "symbol.vala"
			_tmp3_ = g_file_test (valide_idocument_get_path (document), G_FILE_TEST_EXISTS);
#line 1222 "symbol.c"
		} else {
#line 460 "symbol.vala"
			_tmp3_ = FALSE;
#line 1226 "symbol.c"
		}
#line 460 "symbol.vala"
		if (_tmp3_) {
#line 464 "symbol.vala"
			symbol_browser_clear_data (self);
#line 1232 "symbol.c"
			{
				char* output;
				gint lines_size;
				gint lines_length1;
				char** lines;
				Symbol* root;
				char* _tmp6_;
				char* _tmp7_;
				char** _tmp9_;
				char** _tmp8_;
				output = NULL;
				lines = (lines_length1 = 0, NULL);
#line 470 "symbol.vala"
				root = NULL;
#line 472 "symbol.vala"
				_tmp6_ = symbol_browser_exec_ctags (self, valide_idocument_get_path (document), &_inner_error_);
#line 1249 "symbol.c"
				if (_inner_error_ != NULL) {
					_g_free0 (output);
					lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
					_symbol_unref0 (root);
					goto __catch1_g_error;
					goto __finally1;
				}
#line 472 "symbol.vala"
				output = (_tmp7_ = _tmp6_, _g_free0 (output), _tmp7_);
#line 473 "symbol.vala"
				lines = (_tmp9_ = _tmp8_ = g_strsplit (output, "\n", 0), lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL), lines_length1 = _vala_array_length (_tmp8_), lines_size = lines_length1, _tmp9_);
#line 1261 "symbol.c"
				{
					gint i;
#line 474 "symbol.vala"
					i = 0;
#line 1266 "symbol.c"
					{
						gboolean _tmp10_;
#line 474 "symbol.vala"
						_tmp10_ = TRUE;
#line 474 "symbol.vala"
						while (TRUE) {
#line 474 "symbol.vala"
							if (!_tmp10_) {
#line 474 "symbol.vala"
								i++;
#line 1277 "symbol.c"
							}
#line 474 "symbol.vala"
							_tmp10_ = FALSE;
#line 474 "symbol.vala"
							if (!(lines[i] != NULL)) {
#line 474 "symbol.vala"
								break;
#line 1285 "symbol.c"
							}
#line 476 "symbol.vala"
							if (_vala_strcmp0 (lines[i], "") != 0) {
#line 1289 "symbol.c"
								Symbol* symbol;
								Symbol* _tmp11_;
								symbol = NULL;
#line 480 "symbol.vala"
								symbol = (_tmp11_ = symbol_browser_parse_line (self, lines[i]), _symbol_unref0 (symbol), _tmp11_);
#line 481 "symbol.vala"
								if (symbol != NULL) {
#line 1297 "symbol.c"
									ValideiDocument* _tmp12_;
									Symbol* _tmp19_;
									gboolean _tmp20_ = FALSE;
									gboolean _tmp21_ = FALSE;
#line 483 "symbol.vala"
									symbol->document = (_tmp12_ = document, VALIDE_IS_ABSTRACT_TEXT_DOCUMENT (_tmp12_) ? ((ValideAbstractTextDocument*) _tmp12_) : NULL);
#line 484 "symbol.vala"
									if (_vala_strcmp0 (symbol->type, "class") == 0) {
#line 1306 "symbol.c"
										Symbol* _tmp13_;
#line 486 "symbol.vala"
										root = (_tmp13_ = NULL, _symbol_unref0 (root), _tmp13_);
#line 1310 "symbol.c"
									} else {
										gboolean _tmp14_ = FALSE;
#line 488 "symbol.vala"
										if (root != NULL) {
#line 1315 "symbol.c"
											gboolean _tmp15_ = FALSE;
											gboolean _tmp16_ = FALSE;
#line 489 "symbol.vala"
											if (_vala_strcmp0 (root->type, "enum") == 0) {
#line 489 "symbol.vala"
												_tmp16_ = _vala_strcmp0 (symbol->type, "enumvalue") != 0;
#line 1322 "symbol.c"
											} else {
#line 489 "symbol.vala"
												_tmp16_ = FALSE;
#line 1326 "symbol.c"
											}
#line 489 "symbol.vala"
											if (_tmp16_) {
#line 489 "symbol.vala"
												_tmp15_ = TRUE;
#line 1332 "symbol.c"
											} else {
												gboolean _tmp17_ = FALSE;
#line 490 "symbol.vala"
												if (_vala_strcmp0 (root->type, "errordomain") == 0) {
#line 490 "symbol.vala"
													_tmp17_ = _vala_strcmp0 (symbol->type, "errorcode") != 0;
#line 1339 "symbol.c"
												} else {
#line 490 "symbol.vala"
													_tmp17_ = FALSE;
#line 1343 "symbol.c"
												}
#line 490 "symbol.vala"
												_tmp15_ = _tmp17_;
#line 1347 "symbol.c"
											}
#line 489 "symbol.vala"
											_tmp14_ = _tmp15_;
#line 1351 "symbol.c"
										} else {
#line 488 "symbol.vala"
											_tmp14_ = FALSE;
#line 1355 "symbol.c"
										}
#line 488 "symbol.vala"
										if (_tmp14_) {
#line 1359 "symbol.c"
											Symbol* _tmp18_;
#line 492 "symbol.vala"
											root = (_tmp18_ = _symbol_ref0 (root->root), _symbol_unref0 (root), _tmp18_);
#line 1363 "symbol.c"
										}
									}
#line 494 "symbol.vala"
									symbol->root = (_tmp19_ = _symbol_ref0 (root), _symbol_unref0 (symbol->root), _tmp19_);
#line 495 "symbol.vala"
									symbol_browser_add_symbol (self, symbol);
#line 496 "symbol.vala"
									if (_vala_strcmp0 (symbol->type, "class") == 0) {
#line 496 "symbol.vala"
										_tmp21_ = TRUE;
#line 1374 "symbol.c"
									} else {
#line 496 "symbol.vala"
										_tmp21_ = _vala_strcmp0 (symbol->type, "enum") == 0;
#line 1378 "symbol.c"
									}
#line 496 "symbol.vala"
									if (_tmp21_) {
#line 496 "symbol.vala"
										_tmp20_ = TRUE;
#line 1384 "symbol.c"
									} else {
#line 497 "symbol.vala"
										_tmp20_ = _vala_strcmp0 (symbol->type, "errordomain") == 0;
#line 1388 "symbol.c"
									}
#line 496 "symbol.vala"
									if (_tmp20_) {
#line 1392 "symbol.c"
										Symbol* _tmp22_;
#line 499 "symbol.vala"
										root = (_tmp22_ = _symbol_ref0 (symbol), _symbol_unref0 (root), _tmp22_);
#line 1396 "symbol.c"
									}
								}
								_symbol_unref0 (symbol);
							}
						}
					}
				}
				_g_free0 (output);
				lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
				_symbol_unref0 (root);
			}
			goto __finally1;
			__catch1_g_error:
			{
				GError * e;
				e = _inner_error_;
				_inner_error_ = NULL;
				{
#line 507 "symbol.vala"
					g_debug (_ ("Could not execute ctags: %s\n"), e->message);
#line 1417 "symbol.c"
					_g_error_free0 (e);
				}
			}
			__finally1:
			if (_inner_error_ != NULL) {
				_g_object_unref0 (document);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return FALSE;
			}
#line 510 "symbol.vala"
			if (gtk_tree_model_iter_n_children ((GtkTreeModel*) self->priv->model, NULL) > 0) {
#line 512 "symbol.vala"
				gtk_widget_set_sensitive ((GtkWidget*) self->priv->box, TRUE);
#line 1432 "symbol.c"
			}
		} else {
#line 517 "symbol.vala"
			symbol_browser_clear_data (self);
#line 1437 "symbol.c"
		}
#line 519 "symbol.vala"
		gtk_tree_view_set_model (self->priv->tree_view, (GtkTreeModel*) self->priv->model);
#line 520 "symbol.vala"
		gtk_widget_thaw_child_notify ((GtkWidget*) self->priv->tree_view);
#line 522 "symbol.vala"
		gtk_tree_view_expand_all (self->priv->tree_view);
#line 523 "symbol.vala"
		g_atomic_int_set (&self->priv->atom, 0);
#line 1447 "symbol.c"
		_g_object_unref0 (document);
	}
	result = FALSE;
#line 525 "symbol.vala"
	return result;
#line 1453 "symbol.c"
}


#line 449 "symbol.vala"
static gboolean _symbol_browser_populate_symbols_asc_gsource_func (gpointer self) {
#line 1459 "symbol.c"
	return symbol_browser_populate_symbols_asc (self);
}


#line 531 "symbol.vala"
static void symbol_browser_populate_symbols (SymbolBrowser* self) {
#line 531 "symbol.vala"
	g_return_if_fail (self != NULL);
#line 533 "symbol.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _symbol_browser_populate_symbols_asc_gsource_func, g_object_ref (self), g_object_unref);
#line 1470 "symbol.c"
}


#line 540 "symbol.vala"
static void symbol_browser_restore_expanded_rows (SymbolBrowser* self) {
#line 540 "symbol.vala"
	g_return_if_fail (self != NULL);
#line 543 "symbol.vala"
	if (gtk_widget_get_sensitive ((GtkWidget*) valide_window_get_documents (valide_plugin_get_window ((ValidePlugin*) self))) == TRUE) {
#line 1480 "symbol.c"
		GtkTreeIter iter = {0};
		GtkTreeModel* model;
		GtkTreeModel* _tmp0_;
		model = NULL;
#line 548 "symbol.vala"
		model = (_tmp0_ = _g_object_ref0 (gtk_tree_view_get_model (self->priv->tree_view)), _g_object_unref0 (model), _tmp0_);
#line 549 "symbol.vala"
		if (gtk_tree_model_get_iter_first (model, &iter) == TRUE) {
#line 1489 "symbol.c"
			{
				gboolean r;
#line 551 "symbol.vala"
				r = gtk_tree_model_get_iter_first (model, &iter);
#line 1494 "symbol.c"
				{
					gboolean _tmp1_;
#line 551 "symbol.vala"
					_tmp1_ = TRUE;
#line 551 "symbol.vala"
					while (TRUE) {
#line 1501 "symbol.c"
						char* name;
#line 551 "symbol.vala"
						if (!_tmp1_) {
#line 553 "symbol.vala"
							r = gtk_tree_model_iter_next (model, &iter);
#line 1507 "symbol.c"
						}
#line 551 "symbol.vala"
						_tmp1_ = FALSE;
#line 552 "symbol.vala"
						if (!(r == TRUE)) {
#line 552 "symbol.vala"
							break;
#line 1515 "symbol.c"
						}
						name = NULL;
#line 557 "symbol.vala"
						gtk_tree_model_get (model, &iter, SYMBOL_BROWSER_COL_NAME, &name, -1, -1);
#line 558 "symbol.vala"
						if (symbol_browser_is_expanded_row (self, name)) {
#line 1522 "symbol.c"
							GtkTreePath* path;
#line 560 "symbol.vala"
							path = gtk_tree_model_get_path (model, &iter);
#line 561 "symbol.vala"
							gtk_tree_view_expand_row (self->priv->tree_view, path, FALSE);
#line 1528 "symbol.c"
							_gtk_tree_path_free0 (path);
						}
						_g_free0 (name);
					}
				}
			}
		}
		_g_object_unref0 (model);
	}
}


#line 568 "symbol.vala"
static void symbol_browser_on_row_activated (SymbolBrowser* self, GtkTreeView* sender, GtkTreePath* path, GtkTreeViewColumn* column) {
#line 1543 "symbol.c"
	GError * _inner_error_;
	GtkTreeIter iter = {0};
	GtkTreeModel* model;
	GtkTreeModel* _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 568 "symbol.vala"
	g_return_if_fail (self != NULL);
#line 568 "symbol.vala"
	g_return_if_fail (sender != NULL);
#line 568 "symbol.vala"
	g_return_if_fail (path != NULL);
#line 568 "symbol.vala"
	g_return_if_fail (column != NULL);
#line 1557 "symbol.c"
	_inner_error_ = NULL;
	model = NULL;
#line 574 "symbol.vala"
	model = (_tmp0_ = _g_object_ref0 (gtk_tree_view_get_model (self->priv->tree_view)), _g_object_unref0 (model), _tmp0_);
#line 575 "symbol.vala"
	gtk_tree_model_get_iter (model, &iter, path);
#line 578 "symbol.vala"
	if (!symbol_browser_get_hierarchic_view (self)) {
#line 578 "symbol.vala"
		_tmp1_ = gtk_tree_model_iter_has_child (model, &iter);
#line 1568 "symbol.c"
	} else {
#line 578 "symbol.vala"
		_tmp1_ = FALSE;
#line 1572 "symbol.c"
	}
#line 578 "symbol.vala"
	if (_tmp1_) {
#line 580 "symbol.vala"
		if (gtk_tree_view_row_expanded (self->priv->tree_view, path)) {
#line 582 "symbol.vala"
			gtk_tree_view_collapse_row (self->priv->tree_view, path);
#line 1580 "symbol.c"
		} else {
#line 586 "symbol.vala"
			gtk_tree_view_expand_row (self->priv->tree_view, path, FALSE);
#line 1584 "symbol.c"
		}
	} else {
		gint line = 0;
		char* name;
		char* filename;
		name = NULL;
		filename = NULL;
#line 596 "symbol.vala"
		gtk_tree_model_get (model, &iter, SYMBOL_BROWSER_COL_NAME, &name, SYMBOL_BROWSER_COL_LINE, &line, SYMBOL_BROWSER_COL_FILE, &filename, -1);
#line 1594 "symbol.c"
		{
			ValideiDocument* document;
			ValideiDocument* _tmp2_;
			ValideiDocument* _tmp3_;
			document = NULL;
#line 602 "symbol.vala"
			_tmp2_ = valide_document_manager_create (valide_window_get_documents (valide_plugin_get_window ((ValidePlugin*) self)), filename, &_inner_error_);
#line 1602 "symbol.c"
			if (_inner_error_ != NULL) {
				_g_object_unref0 (document);
				goto __catch2_g_error;
				goto __finally2;
			}
#line 602 "symbol.vala"
			document = (_tmp3_ = _tmp2_, _g_object_unref0 (document), _tmp3_);
#line 603 "symbol.vala"
			if (VALIDE_IS_ABSTRACT_TEXT_DOCUMENT (document)) {
#line 1612 "symbol.c"
				ValideiDocument* _tmp4_;
#line 605 "symbol.vala"
				valide_source_view_goto_line (valide_abstract_text_document_get_text_view ((_tmp4_ = document, VALIDE_IS_ABSTRACT_TEXT_DOCUMENT (_tmp4_) ? ((ValideAbstractTextDocument*) _tmp4_) : NULL)), line - 1);
#line 1616 "symbol.c"
			}
#line 607 "symbol.vala"
			gtk_widget_grab_focus ((GtkWidget*) document);
#line 1620 "symbol.c"
			_g_object_unref0 (document);
		}
		goto __finally2;
		__catch2_g_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			{
#line 611 "symbol.vala"
				g_warning ("symbol.vala:611: %s", e->message);
#line 1632 "symbol.c"
				_g_error_free0 (e);
			}
		}
		__finally2:
		if (_inner_error_ != NULL) {
			_g_free0 (name);
			_g_free0 (filename);
			_g_object_unref0 (model);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		_g_free0 (name);
		_g_free0 (filename);
	}
	_g_object_unref0 (model);
}


#line 616 "symbol.vala"
static void symbol_browser_on_cursor_changed (SymbolBrowser* self, GtkTreeView* sender) {
#line 1654 "symbol.c"
	GtkTreeIter iter = {0};
	GtkTreeModel* model;
	GtkTreeSelection* selection;
	GtkTreeModel* _tmp0_;
	GtkTreeSelection* _tmp1_;
#line 616 "symbol.vala"
	g_return_if_fail (self != NULL);
#line 616 "symbol.vala"
	g_return_if_fail (sender != NULL);
#line 1664 "symbol.c"
	model = NULL;
	selection = NULL;
#line 622 "symbol.vala"
	model = (_tmp0_ = _g_object_ref0 (gtk_tree_view_get_model (self->priv->tree_view)), _g_object_unref0 (model), _tmp0_);
#line 623 "symbol.vala"
	selection = (_tmp1_ = _g_object_ref0 (gtk_tree_view_get_selection (self->priv->tree_view)), _g_object_unref0 (selection), _tmp1_);
#line 624 "symbol.vala"
	if (gtk_tree_selection_get_selected (selection, NULL, &iter)) {
#line 1673 "symbol.c"
		gint line = 0;
		char* name;
		char* filename;
		name = NULL;
		filename = NULL;
#line 630 "symbol.vala"
		gtk_tree_model_get (model, &iter, SYMBOL_BROWSER_COL_NAME, &name, SYMBOL_BROWSER_COL_FILE, &filename, SYMBOL_BROWSER_COL_LINE, &line, -1);
#line 633 "symbol.vala"
		if (filename != NULL) {
#line 1683 "symbol.c"
			char* label_text;
			char* status_message;
			char* _tmp3_;
			char* _tmp2_;
			char* _tmp4_;
			label_text = NULL;
			status_message = NULL;
#line 638 "symbol.vala"
			label_text = (_tmp3_ = g_strdup_printf ("%s Line:%d", _tmp2_ = g_path_get_basename (filename), line), _g_free0 (label_text), _tmp3_);
#line 1693 "symbol.c"
			_g_free0 (_tmp2_);
#line 639 "symbol.vala"
			gtk_label_set_text (self->priv->label, label_text);
#line 641 "symbol.vala"
			status_message = (_tmp4_ = g_strdup_printf ("Double-click to jump to '%s'", name), _g_free0 (status_message), _tmp4_);
#line 642 "symbol.vala"
			valide_statusbar_flash_message (valide_window_get_statusbar (valide_plugin_get_window ((ValidePlugin*) self)), self->priv->status_context, status_message);
#line 1701 "symbol.c"
			_g_free0 (label_text);
			_g_free0 (status_message);
		}
		_g_free0 (name);
		_g_free0 (filename);
	}
	_g_object_unref0 (model);
	_g_object_unref0 (selection);
}


#line 647 "symbol.vala"
static void symbol_browser_on_row_expanded (SymbolBrowser* self, GtkTreeView* sender, GtkTreeIter* iter, GtkTreePath* path) {
#line 1715 "symbol.c"
	char* name;
	GtkTreeModel* model;
	GtkTreeModel* _tmp0_;
#line 647 "symbol.vala"
	g_return_if_fail (self != NULL);
#line 647 "symbol.vala"
	g_return_if_fail (sender != NULL);
#line 647 "symbol.vala"
	g_return_if_fail (path != NULL);
#line 1725 "symbol.c"
	name = NULL;
	model = NULL;
#line 653 "symbol.vala"
	model = (_tmp0_ = _g_object_ref0 (gtk_tree_view_get_model (self->priv->tree_view)), _g_object_unref0 (model), _tmp0_);
#line 654 "symbol.vala"
	gtk_tree_model_get (model, iter, SYMBOL_BROWSER_COL_NAME, &name, -1, -1);
#line 655 "symbol.vala"
	g_return_if_fail (name != NULL);
#line 657 "symbol.vala"
	symbol_browser_add_expanded_row (self, name);
#line 1736 "symbol.c"
	_g_free0 (name);
	_g_object_unref0 (model);
}


#line 660 "symbol.vala"
static void symbol_browser_on_row_collapsed (SymbolBrowser* self, GtkTreeView* sender, GtkTreeIter* iter, GtkTreePath* path) {
#line 1744 "symbol.c"
	char* name;
	GtkTreeModel* model;
	GtkTreeModel* _tmp0_;
#line 660 "symbol.vala"
	g_return_if_fail (self != NULL);
#line 660 "symbol.vala"
	g_return_if_fail (sender != NULL);
#line 660 "symbol.vala"
	g_return_if_fail (path != NULL);
#line 1754 "symbol.c"
	name = NULL;
	model = NULL;
#line 666 "symbol.vala"
	model = (_tmp0_ = _g_object_ref0 (gtk_tree_view_get_model (self->priv->tree_view)), _g_object_unref0 (model), _tmp0_);
#line 667 "symbol.vala"
	gtk_tree_model_get (model, iter, SYMBOL_BROWSER_COL_NAME, &name, -1, -1);
#line 668 "symbol.vala"
	g_return_if_fail (name != NULL);
#line 670 "symbol.vala"
	symbol_browser_remove_expanded_row (self, name);
#line 1765 "symbol.c"
	_g_free0 (name);
	_g_object_unref0 (model);
}


#line 781 "symbol.vala"
SymbolBrowser* symbol_browser_construct (GType object_type, const char* path) {
#line 1773 "symbol.c"
	GParameter * __params;
	GParameter * __params_it;
	SymbolBrowser * self;
#line 781 "symbol.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 1779 "symbol.c"
	__params = g_new0 (GParameter, 1);
	__params_it = __params;
#line 783 "symbol.vala"
	__params_it->name = "path";
#line 783 "symbol.vala"
	g_value_init (&__params_it->value, G_TYPE_STRING);
#line 783 "symbol.vala"
	g_value_set_string (&__params_it->value, path);
#line 783 "symbol.vala"
	__params_it++;
#line 1790 "symbol.c"
	self = g_object_newv (object_type, __params_it - __params, __params);
	while (__params_it > __params) {
		--__params_it;
		g_value_unset (&__params_it->value);
	}
	g_free (__params);
	return self;
}


#line 781 "symbol.vala"
SymbolBrowser* symbol_browser_new (const char* path) {
#line 781 "symbol.vala"
	return symbol_browser_construct (TYPE_SYMBOL_BROWSER, path);
#line 1805 "symbol.c"
}


static void _lambda0_ (GtkToggleButton* s, SymbolBrowser* self) {
	g_return_if_fail (s != NULL);
#line 809 "symbol.vala"
	symbol_browser_set_show_language_column (self, gtk_toggle_button_get_active (s));
#line 1813 "symbol.c"
}


static void __lambda0__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	_lambda0_ (_sender, self);
}


static void _lambda1_ (GtkToggleButton* s, SymbolBrowser* self) {
	g_return_if_fail (s != NULL);
#line 816 "symbol.vala"
	symbol_browser_set_show_source_file_column (self, gtk_toggle_button_get_active (s));
#line 1826 "symbol.c"
}


static void __lambda1__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	_lambda1_ (_sender, self);
}


static void _lambda2_ (GtkToggleButton* s, SymbolBrowser* self) {
	g_return_if_fail (s != NULL);
#line 823 "symbol.vala"
	symbol_browser_set_show_line_number_column (self, gtk_toggle_button_get_active (s));
#line 1839 "symbol.c"
}


static void __lambda2__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	_lambda2_ (_sender, self);
}


static void _lambda3_ (GtkToggleButton* s, SymbolBrowser* self) {
	g_return_if_fail (s != NULL);
#line 830 "symbol.vala"
	symbol_browser_set_hierarchic_view (self, gtk_toggle_button_get_active (s));
#line 1852 "symbol.c"
}


static void __lambda3__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	_lambda3_ (_sender, self);
}


#line 795 "symbol.vala"
GtkWidget* symbol_browser_create_configure_dialog (SymbolBrowser* self) {
#line 1863 "symbol.c"
	GtkWidget* result;
	ValideFrame* frame;
	GtkVBox* vbox;
	GtkCheckButton* check;
	ValideFrame* _tmp0_;
	GtkVBox* _tmp1_;
	GtkCheckButton* _tmp2_;
	GtkCheckButton* _tmp3_;
	GtkCheckButton* _tmp4_;
	GtkCheckButton* _tmp5_;
#line 795 "symbol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1876 "symbol.c"
	frame = NULL;
	vbox = NULL;
	check = NULL;
#line 801 "symbol.vala"
	frame = (_tmp0_ = g_object_ref_sink (valide_frame_new (_ ("Additionnal columns"))), _g_object_unref0 (frame), _tmp0_);
#line 803 "symbol.vala"
	vbox = (_tmp1_ = g_object_ref_sink ((GtkVBox*) gtk_vbox_new (TRUE, 0)), _g_object_unref0 (vbox), _tmp1_);
#line 804 "symbol.vala"
	gtk_container_add ((GtkContainer*) frame, (GtkWidget*) vbox);
#line 806 "symbol.vala"
	check = (_tmp2_ = g_object_ref_sink ((GtkCheckButton*) gtk_check_button_new_with_label (_ ("Programming language"))), _g_object_unref0 (check), _tmp2_);
#line 807 "symbol.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) check, symbol_browser_get_show_language_column (self));
#line 808 "symbol.vala"
	g_signal_connect_object ((GtkToggleButton*) check, "toggled", (GCallback) __lambda0__gtk_toggle_button_toggled, self, 0);
#line 811 "symbol.vala"
	gtk_box_pack_start ((GtkBox*) vbox, (GtkWidget*) check, TRUE, TRUE, (guint) 0);
#line 813 "symbol.vala"
	check = (_tmp3_ = g_object_ref_sink ((GtkCheckButton*) gtk_check_button_new_with_label (_ ("Source file"))), _g_object_unref0 (check), _tmp3_);
#line 814 "symbol.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) check, symbol_browser_get_show_source_file_column (self));
#line 815 "symbol.vala"
	g_signal_connect_object ((GtkToggleButton*) check, "toggled", (GCallback) __lambda1__gtk_toggle_button_toggled, self, 0);
#line 818 "symbol.vala"
	gtk_box_pack_start ((GtkBox*) vbox, (GtkWidget*) check, TRUE, TRUE, (guint) 0);
#line 820 "symbol.vala"
	check = (_tmp4_ = g_object_ref_sink ((GtkCheckButton*) gtk_check_button_new_with_label (_ ("Line number"))), _g_object_unref0 (check), _tmp4_);
#line 821 "symbol.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) check, symbol_browser_get_show_line_number_column (self));
#line 822 "symbol.vala"
	g_signal_connect_object ((GtkToggleButton*) check, "toggled", (GCallback) __lambda2__gtk_toggle_button_toggled, self, 0);
#line 825 "symbol.vala"
	gtk_box_pack_start ((GtkBox*) vbox, (GtkWidget*) check, TRUE, TRUE, (guint) 0);
#line 827 "symbol.vala"
	check = (_tmp5_ = g_object_ref_sink ((GtkCheckButton*) gtk_check_button_new_with_label (_ ("Hierarchic view"))), _g_object_unref0 (check), _tmp5_);
#line 828 "symbol.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) check, symbol_browser_get_hierarchic_view (self));
#line 829 "symbol.vala"
	g_signal_connect_object ((GtkToggleButton*) check, "toggled", (GCallback) __lambda3__gtk_toggle_button_toggled, self, 0);
#line 832 "symbol.vala"
	gtk_box_pack_start ((GtkBox*) vbox, (GtkWidget*) check, TRUE, TRUE, (guint) 0);
#line 1918 "symbol.c"
	result = (GtkWidget*) frame;
	_g_object_unref0 (vbox);
	_g_object_unref0 (check);
#line 834 "symbol.vala"
	return result;
#line 1924 "symbol.c"
}


static const char* symbol_browser_real_get_path (ValidePlugin* base) {
	const char* result;
	SymbolBrowser* self;
	self = (SymbolBrowser*) base;
	result = self->priv->_path;
#line 81 "symbol.vala"
	return result;
#line 1935 "symbol.c"
}


static void symbol_browser_real_set_path (ValidePlugin* base, const char* value) {
	SymbolBrowser* self;
	char* _tmp0_;
	self = (SymbolBrowser*) base;
	self->priv->_path = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_path), _tmp0_);
	g_object_notify ((GObject *) self, "path");
}


static ValideWindow* symbol_browser_real_get_window (ValidePlugin* base) {
	ValideWindow* result;
	SymbolBrowser* self;
	self = (SymbolBrowser*) base;
	result = self->priv->_window;
#line 85 "symbol.vala"
	return result;
#line 1955 "symbol.c"
}


static void symbol_browser_real_set_window (ValidePlugin* base, ValideWindow* value) {
	SymbolBrowser* self;
	ValideWindow* _tmp0_;
	self = (SymbolBrowser*) base;
	self->priv->_window = (_tmp0_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_window), _tmp0_);
	g_object_notify ((GObject *) self, "window");
}


static gboolean symbol_browser_get_show_language_column (SymbolBrowser* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = valide_abstract_config_manager_get_boolean ((ValideAbstractConfigManager*) valide_window_get_config_manager (valide_plugin_get_window ((ValidePlugin*) self)), "SymbolBrowser", "show-language");
#line 91 "symbol.vala"
	return result;
#line 1974 "symbol.c"
}


static void symbol_browser_set_show_language_column (SymbolBrowser* self, gboolean value) {
	g_return_if_fail (self != NULL);
#line 96 "symbol.vala"
	valide_abstract_config_manager_set_boolean ((ValideAbstractConfigManager*) valide_window_get_config_manager (valide_plugin_get_window ((ValidePlugin*) self)), "SymbolBrowser", "show-language", value);
#line 98 "symbol.vala"
	gtk_tree_view_column_set_visible (self->priv->language_column, value);
#line 1984 "symbol.c"
}


static gboolean symbol_browser_get_show_source_file_column (SymbolBrowser* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = valide_abstract_config_manager_get_boolean ((ValideAbstractConfigManager*) valide_window_get_config_manager (valide_plugin_get_window ((ValidePlugin*) self)), "SymbolBrowser", "show-source-file");
#line 106 "symbol.vala"
	return result;
#line 1994 "symbol.c"
}


static void symbol_browser_set_show_source_file_column (SymbolBrowser* self, gboolean value) {
	g_return_if_fail (self != NULL);
#line 111 "symbol.vala"
	valide_abstract_config_manager_set_boolean ((ValideAbstractConfigManager*) valide_window_get_config_manager (valide_plugin_get_window ((ValidePlugin*) self)), "SymbolBrowser", "show-source-file", value);
#line 113 "symbol.vala"
	gtk_tree_view_column_set_visible (self->priv->source_file_column, value);
#line 2004 "symbol.c"
}


static gboolean symbol_browser_get_show_line_number_column (SymbolBrowser* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = valide_abstract_config_manager_get_boolean ((ValideAbstractConfigManager*) valide_window_get_config_manager (valide_plugin_get_window ((ValidePlugin*) self)), "SymbolBrowser", "show-line-number");
#line 121 "symbol.vala"
	return result;
#line 2014 "symbol.c"
}


static void symbol_browser_set_show_line_number_column (SymbolBrowser* self, gboolean value) {
	g_return_if_fail (self != NULL);
#line 126 "symbol.vala"
	valide_abstract_config_manager_set_boolean ((ValideAbstractConfigManager*) valide_window_get_config_manager (valide_plugin_get_window ((ValidePlugin*) self)), "SymbolBrowser", "show-line-number", value);
#line 128 "symbol.vala"
	gtk_tree_view_column_set_visible (self->priv->line_number_column, value);
#line 2024 "symbol.c"
}


static gboolean symbol_browser_get_hierarchic_view (SymbolBrowser* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = valide_abstract_config_manager_get_boolean ((ValideAbstractConfigManager*) valide_window_get_config_manager (valide_plugin_get_window ((ValidePlugin*) self)), "SymbolBrowser", "hierarchic-view");
#line 136 "symbol.vala"
	return result;
#line 2034 "symbol.c"
}


static void symbol_browser_set_hierarchic_view (SymbolBrowser* self, gboolean value) {
	g_return_if_fail (self != NULL);
#line 141 "symbol.vala"
	valide_abstract_config_manager_set_boolean ((ValideAbstractConfigManager*) valide_window_get_config_manager (valide_plugin_get_window ((ValidePlugin*) self)), "SymbolBrowser", "hierarchic-view", value);
#line 143 "symbol.vala"
	symbol_browser_populate_symbols (self);
#line 2044 "symbol.c"
}


#line 568 "symbol.vala"
static void _symbol_browser_on_row_activated_gtk_tree_view_row_activated (GtkTreeView* _sender, GtkTreePath* path, GtkTreeViewColumn* column, gpointer self) {
#line 2050 "symbol.c"
	symbol_browser_on_row_activated (self, _sender, path, column);
}


#line 616 "symbol.vala"
static void _symbol_browser_on_cursor_changed_gtk_tree_view_cursor_changed (GtkTreeView* _sender, gpointer self) {
#line 2057 "symbol.c"
	symbol_browser_on_cursor_changed (self, _sender);
}


#line 647 "symbol.vala"
static void _symbol_browser_on_row_expanded_gtk_tree_view_row_expanded (GtkTreeView* _sender, GtkTreeIter* iter, GtkTreePath* path, gpointer self) {
#line 2064 "symbol.c"
	symbol_browser_on_row_expanded (self, _sender, iter, path);
}


#line 660 "symbol.vala"
static void _symbol_browser_on_row_collapsed_gtk_tree_view_row_collapsed (GtkTreeView* _sender, GtkTreeIter* iter, GtkTreePath* path, gpointer self) {
#line 2071 "symbol.c"
	symbol_browser_on_row_collapsed (self, _sender, iter, path);
}


#line 531 "symbol.vala"
static void _symbol_browser_populate_symbols_valide_document_manager_tab_removed (ValideDocumentManager* _sender, ValideiDocument* document, gpointer self) {
#line 2078 "symbol.c"
	symbol_browser_populate_symbols (self);
}


#line 531 "symbol.vala"
static void _symbol_browser_populate_symbols_valide_document_manager_tab_changed (ValideDocumentManager* _sender, ValideiDocument* document, gpointer self) {
#line 2085 "symbol.c"
	symbol_browser_populate_symbols (self);
}


#line 531 "symbol.vala"
static void _symbol_browser_populate_symbols_valide_document_manager_tab_saved (ValideDocumentManager* _sender, ValideiDocument* document, gpointer self) {
#line 2092 "symbol.c"
	symbol_browser_populate_symbols (self);
}


static GObject * symbol_browser_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	SymbolBrowser * self;
	GError * _inner_error_;
	parent_class = G_OBJECT_CLASS (symbol_browser_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = SYMBOL_BROWSER (obj);
	_inner_error_ = NULL;
	{
		GtkTreeStore* store;
		GtkTreeViewColumn* col;
		GtkScrolledWindow* scrolled;
		GtkCellRendererText* renderer;
		GtkCellRendererPixbuf* renderer_pixbuf;
		GtkVBox* _tmp0_;
		GtkScrolledWindow* _tmp1_;
		GtkTreeView* _tmp2_;
		GtkLabel* _tmp3_;
		GtkTreeStore* _tmp4_;
		GtkTreeViewColumn* _tmp5_;
		GtkCellRendererPixbuf* _tmp6_;
		GtkCellRendererText* _tmp7_;
		GtkTreeViewColumn* _tmp8_;
		GtkCellRendererText* _tmp9_;
		GtkTreeViewColumn* _tmp10_;
		GtkCellRendererText* _tmp11_;
		GtkTreeViewColumn* _tmp12_;
		GtkCellRendererText* _tmp13_;
		store = NULL;
		col = NULL;
		scrolled = NULL;
		renderer = NULL;
		renderer_pixbuf = NULL;
#line 681 "symbol.vala"
		g_atomic_int_set (&self->priv->atom, 0);
#line 683 "symbol.vala"
		self->priv->box = (_tmp0_ = g_object_ref_sink ((GtkVBox*) gtk_vbox_new (FALSE, 0)), _g_object_unref0 (self->priv->box), _tmp0_);
#line 686 "symbol.vala"
		gtk_box_set_spacing ((GtkBox*) self->priv->box, 2);
#line 687 "symbol.vala"
		gtk_container_set_border_width ((GtkContainer*) self->priv->box, (guint) 2);
#line 690 "symbol.vala"
		scrolled = (_tmp1_ = g_object_ref_sink ((GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL)), _g_object_unref0 (scrolled), _tmp1_);
#line 691 "symbol.vala"
		gtk_scrolled_window_set_policy (scrolled, GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
#line 692 "symbol.vala"
		gtk_scrolled_window_set_shadow_type (scrolled, GTK_SHADOW_IN);
#line 693 "symbol.vala"
		gtk_box_pack_start ((GtkBox*) self->priv->box, (GtkWidget*) scrolled, TRUE, TRUE, (guint) 0);
#line 695 "symbol.vala"
		self->priv->tree_view = (_tmp2_ = g_object_ref_sink ((GtkTreeView*) gtk_tree_view_new ()), _g_object_unref0 (self->priv->tree_view), _tmp2_);
#line 696 "symbol.vala"
		gtk_tree_view_set_rules_hint (self->priv->tree_view, FALSE);
#line 697 "symbol.vala"
		gtk_tree_view_set_headers_visible (self->priv->tree_view, TRUE);
#line 698 "symbol.vala"
		gtk_tree_view_set_headers_clickable (self->priv->tree_view, TRUE);
#line 699 "symbol.vala"
		gtk_container_add ((GtkContainer*) scrolled, (GtkWidget*) self->priv->tree_view);
#line 702 "symbol.vala"
		self->priv->label = (_tmp3_ = g_object_ref_sink ((GtkLabel*) gtk_label_new ("")), _g_object_unref0 (self->priv->label), _tmp3_);
#line 703 "symbol.vala"
		gtk_misc_set_alignment ((GtkMisc*) self->priv->label, (float) 0.0, (float) 0.5);
#line 704 "symbol.vala"
		gtk_box_pack_start ((GtkBox*) self->priv->box, (GtkWidget*) self->priv->label, FALSE, TRUE, (guint) 0);
#line 707 "symbol.vala"
		store = (_tmp4_ = gtk_tree_store_new ((gint) SYMBOL_BROWSER_COL_NB, GDK_TYPE_PIXBUF, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_INT, G_TYPE_STRING, G_TYPE_OBJECT, NULL), _g_object_unref0 (store), _tmp4_);
#line 713 "symbol.vala"
		col = (_tmp5_ = g_object_ref_sink (gtk_tree_view_column_new ()), _g_object_unref0 (col), _tmp5_);
#line 714 "symbol.vala"
		gtk_tree_view_column_set_title (col, _ ("Symbol"));
#line 716 "symbol.vala"
		renderer_pixbuf = (_tmp6_ = g_object_ref_sink ((GtkCellRendererPixbuf*) gtk_cell_renderer_pixbuf_new ()), _g_object_unref0 (renderer_pixbuf), _tmp6_);
#line 717 "symbol.vala"
		gtk_cell_layout_pack_start ((GtkCellLayout*) col, (GtkCellRenderer*) renderer_pixbuf, FALSE);
#line 718 "symbol.vala"
		gtk_tree_view_column_set_attributes (col, (GtkCellRenderer*) renderer_pixbuf, "pixbuf", SYMBOL_BROWSER_COL_ICON, NULL);
#line 720 "symbol.vala"
		renderer = (_tmp7_ = g_object_ref_sink ((GtkCellRendererText*) gtk_cell_renderer_text_new ()), _g_object_unref0 (renderer), _tmp7_);
#line 721 "symbol.vala"
		gtk_cell_layout_pack_start ((GtkCellLayout*) col, (GtkCellRenderer*) renderer, FALSE);
#line 722 "symbol.vala"
		gtk_tree_view_column_set_attributes (col, (GtkCellRenderer*) renderer, "markup", SYMBOL_BROWSER_COL_NAME, NULL);
#line 723 "symbol.vala"
		gtk_tree_view_append_column (self->priv->tree_view, col);
#line 727 "symbol.vala"
		self->priv->language_column = (_tmp8_ = g_object_ref_sink (gtk_tree_view_column_new ()), _g_object_unref0 (self->priv->language_column), _tmp8_);
#line 728 "symbol.vala"
		symbol_browser_set_show_language_column (self, valide_abstract_config_manager_get_boolean ((ValideAbstractConfigManager*) valide_window_get_config_manager (valide_plugin_get_window ((ValidePlugin*) self)), "SymbolBrowser", "show-language"));
#line 729 "symbol.vala"
		gtk_tree_view_column_set_title (self->priv->language_column, _ ("Language"));
#line 730 "symbol.vala"
		renderer = (_tmp9_ = g_object_ref_sink ((GtkCellRendererText*) gtk_cell_renderer_text_new ()), _g_object_unref0 (renderer), _tmp9_);
#line 731 "symbol.vala"
		gtk_cell_layout_pack_start ((GtkCellLayout*) self->priv->language_column, (GtkCellRenderer*) renderer, TRUE);
#line 732 "symbol.vala"
		gtk_tree_view_column_set_attributes (self->priv->language_column, (GtkCellRenderer*) renderer, "text", SYMBOL_BROWSER_COL_LANGUAGE, NULL);
#line 733 "symbol.vala"
		gtk_tree_view_append_column (self->priv->tree_view, self->priv->language_column);
#line 735 "symbol.vala"
		self->priv->source_file_column = (_tmp10_ = g_object_ref_sink (gtk_tree_view_column_new ()), _g_object_unref0 (self->priv->source_file_column), _tmp10_);
#line 736 "symbol.vala"
		symbol_browser_set_show_source_file_column (self, valide_abstract_config_manager_get_boolean ((ValideAbstractConfigManager*) valide_window_get_config_manager (valide_plugin_get_window ((ValidePlugin*) self)), "SymbolBrowser", "show-source-file"));
#line 737 "symbol.vala"
		gtk_tree_view_column_set_title (self->priv->source_file_column, _ ("File"));
#line 738 "symbol.vala"
		renderer = (_tmp11_ = g_object_ref_sink ((GtkCellRendererText*) gtk_cell_renderer_text_new ()), _g_object_unref0 (renderer), _tmp11_);
#line 739 "symbol.vala"
		gtk_cell_layout_pack_start ((GtkCellLayout*) self->priv->source_file_column, (GtkCellRenderer*) renderer, TRUE);
#line 740 "symbol.vala"
		gtk_tree_view_column_set_attributes (self->priv->source_file_column, (GtkCellRenderer*) renderer, "text", SYMBOL_BROWSER_COL_FILE, NULL);
#line 741 "symbol.vala"
		gtk_tree_view_append_column (self->priv->tree_view, self->priv->source_file_column);
#line 743 "symbol.vala"
		self->priv->line_number_column = (_tmp12_ = g_object_ref_sink (gtk_tree_view_column_new ()), _g_object_unref0 (self->priv->line_number_column), _tmp12_);
#line 744 "symbol.vala"
		symbol_browser_set_show_line_number_column (self, valide_abstract_config_manager_get_boolean ((ValideAbstractConfigManager*) valide_window_get_config_manager (valide_plugin_get_window ((ValidePlugin*) self)), "SymbolBrowser", "show-line-number"));
#line 745 "symbol.vala"
		gtk_tree_view_column_set_title (self->priv->line_number_column, _ ("Line"));
#line 746 "symbol.vala"
		renderer = (_tmp13_ = g_object_ref_sink ((GtkCellRendererText*) gtk_cell_renderer_text_new ()), _g_object_unref0 (renderer), _tmp13_);
#line 747 "symbol.vala"
		gtk_cell_layout_pack_start ((GtkCellLayout*) self->priv->line_number_column, (GtkCellRenderer*) renderer, TRUE);
#line 748 "symbol.vala"
		gtk_tree_view_column_set_attributes (self->priv->line_number_column, (GtkCellRenderer*) renderer, "text", SYMBOL_BROWSER_COL_LINE, NULL);
#line 749 "symbol.vala"
		gtk_tree_view_append_column (self->priv->tree_view, self->priv->line_number_column);
#line 751 "symbol.vala"
		gtk_tree_view_set_model (self->priv->tree_view, (GtkTreeModel*) store);
#line 754 "symbol.vala"
		g_signal_connect_object (self->priv->tree_view, "row-activated", (GCallback) _symbol_browser_on_row_activated_gtk_tree_view_row_activated, self, 0);
#line 755 "symbol.vala"
		g_signal_connect_object (self->priv->tree_view, "cursor-changed", (GCallback) _symbol_browser_on_cursor_changed_gtk_tree_view_cursor_changed, self, 0);
#line 756 "symbol.vala"
		g_signal_connect_object (self->priv->tree_view, "row-expanded", (GCallback) _symbol_browser_on_row_expanded_gtk_tree_view_row_expanded, self, 0);
#line 757 "symbol.vala"
		g_signal_connect_object (self->priv->tree_view, "row-collapsed", (GCallback) _symbol_browser_on_row_collapsed_gtk_tree_view_row_collapsed, self, 0);
#line 759 "symbol.vala"
		self->priv->status_context = gtk_statusbar_get_context_id ((GtkStatusbar*) valide_window_get_statusbar (valide_plugin_get_window ((ValidePlugin*) self)), "valide_symbol_browser");
#line 761 "symbol.vala"
		gtk_widget_set_sensitive ((GtkWidget*) self->priv->box, FALSE);
#line 763 "symbol.vala"
		g_signal_connect_object (valide_window_get_documents (valide_plugin_get_window ((ValidePlugin*) self)), "tab-removed", (GCallback) _symbol_browser_populate_symbols_valide_document_manager_tab_removed, self, 0);
#line 764 "symbol.vala"
		g_signal_connect_object (valide_window_get_documents (valide_plugin_get_window ((ValidePlugin*) self)), "tab-changed", (GCallback) _symbol_browser_populate_symbols_valide_document_manager_tab_changed, self, 0);
#line 765 "symbol.vala"
		g_signal_connect_object (valide_window_get_documents (valide_plugin_get_window ((ValidePlugin*) self)), "tab-saved", (GCallback) _symbol_browser_populate_symbols_valide_document_manager_tab_saved, self, 0);
#line 2245 "symbol.c"
		{
			char* _tmp14_;
#line 769 "symbol.vala"
			valide_utils_register_icon (_tmp14_ = g_build_filename (PIXMAPS_DIR, "plugins", "symbol-browser.png", NULL), "symbol-browser-plugin-icon", &_inner_error_);
#line 2250 "symbol.c"
			if (_inner_error_ != NULL) {
				goto __catch3_g_error;
				goto __finally3;
			}
			_g_free0 (_tmp14_);
		}
		goto __finally3;
		__catch3_g_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			{
#line 775 "symbol.vala"
				g_debug ("symbol.vala:775: %s", e->message);
#line 2266 "symbol.c"
				_g_error_free0 (e);
			}
		}
		__finally3:
		if (_inner_error_ != NULL) {
			_g_object_unref0 (store);
			_g_object_unref0 (col);
			_g_object_unref0 (scrolled);
			_g_object_unref0 (renderer);
			_g_object_unref0 (renderer_pixbuf);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
		}
#line 777 "symbol.vala"
		valide_window_add_widget (valide_plugin_get_window ((ValidePlugin*) self), (GtkWidget*) self->priv->box, "symbol-browser-plugin", _ ("Symbols"), VALIDE_WINDOW_PLACEMENT_LEFT, "symbol-browser-plugin-icon");
#line 2282 "symbol.c"
		_g_object_unref0 (store);
		_g_object_unref0 (col);
		_g_object_unref0 (scrolled);
		_g_object_unref0 (renderer);
		_g_object_unref0 (renderer_pixbuf);
	}
	return obj;
}


static void symbol_browser_class_init (SymbolBrowserClass * klass) {
	symbol_browser_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SymbolBrowserPrivate));
	G_OBJECT_CLASS (klass)->get_property = symbol_browser_get_property;
	G_OBJECT_CLASS (klass)->set_property = symbol_browser_set_property;
	G_OBJECT_CLASS (klass)->constructor = symbol_browser_constructor;
	G_OBJECT_CLASS (klass)->finalize = symbol_browser_finalize;
	g_object_class_override_property (G_OBJECT_CLASS (klass), SYMBOL_BROWSER_PATH, "path");
	g_object_class_override_property (G_OBJECT_CLASS (klass), SYMBOL_BROWSER_WINDOW, "window");
}


static void symbol_browser_valide_plugin_interface_init (ValidePluginIface * iface) {
	symbol_browser_valide_plugin_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_path = symbol_browser_real_get_path;
	iface->set_path = symbol_browser_real_set_path;
	iface->get_window = symbol_browser_real_get_window;
	iface->set_window = symbol_browser_real_set_window;
}


static void symbol_browser_instance_init (SymbolBrowser * self) {
	self->priv = SYMBOL_BROWSER_GET_PRIVATE (self);
}


static void symbol_browser_finalize (GObject* obj) {
	SymbolBrowser * self;
	self = SYMBOL_BROWSER (obj);
	{
		guint _tmp15_;
		guint _tmp16_;
#line 788 "symbol.vala"
		g_signal_handlers_disconnect_matched (valide_window_get_documents (valide_plugin_get_window ((ValidePlugin*) self)), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, (g_signal_parse_name ("tab-removed", VALIDE_TYPE_DOCUMENT_MANAGER, &_tmp15_, NULL, FALSE), _tmp15_), 0, NULL, (GCallback) _symbol_browser_populate_symbols_valide_document_manager_tab_removed, self);
#line 789 "symbol.vala"
		g_signal_handlers_disconnect_matched (valide_window_get_documents (valide_plugin_get_window ((ValidePlugin*) self)), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, (g_signal_parse_name ("tab-changed", VALIDE_TYPE_DOCUMENT_MANAGER, &_tmp16_, NULL, FALSE), _tmp16_), 0, NULL, (GCallback) _symbol_browser_populate_symbols_valide_document_manager_tab_changed, self);
#line 790 "symbol.vala"
		g_signal_connect_object (valide_window_get_documents (valide_plugin_get_window ((ValidePlugin*) self)), "tab-saved", (GCallback) _symbol_browser_populate_symbols_valide_document_manager_tab_saved, self, 0);
#line 792 "symbol.vala"
		valide_window_remove_widget (valide_plugin_get_window ((ValidePlugin*) self), (GtkWidget*) self->priv->box);
#line 2333 "symbol.c"
	}
	_g_object_unref0 (self->priv->box);
	_g_object_unref0 (self->priv->label);
	_g_object_unref0 (self->priv->model);
	_g_object_unref0 (self->priv->tree_view);
	__g_slist_free_g_free0 (self->priv->expanded_rows);
	_g_object_unref0 (self->priv->language_column);
	_g_object_unref0 (self->priv->source_file_column);
	_g_object_unref0 (self->priv->line_number_column);
	_g_hash_table_unref0 (self->priv->root_nodes);
	_g_free0 (self->priv->_path);
	_g_object_unref0 (self->priv->_window);
	G_OBJECT_CLASS (symbol_browser_parent_class)->finalize (obj);
}


GType symbol_browser_get_type (void) {
	static GType symbol_browser_type_id = 0;
	if (symbol_browser_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (SymbolBrowserClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) symbol_browser_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SymbolBrowser), 0, (GInstanceInitFunc) symbol_browser_instance_init, NULL };
		static const GInterfaceInfo valide_plugin_info = { (GInterfaceInitFunc) symbol_browser_valide_plugin_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		symbol_browser_type_id = g_type_register_static (G_TYPE_OBJECT, "SymbolBrowser", &g_define_type_info, 0);
		g_type_add_interface_static (symbol_browser_type_id, VALIDE_TYPE_PLUGIN, &valide_plugin_info);
	}
	return symbol_browser_type_id;
}


static void symbol_browser_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SymbolBrowser * self;
	self = SYMBOL_BROWSER (object);
	switch (property_id) {
		case SYMBOL_BROWSER_PATH:
		g_value_set_string (value, valide_plugin_get_path ((ValidePlugin*) self));
		break;
		case SYMBOL_BROWSER_WINDOW:
		g_value_set_object (value, valide_plugin_get_window ((ValidePlugin*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void symbol_browser_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	SymbolBrowser * self;
	self = SYMBOL_BROWSER (object);
	switch (property_id) {
		case SYMBOL_BROWSER_PATH:
		valide_plugin_set_path ((ValidePlugin*) self, g_value_get_string (value));
		break;
		case SYMBOL_BROWSER_WINDOW:
		valide_plugin_set_window ((ValidePlugin*) self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


#line 839 "symbol.vala"
GType register_plugin (void) {
#line 2398 "symbol.c"
	GType result;
	result = TYPE_SYMBOL_BROWSER;
#line 841 "symbol.vala"
	return result;
#line 2403 "symbol.c"
}


#line 844 "symbol.vala"
GtkWidget* create_configure_dialog (SymbolBrowser* _self_) {
#line 2409 "symbol.c"
	GtkWidget* result;
#line 844 "symbol.vala"
	g_return_val_if_fail (_self_ != NULL, NULL);
#line 2413 "symbol.c"
	result = symbol_browser_create_configure_dialog (_self_);
#line 846 "symbol.vala"
	return result;
#line 2417 "symbol.c"
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




