/* main.c generated by valac, the Vala compiler
 * generated from main.vala, do not modify */

/* main.vala
 *
 * Copyright (C) 2008-2009 Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <nicolas.joseph@valaide.org>
 */
/*string encoding_charset;*/
/*bool new_window_option;*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <valide-0.0.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <unique/unique.h>
#include <config.h>


#define VALIDE_TYPE_APPLICATION (valide_application_get_type ())
#define VALIDE_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_APPLICATION, ValideApplication))
#define VALIDE_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_APPLICATION, ValideApplicationClass))
#define VALIDE_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_APPLICATION))
#define VALIDE_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_APPLICATION))
#define VALIDE_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_APPLICATION, ValideApplicationClass))

typedef struct _ValideApplication ValideApplication;
typedef struct _ValideApplicationClass ValideApplicationClass;
typedef struct _ValideApplicationPrivate ValideApplicationPrivate;

#define VALIDE_APPLICATION_TYPE_ACTION (valide_application_action_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_option_context_free0(var) ((var == NULL) ? NULL : (var = (g_option_context_free (var), NULL)))
#define _unique_message_data_free0(var) ((var == NULL) ? NULL : (var = (unique_message_data_free (var), NULL)))

struct _ValideApplication {
	GObject parent_instance;
	ValideApplicationPrivate * priv;
};

struct _ValideApplicationClass {
	GObjectClass parent_class;
};

struct _ValideApplicationPrivate {
	gboolean show_version;
	gboolean new_document;
	char** file_list;
	gint file_list_length1;
	gint file_list_size;
	char* client_id;
	GHashTable* windows;
};

typedef enum  {
	VALIDE_APPLICATION_ACTION_NEW,
	VALIDE_APPLICATION_ACTION_OPEN,
	VALIDE_APPLICATION_ACTION_INVALID,
	VALIDE_APPLICATION_ACTION_ACTIVATE
} ValideApplicationAction;


extern gboolean _new_document;
gboolean _new_document = FALSE;
extern gboolean _show_version;
gboolean _show_version = FALSE;
extern char* _client_id;
char* _client_id = NULL;
extern char** _remaining_args;
extern gint _remaining_args_length1;
char** _remaining_args = NULL;
gint _remaining_args_length1 = 0;
static gint _remaining_args_size = 0;
static gpointer valide_application_parent_class = NULL;

GType valide_application_get_type (void);
#define VALIDE_APPLICATION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALIDE_TYPE_APPLICATION, ValideApplicationPrivate))
enum  {
	VALIDE_APPLICATION_DUMMY_PROPERTY
};
static GType valide_application_action_get_type (void);
static gboolean valide_application_launch_window (ValideApplication* self, ValideWindow* window, ValideApplicationAction action, char** uris, int uris_length1);
static ValideWindow* valide_application_create_new_window (ValideApplication* self, ValideApplicationAction action, char** uris, int uris_length1, GdkScreen* screen);
static void _lambda0_ (GtkObject* s, ValideApplication* self);
static void __lambda0__gtk_object_destroy (GtkObject* _sender, gpointer self);
static UniqueResponse valide_application_message (ValideApplication* self, UniqueApp* sender, gint command, UniqueMessageData* data, guint time);
static void _vala_array_add1 (char*** array, int* length, int* size, char* value);
ValideApplication* valide_application_new (char** args, int args_length1);
ValideApplication* valide_application_construct (GType object_type, char** args, int args_length1);
static UniqueResponse _valide_application_message_unique_app_message_received (UniqueApp* _sender, gint command, UniqueMessageData* message_data, guint time_, gpointer self);
gint valide_application_run (ValideApplication* self);
static void valide_application_finalize (GObject* obj);
gint _main (char** args, int args_length1);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);

static const GOptionEntry options[] = {{"client-id", '\0', 0, G_OPTION_ARG_STRING, &_client_id, N_ ("Specify session management ID"), N_ ("ID")}, {"version", 'V', 0, G_OPTION_ARG_NONE, &_show_version, N_ ("Show the application's version"), NULL}, {"new-document", '\0', 0, G_OPTION_ARG_NONE, &_new_document, N_ ("Create a new document in an existing instance of valide"), NULL}, {"", '\0', 0, G_OPTION_ARG_FILENAME_ARRAY, &_remaining_args, NULL, N_ ("[FILE...]")}, {NULL}};



static GType valide_application_action_get_type (void) {
	static GType valide_application_action_type_id = 0;
	if (G_UNLIKELY (valide_application_action_type_id == 0)) {
		static const GEnumValue values[] = {{VALIDE_APPLICATION_ACTION_NEW, "VALIDE_APPLICATION_ACTION_NEW", "new"}, {VALIDE_APPLICATION_ACTION_OPEN, "VALIDE_APPLICATION_ACTION_OPEN", "open"}, {VALIDE_APPLICATION_ACTION_INVALID, "VALIDE_APPLICATION_ACTION_INVALID", "invalid"}, {VALIDE_APPLICATION_ACTION_ACTIVATE, "VALIDE_APPLICATION_ACTION_ACTIVATE", "activate"}, {0, NULL, NULL}};
		valide_application_action_type_id = g_enum_register_static ("ValideApplicationAction", values);
	}
	return valide_application_action_type_id;
}


#line 56 "main.vala"
static gboolean valide_application_launch_window (ValideApplication* self, ValideWindow* window, ValideApplicationAction action, char** uris, int uris_length1) {
#line 136 "main.c"
	gboolean result;
	GError * _inner_error_;
	gboolean opened;
#line 56 "main.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 56 "main.vala"
	g_return_val_if_fail (window != NULL, FALSE);
#line 144 "main.c"
	_inner_error_ = NULL;
#line 58 "main.vala"
	opened = FALSE;
#line 60 "main.vala"
	switch (action) {
#line 150 "main.c"
		case VALIDE_APPLICATION_ACTION_ACTIVATE:
		{
#line 63 "main.vala"
			gtk_window_present ((GtkWindow*) window);
#line 64 "main.vala"
			break;
#line 157 "main.c"
		}
		case VALIDE_APPLICATION_ACTION_NEW:
		{
			ValideiDocument* _tmp0_;
#line 66 "main.vala"
			_tmp0_ = valide_document_manager_create (valide_window_get_documents (window), NULL, &_inner_error_);
#line 164 "main.c"
			if (_inner_error_ != NULL) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return FALSE;
			}
			_g_object_unref0 (_tmp0_);
#line 67 "main.vala"
			opened = TRUE;
#line 68 "main.vala"
			break;
#line 175 "main.c"
		}
		case VALIDE_APPLICATION_ACTION_OPEN:
		{
#line 70 "main.vala"
			if (uris != NULL) {
#line 181 "main.c"
				{
					gint i;
#line 72 "main.vala"
					i = 0;
#line 186 "main.c"
					{
						gboolean _tmp1_;
#line 72 "main.vala"
						_tmp1_ = TRUE;
#line 72 "main.vala"
						while (TRUE) {
#line 72 "main.vala"
							if (!_tmp1_) {
#line 72 "main.vala"
								i++;
#line 197 "main.c"
							}
#line 72 "main.vala"
							_tmp1_ = FALSE;
#line 72 "main.vala"
							if (!(uris[i] != NULL)) {
#line 72 "main.vala"
								break;
#line 205 "main.c"
							}
							{
#line 76 "main.vala"
								if (valide_project_manager_accept_file (valide_window_get_projects (window), uris[i])) {
#line 78 "main.vala"
									valide_project_manager_open (valide_window_get_projects (window), uris[i], &_inner_error_);
#line 212 "main.c"
									if (_inner_error_ != NULL) {
										goto __catch0_g_error;
										goto __finally0;
									}
								} else {
									ValideiDocument* _tmp2_;
#line 82 "main.vala"
									_tmp2_ = valide_document_manager_create (valide_window_get_documents (window), uris[i], &_inner_error_);
#line 221 "main.c"
									if (_inner_error_ != NULL) {
										goto __catch0_g_error;
										goto __finally0;
									}
									_g_object_unref0 (_tmp2_);
								}
#line 84 "main.vala"
								opened = TRUE;
#line 230 "main.c"
							}
							goto __finally0;
							__catch0_g_error:
							{
								GError * e;
								e = _inner_error_;
								_inner_error_ = NULL;
								{
#line 88 "main.vala"
									g_debug ("main.vala:88: %s", e->message);
#line 241 "main.c"
									_g_error_free0 (e);
								}
							}
							__finally0:
							if (_inner_error_ != NULL) {
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
								g_clear_error (&_inner_error_);
								return FALSE;
							}
						}
					}
				}
			}
#line 92 "main.vala"
			break;
#line 257 "main.c"
		}
	}
	result = opened;
#line 94 "main.vala"
	return result;
#line 263 "main.c"
}


#line 97 "main.vala"
static ValideWindow* valide_application_create_new_window (ValideApplication* self, ValideApplicationAction action, char** uris, int uris_length1, GdkScreen* screen) {
#line 269 "main.c"
	ValideWindow* result;
	gboolean opened = FALSE;
	ValideWindow* window;
	ValideWindow* _tmp0_;
#line 97 "main.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 276 "main.c"
	window = NULL;
#line 103 "main.vala"
	window = (_tmp0_ = g_object_ref_sink (valide_window_new ()), _g_object_unref0 (window), _tmp0_);
#line 104 "main.vala"
	if (screen != NULL) {
#line 106 "main.vala"
		gtk_window_set_screen ((GtkWindow*) window, screen);
#line 284 "main.c"
	}
#line 108 "main.vala"
	opened = valide_application_launch_window (self, window, action, uris, uris_length1);
#line 109 "main.vala"
	valide_window_run (window);
#line 110 "main.vala"
	if (opened) {
#line 112 "main.vala"
		valide_start_page_iconify (valide_window_get_start_page (window));
#line 294 "main.c"
	}
	result = window;
#line 114 "main.vala"
	return result;
#line 299 "main.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _lambda0_ (GtkObject* s, ValideApplication* self) {
	char* ws_s;
	char* _tmp1_;
	GtkObject* _tmp0_;
	g_return_if_fail (s != NULL);
	ws_s = NULL;
#line 159 "main.vala"
	ws_s = (_tmp1_ = g_strdup_printf ("%u", (_tmp0_ = s, VALIDE_IS_WINDOW (_tmp0_) ? ((ValideWindow*) _tmp0_) : NULL)->workspace), _g_free0 (ws_s), _tmp1_);
#line 160 "main.vala"
	g_hash_table_remove (self->priv->windows, ws_s);
#line 161 "main.vala"
	if (g_hash_table_size (self->priv->windows) == 0) {
#line 163 "main.vala"
		gtk_main_quit ();
#line 322 "main.c"
	}
	_g_free0 (ws_s);
}


static void __lambda0__gtk_object_destroy (GtkObject* _sender, gpointer self) {
	_lambda0_ (_sender, self);
}


#line 118 "main.vala"
static UniqueResponse valide_application_message (ValideApplication* self, UniqueApp* sender, gint command, UniqueMessageData* data, guint time) {
#line 335 "main.c"
	UniqueResponse result;
	char* ws;
	ValideApplicationAction action = 0;
	ValideWindow* window;
	guint workspace = 0U;
	char** _tmp0_;
	gint uris_size;
	gint uris_length1;
	char** uris;
	char* _tmp2_;
	ValideWindow* _tmp3_;
#line 118 "main.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 118 "main.vala"
	g_return_val_if_fail (sender != NULL, 0);
#line 118 "main.vala"
	g_return_val_if_fail (data != NULL, 0);
#line 353 "main.c"
	ws = NULL;
	window = NULL;
	uris = (_tmp0_ = NULL, uris_length1 = 0, uris_size = uris_length1, _tmp0_);
#line 127 "main.vala"
	switch (command) {
#line 359 "main.c"
		case UNIQUE_OPEN:
		{
			char** _tmp1_;
#line 130 "main.vala"
			action = VALIDE_APPLICATION_ACTION_OPEN;
#line 131 "main.vala"
			uris = (_tmp1_ = unique_message_data_get_uris (data), uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL), uris_length1 = -1, uris_size = uris_length1, _tmp1_);
#line 132 "main.vala"
			break;
#line 369 "main.c"
		}
		case UNIQUE_NEW:
		{
#line 134 "main.vala"
			action = VALIDE_APPLICATION_ACTION_NEW;
#line 135 "main.vala"
			break;
#line 377 "main.c"
		}
		case UNIQUE_ACTIVATE:
		{
#line 137 "main.vala"
			action = VALIDE_APPLICATION_ACTION_ACTIVATE;
#line 138 "main.vala"
			break;
#line 385 "main.c"
		}
		default:
		{
#line 141 "main.vala"
			action = VALIDE_APPLICATION_ACTION_INVALID;
#line 142 "main.vala"
			break;
#line 393 "main.c"
		}
	}
#line 145 "main.vala"
	workspace = unique_message_data_get_workspace (data);
#line 147 "main.vala"
	if (workspace == 0) {
#line 149 "main.vala"
		workspace = unique_backend_get_workspace (unique_backend_create ());
#line 402 "main.c"
	}
#line 151 "main.vala"
	ws = (_tmp2_ = g_strdup_printf ("%u", workspace), _g_free0 (ws), _tmp2_);
#line 152 "main.vala"
	window = (_tmp3_ = _g_object_ref0 ((ValideWindow*) g_hash_table_lookup (self->priv->windows, ws)), _g_object_unref0 (window), _tmp3_);
#line 153 "main.vala"
	if (window == NULL) {
#line 410 "main.c"
		ValideWindow* _tmp4_;
#line 155 "main.vala"
		window = (_tmp4_ = valide_application_create_new_window (self, action, uris, uris_length1, unique_message_data_get_screen (data)), _g_object_unref0 (window), _tmp4_);
#line 156 "main.vala"
		g_signal_connect_object ((GtkObject*) window, "destroy", (GCallback) __lambda0__gtk_object_destroy, self, 0);
#line 166 "main.vala"
		g_hash_table_insert (self->priv->windows, g_strdup (ws), _g_object_ref0 (window));
#line 418 "main.c"
	}
#line 168 "main.vala"
	valide_application_launch_window (self, window, action, uris, uris_length1);
#line 422 "main.c"
	result = UNIQUE_RESPONSE_OK;
	_g_free0 (ws);
	_g_object_unref0 (window);
	uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
#line 169 "main.vala"
	return result;
#line 429 "main.c"
}


static void _vala_array_add1 (char*** array, int* length, int* size, char* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (char*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


#line 173 "main.vala"
ValideApplication* valide_application_construct (GType object_type, char** args, int args_length1) {
#line 445 "main.c"
	GError * _inner_error_;
	ValideApplication * self;
	GOptionContext* context;
	GHashTable* _tmp0_;
	GOptionContext* _tmp1_;
	_inner_error_ = NULL;
#line 173 "main.vala"
	self = (ValideApplication*) g_object_new (object_type, NULL);
#line 454 "main.c"
	context = NULL;
#line 177 "main.vala"
	gtk_init (&args_length1, &args);
#line 178 "main.vala"
	bindtextdomain (GETTEXT_PACKAGE, LOCALE_DIR);
#line 179 "main.vala"
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
#line 181 "main.vala"
	self->priv->windows = (_tmp0_ = g_hash_table_new (g_str_hash, g_str_equal), _g_hash_table_unref0 (self->priv->windows), _tmp0_);
#line 184 "main.vala"
	context = (_tmp1_ = g_option_context_new (_ ("- Integrated Development Environment for Vala")), _g_option_context_free0 (context), _tmp1_);
#line 185 "main.vala"
	g_option_context_add_main_entries (context, options, GETTEXT_PACKAGE);
#line 186 "main.vala"
	g_option_context_add_group (context, gtk_get_option_group (FALSE));
#line 470 "main.c"
	{
#line 190 "main.vala"
		g_option_context_parse (context, &args_length1, &args, &_inner_error_);
#line 474 "main.c"
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_OPTION_ERROR) {
				goto __catch1_g_option_error;
			}
			goto __finally1;
		}
#line 191 "main.vala"
		if (_remaining_args != NULL) {
#line 483 "main.c"
			{
				gint i;
#line 193 "main.vala"
				i = 0;
#line 488 "main.c"
				{
					gboolean _tmp2_;
#line 193 "main.vala"
					_tmp2_ = TRUE;
#line 193 "main.vala"
					while (TRUE) {
#line 193 "main.vala"
						if (!_tmp2_) {
#line 193 "main.vala"
							i++;
#line 499 "main.c"
						}
#line 193 "main.vala"
						_tmp2_ = FALSE;
#line 193 "main.vala"
						if (!(_remaining_args[i] != NULL)) {
#line 193 "main.vala"
							break;
#line 507 "main.c"
						}
#line 195 "main.vala"
						_vala_array_add1 (&self->priv->file_list, &self->priv->file_list_length1, &self->priv->file_list_size, g_strdup (_remaining_args[i]));
#line 511 "main.c"
					}
				}
			}
		}
#line 198 "main.vala"
		self->priv->show_version = _show_version;
#line 199 "main.vala"
		self->priv->new_document = _new_document;
#line 200 "main.vala"
		if (_client_id != NULL) {
#line 522 "main.c"
			char* _tmp3_;
#line 202 "main.vala"
			self->priv->client_id = (_tmp3_ = g_strdup (_client_id), _g_free0 (self->priv->client_id), _tmp3_);
#line 526 "main.c"
		} else {
			char* _tmp4_;
#line 206 "main.vala"
			self->priv->client_id = (_tmp4_ = g_strdup ("org.valide.valaide"), _g_free0 (self->priv->client_id), _tmp4_);
#line 531 "main.c"
		}
	}
	goto __finally1;
	__catch1_g_option_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
#line 211 "main.vala"
			g_print (_ ("%s\nRun '%s --help' to see a full list of available command line options.\n"), e->message, args[0]);
#line 543 "main.c"
			_g_error_free0 (e);
		}
	}
	__finally1:
	if (_inner_error_ != NULL) {
		_g_option_context_free0 (context);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_g_option_context_free0 (context);
	return self;
}


#line 173 "main.vala"
ValideApplication* valide_application_new (char** args, int args_length1) {
#line 173 "main.vala"
	return valide_application_construct (VALIDE_TYPE_APPLICATION, args, args_length1);
#line 563 "main.c"
}


#line 118 "main.vala"
static UniqueResponse _valide_application_message_unique_app_message_received (UniqueApp* _sender, gint command, UniqueMessageData* message_data, guint time_, gpointer self) {
#line 569 "main.c"
	return valide_application_message (self, _sender, command, message_data, time_);
}


#line 250 "main.vala"
gint valide_application_run (ValideApplication* self) {
#line 576 "main.c"
	gint result;
	UniqueApp* app;
#line 250 "main.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 581 "main.c"
	app = NULL;
#line 254 "main.vala"
	if (self->priv->show_version) {
#line 256 "main.vala"
		g_print ("%s - Version %s\n", g_get_application_name (), VERSION);
#line 587 "main.c"
	} else {
		UniqueCommand command = 0;
		UniqueMessageData* data;
		UniqueMessageData* _tmp0_;
		UniqueApp* _tmp1_;
		gboolean _tmp2_;
		data = NULL;
#line 264 "main.vala"
		data = (_tmp0_ = unique_message_data_new (), _unique_message_data_free0 (data), _tmp0_);
#line 265 "main.vala"
		if (self->priv->new_document) {
#line 267 "main.vala"
			command = UNIQUE_NEW;
#line 601 "main.c"
		} else {
#line 269 "main.vala"
			if (self->priv->file_list != NULL) {
#line 271 "main.vala"
				command = UNIQUE_OPEN;
#line 272 "main.vala"
				unique_message_data_set_uris (data, self->priv->file_list);
#line 609 "main.c"
			} else {
#line 276 "main.vala"
				command = UNIQUE_ACTIVATE;
#line 613 "main.c"
			}
		}
#line 279 "main.vala"
		app = (_tmp1_ = unique_app_new (self->priv->client_id, NULL), _g_object_unref0 (app), _tmp1_);
#line 280 "main.vala"
		if ((g_object_get (app, "is-running", &_tmp2_, NULL), _tmp2_)) {
#line 282 "main.vala"
			unique_app_send_message (app, (gint) command, data);
#line 283 "main.vala"
			gdk_notify_startup_complete ();
#line 624 "main.c"
		} else {
#line 287 "main.vala"
			valide_application_message (self, app, (gint) command, data, (guint) 0);
#line 288 "main.vala"
			g_signal_connect_object (app, "message-received", (GCallback) _valide_application_message_unique_app_message_received, self, 0);
#line 289 "main.vala"
			gtk_main ();
#line 632 "main.c"
		}
		_unique_message_data_free0 (data);
	}
	result = 0;
	_g_object_unref0 (app);
#line 292 "main.vala"
	return result;
#line 640 "main.c"
}


static void valide_application_class_init (ValideApplicationClass * klass) {
	valide_application_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValideApplicationPrivate));
	G_OBJECT_CLASS (klass)->finalize = valide_application_finalize;
}


static void valide_application_instance_init (ValideApplication * self) {
	self->priv = VALIDE_APPLICATION_GET_PRIVATE (self);
}


static void valide_application_finalize (GObject* obj) {
	ValideApplication * self;
	self = VALIDE_APPLICATION (obj);
	self->priv->file_list = (_vala_array_free (self->priv->file_list, self->priv->file_list_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (self->priv->client_id);
	_g_hash_table_unref0 (self->priv->windows);
	G_OBJECT_CLASS (valide_application_parent_class)->finalize (obj);
}


GType valide_application_get_type (void) {
	static GType valide_application_type_id = 0;
	if (valide_application_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValideApplicationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valide_application_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValideApplication), 0, (GInstanceInitFunc) valide_application_instance_init, NULL };
		valide_application_type_id = g_type_register_static (G_TYPE_OBJECT, "ValideApplication", &g_define_type_info, 0);
	}
	return valide_application_type_id;
}


#line 297 "main.vala"
gint _main (char** args, int args_length1) {
#line 678 "main.c"
	gint result;
	ValideApplication* _tmp0_;
	gint _tmp1_;
	result = (_tmp1_ = valide_application_run (_tmp0_ = valide_application_new (args, args_length1)), _g_object_unref0 (_tmp0_), _tmp1_);
#line 299 "main.vala"
	return result;
#line 685 "main.c"
}


#line 297 "main.vala"
int main (int argc, char ** argv) {
#line 297 "main.vala"
	g_type_init ();
#line 297 "main.vala"
	return _main (argv, argc);
#line 695 "main.c"
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}




